/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - {fBZNV - [eBeB - Win32 EBhEvV[W
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief {fBZNV: [eBeB: Win32 EBhEvV[W
 *
 * Win32 ̃EBhEvV[WɑΉNX̒`s܂B
 *
 * @author ABE Shigeru
 * @date 2003/12/24
 */
#ifndef _BODY_UTILITY_WINDOWPROCEDURE_H_20031224Wed_221805_
#define _BODY_UTILITY_WINDOWPROCEDURE_H_20031224Wed_221805_


/*   NX`
------------------------------------------------------------------- */
namespace BK {
namespace Win32 {


/// EBhEvV[W
/**
 * Windows bZ[WfBXpb`邽߂̃EBhEvV[W\܂B
 */
class WindowProcedure
{
protected:
    
    /// WM_CREATE: EBhE
    /**
     * WM_CREATE bZ[W܂B
     * ̃bZ[ẂAEBhẼNCAg̈悪ƂɃ|Xg܂B
     * NCAg̈悪Ƃ WM_NCCREATE łB
     *
     * @retval true ɐ
     * @retval false Ɏs (EBhE͔j)
     */
    virtual bool on_create ( CREATESTRUCT & cs )
    {
        return true;
    }
    
    /// WM_CLOSE: EBhE
    /**
     * WM_CLOSE bZ[W܂B
     * ̃bZ[ẂAEBhEƂɃ|Xg܂B
     *
     * @retval true EBhE (DestroyWindow() s)
     * @retval false ςȂ
     */
    virtual bool on_close ( void )
    {
        return true;
    }
    
    /// WM_QUIT: AvP[V̏I
    /**
     * WM_QUIT bZ[W܂B
     * ftHgł system_exit O𑗏o܂B
     */
    virtual void on_quit ( void );
    
    /// sȃbZ[W
    virtual LRESULT on_windows_message ( HWND wnd, UINT msg, WPARAM wparam, LPARAM lparam )
    {
        return DefWindowProc( wnd, msg, wparam, lparam );
    }
    
public:
    /// Windows bZ[W̃fBXpb`s
    LRESULT dispatch_message ( HWND wnd, UINT msg, WPARAM wparam, LPARAM lparam );
};


} /* namespace Win32 */
} /* namespace BK */


#endif /* _BODY_UTILITY_WINDOWPROCEDURE_H_20031224Wed_221805_ */
