/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - {fBZNV - O`
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief {fBZNV: O`
 *
 * ˑȗO`܂B
 *
 * @author ABE Shigeru
 * @date 2003/08/16
 */
#ifndef _BODY_EXCEPTION_H_20030816Sat_114940_
#define _BODY_EXCEPTION_H_20030816Sat_114940_


/*   CN[h
------------------------------------------------------------------- */
#include "schema/main.h"
#include <windows.h>
#include <objbase.h>


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// Windows G[\O
/**
 * Windows ŔG[\߂̗OłB
 * G[R[hۗL܂B
 */
class windows_exception : public runtime_exception
{
public:
    const char * get_type ( void ) const
    {
        return "windows_exception";
    }
    
private:
    /// Windows ̃G[R[h
    DWORD  err_code;
    
protected:
    windows_exception ( void )
    {
    }
    
public:
    /// RXgN^
    /**
     * OIuWFNg𐶐܂B
     * ɁAWindows API  GetLastError() gāAG[R[h擾܂B
     *
     * @param format [in] G[bZ[W
     */
    windows_exception ( const char * format, ... );
    
    /// G[R[h𓾂
    /**
     * Windows ̃G[R[h擾܂B
     *
     * @return G[R[h
     */
    DWORD get_error_code ( void ) const
    {
        return err_code;
    }
};


/// DirectX G[\O
/**
 * DirectX ŔG[\߂̗OłB
 * G[R[hۗL܂B
 */
class directx_exception : public runtime_exception
{
public:
    const char * get_type ( void ) const
    {
        return "directx_exception";
    }
    
private:
    HRESULT err_code;
    
protected:
    directx_exception ( void )
    {
    }
    
public:
    /// RXgN^
    /**
     * @param code [in] DirectX G[R[h
     * @param format [in] G[bZ[W
     */
    directx_exception ( HRESULT code, const char * format, ... );
    
    /// G[R[h𓾂
    /**
     * G[R[h擾܂B
     *
     * @return G[R[h
     */
    HRESULT get_error_code ( void ) const
    {
        return err_code;
    }
};


} /* namespace BK */


#endif /* _BODY_EXCEPTION_H_20030816Sat_114940_ */
