/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - {fBZNV - OtBbN - C[ - tBC[
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief {fBZNV: OtBbN: C[: tBC[
 *
 * tBC[̎`܂B
 *
 * @author ABE Shigeru
 * @date 2003/12/14
 */
#ifndef _BODY_GRAPHIC_LAYER_DX9FILLLAYER_H_20031214Sun_222539_
#define _BODY_GRAPHIC_LAYER_DX9FILLLAYER_H_20031214Sun_222539_


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// DirectX gptBC[
class Dx9FillLayer : public FillLayer
{
public:
    
    /// eNX
    typedef FillLayer parent_t;
    
public: /* RubyObject C^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    //virtual void ruby_gc_mark ( void );
    
    /// Kx[WRNg̃ObZ[Wo̓tO擾
    //virtual bool is_ruby_gc_log_enabled ( void ) const;
    
    /// Ruby inspect \bh
    //virtual char * ruby_inspect ( char * buf, unsigned int cap ) const;
    
    /// Ruby IuWFNgɂ郉bsOCxg
    //virtual void on_ruby_wrap ( void );
    
public: /* Layer C^[tFCX */
    
    /// `Cxg
    virtual void execute ( GraphicDevice * dev );
    
public: /* ProjectionLayer C^[tFCX */
    
    /// ]̈̓o^
    virtual ProjectionInfo * register_projection ( void );
    
    /// ]̈̍폜
    virtual void delete_projection ( ProjectionInfo * ptr );
    
    /// o^Ă]̈̐擾
    virtual unsigned int count_projection ( void ) const;
    
public:
    
    /// C[p̒_^
    typedef DirectX::TLVertex vertex_t;
    
    /// C[WC[p̓]̈
    class info_t : public DirectX::TextureProjectionInfo < vertex_t >
    {
    public: /* RubyObject C^[tFCX */
        
        /// Ruby Kx[WRNgp}[N
        //virtual void ruby_gc_mark ( void );
        
        /// Kx[WRNg̃ObZ[Wo̓tO擾
        //virtual bool is_ruby_gc_log_enabled ( void ) const;
        
        /// Ruby inspect \bh
        //virtual char * ruby_inspect ( char * buf, unsigned int cap ) const;
        
        /// Ruby IuWFNgɂ郉bsOCxg
        //virtual void on_ruby_wrap ( void );
        
    public: /* ProjectionInfo C^[tFCX */
        
        /// ]F̐ݒ
        //virtual void set_color ( const AlphaColor * c );
        
    public: /* TextureProjectionInfo C^[tFCX */
        
        /// KvȒ_̎擾
        virtual unsigned int count_vertex ( void ) const
        {
            return 6;
        }
        
        /// _f[^̏
        virtual unsigned int initialize_vertex ( vertex_t * vbuf );
        
    };
    
    /// Xg^
    typedef DirectX::ProjectionVertexBuffer < vertex_t, info_t > list_t;
    
private:
    
    /// ]̈̃Xg
    list_t obj_list;
    
public:
    
    /// RXgN^
    Dx9FillLayer ( void );
    
    /// fXgN^
    virtual ~Dx9FillLayer ();
    
};


} /* namespace BK */



#endif /* _BODY_GRAPHIC_LAYER_DX9FILLLAYER_H_20031214Sun_222539_ */
