/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - {fBZNV - OtBbN - sN`[
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief {fBZNV: OtBbN: sN`[
 *
 * sN`[̎NX`܂B
 *
 * @author ABE Shigeru
 * @date 2003/12/17
 */
#ifndef _BODY_GRAPHIC_DX9SURFACE_H_20031217Wed_204037_
#define _BODY_GRAPHIC_DX9SURFACE_H_20031217Wed_204037_


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// sN`IuWFNg
class Dx9Surface : public Picture
{
public: /* Bitmap C^[tFCX */
    
    /// ̃OtBbNC[Ŵ܂ܓ]
    virtual void blit ( Point2 const & dest, Bitmap & src, Rect2 const & area );
    
    /// ANZXp̃LoX擾
    virtual Canvas * create_canvas ( Rect2 const * area = NULL );
    
    /// OtBbNC[W̑傫擾
    virtual Size2 get_size ( void );
    
    /// IuWFNg̎擾
    virtual std::string inspect ( void ) const;
    
    /// IuWFNg݂ꏊ擾
    virtual pool_t get_pool_info ( void ) const;
    
    /// IuWFNg̃sNZtH[}bg擾
    virtual Canvas::pixel_t get_pixel_info ( void ) const;
    
    /// OtBbNC[Wt@Cɏo͂
    virtual void write_to_file ( const char * filename );
    
private:
    
    /// T[tFXIuWFNg
    IDirect3DSurface9 * const ptr_surface;
    
    /// v[ꏊ
    D3DPOOL num_pool;
    
    /// sNZtH[}bg
    D3DFORMAT num_format;
    
private:
    
    /// 
    /** RXgN^̋ʃR[hłB */
    void init ( void );
    
public:
    
    /// RXgN^
    /**
     * w肳ꂽp[^ŃT[tFX𐶐܂B
     *
     * vram ^̏ꍇAT[tFX D3DPOOL_DEFAULT ō쐬܂B
     * vram ȔꍇAT[tFX D3DPOOL_SYSTEMMEM ō쐬܂B
     *
     * @param vram [in] T[tFX VRAM ɔzuꍇ true
     */
    Dx9Surface ( Size2 const & size, D3DFORMAT format, bool vram );
    
    /// RXgN^
    /**
     * łɍ\zꂽT[tFXgăIuWFNg\zꍇłB
     * ̃RXgN^ł́AQƃJE^𑝉܂B
     */
    Dx9Surface ( IDirect3DSurface9 * surface );
    
    /// fXgN^
    /**
     * T[tFX̎QƃJE^܂B
     */
    virtual ~Dx9Surface ();
    
    /// T[tFXC^[tFCX擾
    /**
     * \z͕K NULL ɂȂ܂B
     */
    IDirect3DSurface9 * get_interface ( void )
    {
        return ptr_surface;
    }
    
    /// T[tFXC^[tFCX擾
    /**
     * \z͕K NULL ɂȂ܂B
     */
    IDirect3DSurface9 * get_d3d_surface ( void )
    {
        return ptr_surface;
    }
    
    /// v[ꏊ擾
    D3DPOOL get_d3d_pool ( void ) const
    {
        return num_pool;
    }
    
    /// sNZtH[}bg擾
    D3DFORMAT get_d3d_format ( void ) const
    {
        return num_format;
    }
    
    /// T[tFX̃bNs
    /**
     * IDirect3DSurface9::LockRect ƓlłB
     *
     * @return bN̈̏
     * @exception directx_exception bNɎs
     */
    D3DLOCKED_RECT lock_surface ( RECT * r );
    
    /// T[tFX̃AbNs
    /**
     * IDirect3DSurface9::UnlockRect ƓlłB
     *
     * @exception directx_exception AbNɎs
     */
    void unlock_surface ( void );
    
};


} /* namespace BK */


#endif /* _BODY_GRAPHIC_DX9SURFACE_H_20031217Wed_204037_ */
