/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - {fBZNV - OtBbN - sN`[f[^
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief {fBZNV: OtBbN: sN`[f[^
 *
 * sN`[f[^̎NX`܂B
 *
 * @author ABE Shigeru
 * @date 2003/12/17
 */
#ifndef _BODY_GRAPHIC_DX9SURFACEDATA_H_20031217Wed_204330_
#define _BODY_GRAPHIC_DX9SURFACEDATA_H_20031217Wed_204330_


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// sN`f[^IuWFNg
class Dx9SurfaceData : public PictureData
{
public: /* Bitmap C^[tFCX */
    
    /// ̃OtBbNC[Ŵ܂ܓ]
    virtual void blit ( Point2 const & dest, Bitmap & src, Rect2 const & area );
    
    /// ANZXp̃LoX擾
    virtual Canvas * create_canvas ( Rect2 const * area = NULL );
    
    /// OtBbNC[W̑傫擾
    virtual Size2 get_size ( void );
    
    /// IuWFNg̎擾
    virtual std::string inspect ( void ) const;
    
    /// IuWFNg݂ꏊ擾
    virtual pool_t get_pool_info ( void ) const;
    
    /// IuWFNg̃sNZtH[}bg擾
    virtual Canvas::pixel_t get_pixel_info ( void ) const;
    
    /// OtBbNC[Wt@Cɏo͂
    virtual void write_to_file ( const char * filename );
    
private:
    
    /// T[tFXf[^
    Dx9Surface * const ptr_surface;
    
public:
    
    /// RXgN^
    /**
     * KCɍ쐬AsNZtH[}bg A8R8G8B8 ɂȂ܂B
     */
    Dx9SurfaceData ( Size2 const & size );
    
    /// RXgN^
    /**
     * ݒ肷T[tFX̓CɔzuAsNZtH[}bg A8R8G8B8 łȂ΂Ȃ܂B
     * `FbN͍sȂ̂ŁA\ɋCKv܂B
     */
    Dx9SurfaceData ( IDirect3DSurface9 * surface );
    
    /// fXgN^
    /**
     * T[tFX̎QƃJE^܂B
     */
    virtual ~Dx9SurfaceData ();
    
    /// gpĂT[tFX擾
    Dx9Surface * get_surface ( void )
    {
        return ptr_surface;
    }
    
};


} /* namespace BK */


#endif /* _BODY_GRAPHIC_DX9SURFACEDATA_H_20031217Wed_204330_ */
