/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - {fBZNV - OtBbN - C[W
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief {fBZNV: OtBbN: C[W
 *
 * C[W̎NX`܂B
 *
 * @author ABE Shigeru
 * @date 2003/12/17
 */
#ifndef _BODY_GRAPHIC_DX9TEXTURE_H_20031217Wed_204502_
#define _BODY_GRAPHIC_DX9TEXTURE_H_20031217Wed_204502_


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// C[WIuWFNg
class Dx9Texture : public Image
{
public: /* Bitmap C^[tFCX */
    
    /// ̃OtBbNC[Ŵ܂ܓ]
    virtual void blit ( Point2 const & dest, Bitmap & src, Rect2 const & area );
    
    /// ANZXp̃LoX擾
    virtual Canvas * create_canvas ( Rect2 const * area = NULL );
    
    /// OtBbNC[W̑傫擾
    virtual Size2 get_size ( void );
    
    /// IuWFNg̎擾
    virtual std::string inspect ( void ) const;
    
    /// IuWFNg݂ꏊ擾
    virtual pool_t get_pool_info ( void ) const;
    
    /// IuWFNg̃sNZtH[}bg擾
    virtual Canvas::pixel_t get_pixel_info ( void ) const;
    
    /// OtBbNC[Wt@Cɏo͂
    virtual void write_to_file ( const char * filename );
    
private:
    
    /// eNX`IuWFNg
    IDirect3DTexture9 * const ptr_texture;
    
    /// x 0 T[tFXIuWFNg
    Dx9Surface * ptr_surface;
    
    /// eNX`̃v[ꏊ
    D3DPOOL num_pool;
    
    /// eNX`̃sNZtH[}bg
    D3DFORMAT num_format;
    
private:
    
    /// 
    /** RXgN^̋ʃR[hłB */
    void init ( void );
    
public:
    
    /// RXgN^
    /**
     * w肳ꂽp[^ŃeNX`𐶐܂B
     *
     * vram ^̏ꍇAT[tFX D3DPOOL_MANAGED ō쐬܂B
     * vram ȔꍇAT[tFX D3DPOOL_SYSTEMMEM ō쐬܂B
     *
     * C̃eNX`obt@쐬Ƃ̂ vram  false ɂ܂B
     *
     * @param vram [in] eNX` VRAM ɔzuꍇ true
     */
    Dx9Texture ( Size2 const & size, D3DFORMAT format, bool vram );
    
    /// RXgN^
    /**
     * łɍ\zꂽeNX`găIuWFNg\zꍇłB
     * ̃RXgN^ł́AQƃJE^𑝉܂B
     */
    Dx9Texture ( IDirect3DTexture9 * texture );
    
    /// fXgN^
    /**
     * eNX`̎QƃJE^܂B
     */
    ~Dx9Texture ();
    
    /// eNX`C^[tFCX擾
    /**
     * \z͕K NULL ɂȂ܂B
     */
    IDirect3DTexture9 * get_interface ( void )
    {
        return ptr_texture;
    }
    
    /// T[tFXC^[tFCX擾
    /**
     * x 0 eNX`̃T[tFX擾܂B
     */
    IDirect3DSurface9 * get_d3d_surface ( void )
    {
        return ptr_surface->get_interface();
    }
    
    /// v[ꏊ擾
    D3DPOOL get_d3d_pool ( void ) const
    {
        return num_pool;
    }
    
    /// sNZtH[}bg擾
    D3DFORMAT get_d3d_format ( void ) const
    {
        return num_format;
    }
    
    /// eNX`̃bNs
    /**
     * x 0 T[tFX̃bNs܂B
     *
     * @return bN̈̏
     * @exception directx_exception bNɎs
     */
    D3DLOCKED_RECT lock_surface ( RECT * r );
    
    /// eNX`̃AbNs
    /**
     * x 0 T[tFX̃AbNs܂B
     *
     * @exception directx_exception AbNɎs
     */
    void unlock_surface ( void );
    
};


} /* namespace BK */


#endif /* _BODY_GRAPHIC_DX9TEXTURE_H_20031217Wed_204502_ */
