/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - {fBZNV - OtBbN - ]̈obt@
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief {fBZNV: OtBbN: ]̈obt@
 *
 * ]̈̃obt@NX`܂B
 *
 * @author ABE Shigeru
 * @date 2003/12/19
 */
#ifndef _BODY_GRAPHIC_PROJECTIONINFOBUFFER_H_20031219Fri_144838_
#define _BODY_GRAPHIC_PROJECTIONINFOBUFFER_H_20031219Fri_144838_


/*   NX`
------------------------------------------------------------------- */
namespace BK {
namespace Win32 {


/// ]̈惌C[p̒_obt@
/**
 * ]̈gp郌C[̃ReiNXłB
 */
template < typename info_t >
class ProjectionInfoBuffer
{
public:
    
    /// ]̈̃Xg^
    typedef std::vector < info_t * > list_t;
    
private:
    
    /// ]̈̃Xg
    OnOffObjectArray < info_t > ary_info;
    
    /// ]̈̃Xg ([LO)
    list_t ary_sorted_info;
    
    /// IuWFNggp\ł邩𔻕ʂ֐IuWFNg
    class is_active_t
    {
    public:
        bool operator () ( const info_t & inf ) const
        {
            return !inf.is_empty();
        }
    };
    
    /// Z \[gZq
    class Z_Less
    {
    public:
        bool operator () ( const info_t * const & p1, const info_t * const & p2 ) const
        {
            return p1->get_z() > p2->get_z();
        }
    };
    
public:
    
    /// RXgN^
    /**
     * @param infotcap [in] ]̈̏obt@TCY
     * @param vertexcap [in] _f[^̏obt@TCY
     */
    ProjectionInfoBuffer ( unsigned int infocap )
            : ary_info (infocap)
    {
    }
    
    /// fXgN^
    virtual ~ProjectionInfoBuffer ()
    {
    }
    
    /// ]̈̒ǉ
    info_t * add ( info_t & info )
    {
        return ary_info.add( info );
    }
    
    /// ]̈̍폜
    /**
     * @retval true 폜ɐ
     * @retval false w肳ꂽf[^͌Ȃ
     */
    bool erase ( info_t & info )
    {
        return ary_info.erase( info );
    }
    
    /// o^Ă]̈̐擾
    unsigned int size ( void ) const
    {
        return ary_info.size();
    }
    
    /// Ruby Kx[WRN^p}[N
    virtual void ruby_gc_mark ( void )
    {
        ary_info.for_each( RubyObjectMarker() );
    }
    
    /// ]̈̃\[g
    /**
     * ]̈ Z Wɂă\[g܂B
     *
     * @return \[gς݂̓]̈惊Xg
     */
    virtual const list_t & execute ( void )
    {
        ary_info.sweep( ary_sorted_info, is_active_t() );
        
        std::sort( ary_sorted_info.begin(), ary_sorted_info.end(), Z_Less() );
        
        return ary_sorted_info;
    }
    
};


} /* namespace Win32 */
} /* namespace BK */


#endif /* _BODY_GRAPHIC_PROJECTIONINFOBUFFER_H_20031219Fri_144838_ */
