/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - {fBZNV - OtBbN - tHg
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief {fBZNV: OtBbN: tHg
 *
 * Win32 ɂtHgƕ̏񋟂܂B
 *
 * @author ABE Shigeru
 * @date 2003/12/24
 */
#ifndef _BODY_GRAPHIC_W32FONT_H_20031224Wed_150244_
#define _BODY_GRAPHIC_W32FONT_H_20031224Wed_150244_


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// tHg
class W32Font : public Font
{
protected: /* Font C^[tFCX */
    
    /// Ot𐶐
    virtual Glyph * create_glyph ( const char * str );
    
public: /* Font C^[tFCX */
    
    /// R[h̎擾
    virtual unsigned int get_charcode ( const char * str ) const;
    
private:
    
    /// tHg
    LOGFONT  obj_logical_font;
    
    /// tHgp̃foCXReLXg
    HDC  handle_device_context;
    
    /// ꂽtHg̃nh
    HFONT  handle_font;
    
    /// ȑOɐݒ肳ĂtHg
    HFONT  handle_font_backup;
    
    /// tHg̃gNX
    TEXTMETRIC  obj_metric;
    
    /// tHg
    mutable char * ptr_fontname_string;
    
    /// ۗLĂIuWFNg̔j
    void release ( void );
    
public:
    
    /// RXgN^
    W32Font ( const info_t & info );
    
    /// fXgN^
    ~W32Font ();
    
    /// w肳ꂽ̃TCY擾
    Size2 query_size ( UINT code );
    
    /// w肳ꂽ ABC TCY擾
    ABC query_ABC ( UINT code );
    
    /* ---- p\bh ---- */
    
    /// w肳ꂽ̃TCY擾
    Size2 query_size ( const char * str );
    
    /// gptHg擾
    const char * get_font_name ( void ) const;
};


} /* namespace BK */


#endif /* _BODY_GRAPHIC_W32FONT_H_20031224Wed_150244_ */
