/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - LN^[ - Character
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: LN^[: Character
 *
 * Character NX̒`s܂B
 *
 * @author ABE Shigeru
 * @date 2003/12/05
 */
#ifndef _SCHEMA_APPLICATION_CHARACTER_CHARACTER_H_20031205Fri_161527_
#define _SCHEMA_APPLICATION_CHARACTER_CHARACTER_H_20031205Fri_161527_


/*   萔̒`
------------------------------------------------------------------- */
namespace BK {


/// LN^[ۗLgݍ݃G[WFgXg̃TCY
/**
 * LN^[ۗLG[WFgXgp̑gݍ݃obt@܂B
 * ̐𒴂ꍇAxN^gp܂B
 */
const unsigned int CHARACTER_AGENT_MAX = 4;


} /* namespace BK */


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// {LN^[IuWFNg
/**
 * LN^[̊{ƂȂNXłB
 * G[WFg (LN^[ƃXNvg̃A\VG[V) ۗL邱Ƃł܂B
 */
class Character : public OnOffObject, public RubyObject
{
private: /* static ϐ */
    
    /// Ruby NX: Character
    static VALUE ruby_class_object;
    
public: /* static \bh */
    
    /// Ruby NX擾
    static VALUE get_ruby_class ( void );
    
    /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
    static bool is_kind_of ( VALUE obj )
    {
        return xrb_is_kind_of(obj, get_ruby_class());
    }
    
    /// Ruby IuWFNgIuWFNgɕϊ
    static Character * value_to_data ( VALUE obj )
    {
        return ruby_basecast< Character, RubyObject >( obj );
    }
    
protected: /* RubyObject C^[tFCX */
    
    /// Ruby NXIuWFNg擾
    virtual VALUE get_ruby_class_object ( void ) const
    {
        return get_ruby_class();
    }
    
public: /* RubyObject C^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    virtual void ruby_gc_mark ( void );
    
    /// Kx[WRNg̃ObZ[Wo̓tO擾
    //virtual bool is_ruby_gc_log_enabled ( void ) const;
    
    /// Ruby inspect \bh
    //virtual char * ruby_inspect ( char * buf, unsigned int cap ) const;
    
    /// Ruby IuWFNgɂ郉bsOCxg
    //virtual void on_ruby_wrap ( void );
    
protected: /* OnOffObject C^[tFCX */
    
    /// ANeBuԂωƂ̃Cxgnh
    //virtual void on_activate ( stat_t status );
    
public:
    
    /// G[WFg^
    typedef CharacterScript::Agent agent_t;
    
public: /* Character C^[tFCX */
    
    /// LN^[̑
    /**
     * o^ĂG[WFgɎs܂B
     * ~ꂽG[WFg͎IɎ菜܂B
     */
    virtual void execute ( void );
    
private:
    
    /// LN^[G[WFg̃Xg
    agent_t * * ary_agent;
    
    /// o^ĂLN^[XNvg
    unsigned int num_agent;
    
    /// LN^[XNvgXg̍őe
    unsigned int num_agent_capacity;
    
    /// gݍ݂̃LN^[G[WFgpobt@
    agent_t * ary_agent_builtin [ CHARACTER_AGENT_MAX ];
    
public:
    
    /// RXgN^
    /** LN^[̓ANeBuԂŏ܂B */
    Character ( void );
    
    /// fXgN^
    ~Character ();
    
    /// G[WFgǉ
    /**
     * LN^[ɃG[WFgǉ܂B
     */
    void add_agent ( agent_t * agent );
    
};


} /* namespace BK */


/*   Init/Exit ֐
------------------------------------------------------------------- */
namespace BK {


/// AvP[VfoCXELN^[̏
void Init_application_character_Character ( void );


/// AvP[VfoCXELN^[̏I
void Exit_application_character_Character ( void );


} /* namespace BK */


#endif /* _SCHEMA_APPLICATION_CHARACTER_CHARACTER_H_20031205Fri_161527_ */
