/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - MA - CharacterGear
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: LN^[: CharacterGear
 *
 * Character NX̒`s܂B
 *
 * @author ABE Shigeru
 * @date 2003/12/05
 */
#ifndef _SCHEMA_APPLICATION_CHARACTER_CHARACTERGEAR_H_20031206Sat_193040_
#define _SCHEMA_APPLICATION_CHARACTER_CHARACTERGEAR_H_20031206Sat_193040_


/*   萔̒`
------------------------------------------------------------------- */
namespace BK {


/// LN^[MAۗL郊Xg̏TCY
const unsigned int CHARACTER_GEAR_INITIAL_SIZE = 1024;


} /* namespace BK */


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// LN^[MA
/**
 * LN^[IuWFNgǗAs邽߂̃MAłB
 */
class CharacterGear : public Gear
{
public:
    
    /// eNX
    typedef Gear parent_t;
    
private: /* static ϐ */
    
    /// Ruby NX: CharacterGear
    static VALUE ruby_class_object;
    
public: /* static \bh */
    
    /// Ruby NX擾
    static VALUE get_ruby_class ( void );
    
    /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
    static bool is_kind_of ( VALUE obj )
    {
        return xrb_is_kind_of(obj, get_ruby_class());
    }
    
    /// Ruby IuWFNgIuWFNgɕϊ
    static CharacterGear * value_to_data ( VALUE obj )
    {
        return ruby_basecast< CharacterGear, RubyObject >( obj );
    }
    
protected: /* RubyObject C^[tFCX */
    
    /// Ruby NXIuWFNg擾
    virtual VALUE get_ruby_class_object ( void ) const
    {
        return get_ruby_class();
    }
    
public: /* RubyObject C^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    virtual void ruby_gc_mark ( void );
    
    /// Kx[WRNg̃ObZ[Wo̓tO擾
    //virtual bool is_ruby_gc_log_enabled ( void ) const;
    
    /// Ruby inspect \bh
    //virtual char * ruby_inspect ( char * buf, unsigned int cap ) const;
    
    /// Ruby IuWFNgɂ郉bsOCxg
    virtual void on_ruby_wrap ( void );
    
public: /* Gear C^[tFCX */
    
    /// ^C}[Cxg
    virtual void execute ( void );
    
private:
    
    /// LN^[Xg
    Character * * ary_character;
    
    /// o^ĂLN^[
    unsigned int num_size;
    
    /// LN^[Xg̗e
    unsigned int num_capacity;
    
public:
    
    /// RXgN^
    CharacterGear ( void );
    
    /// fXgN^
    virtual ~CharacterGear ();
    
    /// LN^[̒ǉ
    /**
     * w肳ꂽLN^[MAɒǉ܂B
     * d̃`FbN͈؍s܂B
     *
     * @param chr [in] ǉLN^[IuWFNg
     */
    void add ( Character & chr );
    
    /// LN^[̍폜
    /**
     * ̃\bh̎gp͐܂I
     * ʏ́ALN^[~Ԃɂ邱ƂŁAMA̍폜s܂B
     *
     * w肳ꂽLN^[MA폜܂B
     * LN^[IuWFNg폜킯ł͂Ȃ̂ŁAӂĂB
     *
     * @return 폜ꂽLN^[IuWFNg
     * @exception argument_exception w肳ꂽLN^[o^ĂȂ
     */
    Character * erase ( Character * ptr );
    
};


} /* namespace BK */


/*   Init/Exit ֐
------------------------------------------------------------------- */
namespace BK {


/// AvP[VfoCXELN^[̏
void Init_application_gear_CharacterGear ( void );


/// AvP[VfoCXELN^[̏I
void Exit_application_gear_CharacterGear ( void );


} /* namespace BK */


#endif /* _SCHEMA_APPLICATION_CHARACTER_CHARACTERGEAR_H_20031206Sat_193040_ */
