/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - MA - FPS MA
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: MA: FPS MA
 *
 * FPS 𑪒肷邽߂̃MANX`܂B
 *
 * @author ABE Shigeru
 * @date 2003/12/21
 */
#ifndef _SCHEMA_APPLICATION_GEAR_FPSGEAR_H_20031221Sun_104855_
#define _SCHEMA_APPLICATION_GEAR_FPSGEAR_H_20031221Sun_104855_


/*   NX̒`
------------------------------------------------------------------- */
namespace BK {


/// FPS MA
/**
 * VXe FPS 𑪒肷邽߂Ɏgp܂B
 * OtBbNfoCX̍\zOɂȂ܂B
 *
 * FPS ̎ZóAŋ߂ 1 b (邱Ƃ) ōs܂B
 */
class FPSGear : public Gear
{
public:
    
    /// eNX
    typedef Gear parent_t;
    
private: /* static ϐ */
    
    /// Ruby NX: FPSGear
    static VALUE ruby_class_object;
    
public: /* static \bh */
    
    /// Ruby NX擾
    static VALUE get_ruby_class ( void );
    
    /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
    static bool is_kind_of ( VALUE obj )
    {
        return xrb_is_kind_of(obj, get_ruby_class());
    }
    
    /// Ruby IuWFNgIuWFNgɕϊ
    static FPSGear * value_to_data ( VALUE obj )
    {
        return ruby_basecast< FPSGear, RubyObject >( obj );
    }
    
protected: /* Ruby IuWFNgpC^[tFCX */
    
    /// Ruby NXIuWFNg擾
    virtual VALUE get_ruby_class_object ( void ) const
    {
        return get_ruby_class();
    }
    
public: /* RubyObject C^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    //virtual void ruby_gc_mark ( void );
    
    /// Kx[WRNg̃ObZ[Wo̓tO擾
    //virtual bool is_ruby_gc_log_enabled ( void ) const;
    
    /// Ruby inspect \bh
    //virtual char * ruby_inspect ( char * buf, unsigned int cap ) const;
    
    /// Ruby IuWFNgɂ郉bsOCxg
    //virtual void on_ruby_wrap ( void );
    
public: /* Gear C^[tFCX */
    
    /// ^C}[Cxg
    //virtual void execute ( void );
    
private:
    
    /// FPS vԊu
    /** ~b\܂B */
    unsigned int num_interval;
    
protected:
    
    /// RXgN^
    FPSGear ( void );
    
public:
    
    /// fXgN^
    virtual ~FPSGear ();
    
    /// ŐV FPS 擾
    /**
     * FPS 擾̎̓TuNXōs܂B
     *
     * @return FPS l
     */
    virtual double get_fps ( void ) const = 0;
    
    /// FPS ̌vԊuԂ擾
    /**
     * @return vԊu (~b)
     */
    unsigned int get_interval ( void ) const
    {
        return num_interval;
    }
    
    /// FPS ̌vԊuԂݒ肷
    /**
     * Wł 1000 ~b (1 b) ɂȂĂ܂B
     * ݒ肷鎞ԂZƁAlZo܂B
     *
     * @param n [in] ݒ肷Ԋu (~b)
     */
    virtual void set_interval ( unsigned int n );
    
};


} /* namespace BK */


/*   Init/Exit ֐
------------------------------------------------------------------- */
namespace BK {


/// AvP[VfoCXEMȀ
void Init_application_gear_FPSGear ( void );


/// AvP[VfoCXEMȀI
void Exit_application_gear_FPSGear ( void );


} /* namespace BK */


#endif /* _SCHEMA_APPLICATION_GEAR_FPSGEAR_H_20031221Sun_104855_ */
