/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - MA
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: MA
 *
 * ۓIȃIuWFNg𑀍삷邽߂̃IuWFNgAMA`܂B
 *
 * MÁAۓIȃIuWFNg̑c
 *  - p[^
 *  - LN^[Ȃǂ̐
 *  - ͂̃`FbN
 *  - ...Ȃ
 * s܂B
 *
 * @author ABE Shigeru
 * @date 2003/08/17
 */
#ifndef _SCHEMA_APPLICATION_GEAR_H_20030817Sun_150704_
#define _SCHEMA_APPLICATION_GEAR_H_20030817Sun_150704_


/*   MANX̒`
------------------------------------------------------------------- */
namespace BK {


/// MA
/**
 * MÁAt[^C}[ƘAăAvP[VŜ𓮂ĂIuWFNgłB
 * MÁAIɃAvP[VfoCXɓo^܂B
 */
class Gear : public OnOffObject, public RubyObject
{
private: /* static ϐ */
    
    /// Ruby NX: Gear
    static VALUE ruby_class_object;
    
public: /* static \bh */
    
    /// Ruby NX擾
    static VALUE get_ruby_class ( void );
    
    /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
    static bool is_kind_of ( VALUE obj )
    {
        return xrb_is_kind_of(obj, get_ruby_class());
    }
    
    /// Ruby IuWFNgIuWFNgɕϊ
    static Gear * value_to_data ( VALUE obj )
    {
        return ruby_basecast< Gear, RubyObject >( obj );
    }
    
protected: /* RubyObject C^[tFCX */
    
    /// Ruby NXIuWFNg擾
    virtual VALUE get_ruby_class_object ( void ) const
    {
        return get_ruby_class();
    }
    
    /// p֐擾
    virtual void * get_ruby_free_function ( void );
    
public: /* RubyObject C^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    //virtual void ruby_gc_mark ( void );
    
    /// Kx[WRNg̃ObZ[Wo̓tO擾
    //virtual bool is_ruby_gc_log_enabled ( void ) const;
    
    /// Ruby inspect \bh
    //virtual char * ruby_inspect ( char * buf, unsigned int cap ) const;
    
    /// Ruby IuWFNgɂ郉bsOCxg
    //virtual void on_ruby_wrap ( void );
    
protected: /* OnOffObject C^[tFCX */
    
    /// ANeBuԂωƂ̃Cxgnh
    //virtual void on_activate ( stat_t status );
    
public: /* Gear C^[tFCX */
    
    /// ^C}[Cxg
    /**
     * ԂƂɎsCxg̃CLq܂B
     * MAANeBȕꍇɂ̂ݎs܂B
     */
    virtual void execute ( void )
    {
    }
    
private:
    
    /// MA ID
    unsigned int gear_id;
    
    /// Ōɒʒmꂽ
    /** MAANeBȕꍇłݒ肳܂B */
    FrameTimer::time_t num_last_time;
    
    /// MAĂ̌oߎ
    /** MAANeBuɂȂĂԂ̎ԂZ܂B */
    FrameTimer::time_t num_total_time;
    
    /// ANeBu^C}[
    /** MAANeBuɂȂĂԂ̂݌oߎԂZ܂B */
    FrameTimer::time_t num_active_time;
    
public:
    
    /// RXgN^
    /**
     * ftHgł́AMA̓ANeBuԂō\z܂B
     */
    Gear ( void );
    
    /// fXgN^
    virtual ~Gear ();
    
    /// MA ID 擾
    /**
     * @retval 0 ȃMA ID
     * @return ̃MA ID
     */
    unsigned int get_gear_id ( void ) const
    {
        return gear_id;
    }
    
    /// MA ID ݒ肷
    /**
     * MÁAID ̑傫 (`1) ɎsĂ܂B
     *  ID MA̎s֌W͖`łB
     */
    void set_gear_id ( unsigned int id );
    
    /// ̒ʒm
    /**
     * ^C}[ɂ莞Ԃo߂ƂɌĂяo\bhłB
     * MAANeBuł邩AANeBuł邩ɂ炸A
     * ĂяoKv܂B
     * ̃\bhĂяoƂɂAMA̎i݂܂B
     *
     * @param t [in] ݎ
     */
    void notify_time ( FrameTimer::time_t t );
    
    /// MẢғԂ擾
    /**
     * MAĂo߂Ԃ擾܂B
     * Pʂ̓~błB
     */
    FrameTimer::time_t get_total_time ( void ) const
    {
        return this->num_total_time;
    }
    
    /// MÃANeBu^C}[擾
    /**
     * MÃANeBu^C}[擾܂B
     * ANeBu^C}[́AMAANeBułԂ̂݁AoߎԂZ܂B
     * Pʂ̓~błB
     */
    FrameTimer::time_t get_active_time ( void ) const
    {
        return this->num_active_time;
    }
    
    /// MÃANeBu^C}[ݒ肷
    void set_active_time ( FrameTimer::time_t t );
    
};


} /* namespace BK */


/*   CN[h
------------------------------------------------------------------- */
#include "ad_ManualGear.h"
#include "ad_TimerGear.h"
#include "ad_FPSGear.h"
#include "ad_CharacterGear.h"
#include "ad_FadeInGear.h"


/*   Init/Exit ֐
------------------------------------------------------------------- */
namespace BK {


/// AvP[VfoCXEMȀ
void Init_application_Gear ( void );


/// AvP[VfoCXEMȀI
void Exit_application_Gear ( void );


} /* namespace BK */


#endif /* _SCHEMA_APPLICATION_GEAR_H_20030817Sun_150704_ */
