/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - AvP[V - MAXg
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: AvP[V: MAXg
 *
 * MAi[CǗ邽߂̔zIuWFNg`܂B
 *
 * @author ABE Shigeru
 * @date 2003/12/12
 */
#ifndef _SCHEMA_APPLICATION_GEARARRAY_H_20031212Fri_112713_
#define _SCHEMA_APPLICATION_GEARARRAY_H_20031212Fri_112713_


/*   NX̒`
------------------------------------------------------------------- */
namespace BK {


/// MAz
/**
 * MAIuWFNgׂzIuWFNgłB
 * z͕̏ۂ܂B^C}[CxgzMƁAMȀԂɂēo^܂B
 */
class GearArray : public OnOffObject
{
private:
    
    /// MAXg
    Gear * * ary_gear;
    
    /// o^ĂMA
    unsigned int num_size;
    
    /// MAXg̗e
    unsigned int num_capacity;
    
public:
    
    /// RXgN^
    /**
     * MAXg̓ANeBuԂō\z܂B
     */
    GearArray ( void );
    
    /// fXgN^
    virtual ~GearArray ();
    
    /// MAǉ
    /**
     * w肳ꂽMAXgɒǉ܂B
     * d̃`FbŃA؍s܂B
     *
     * @param gear [in] ǉMA
     */
    void add_gear ( Gear & gear );
    
    /// MA폜
    /**
     * MAXg폜܂BIuWFNĝ͉܂B
     *
     * @return 폜ꂽvf
     */
    Gear * erase_gear ( Gear * gear );
    
    /// MAo^Ă邩𒲂ׂ
    bool is_include ( Gear * gear ) const;
    
    /// ^C}[CxgzM
    /**
     * @param t [in] Cxg̔zM
     */
    void broadcast ( FrameTimer::time_t t );
    
    /// Ruby Kx[WRNgp}[N
    void ruby_gc_mark ( void );
    
    /// o^ĂMA̐擾
    unsigned int size ( void ) const
    {
        return num_size;
    }
    
};


/// \[gς݃MAz̃Xg
/**
 *  ID ɐ񂪍s GearArray ̃XgIuWFNgłB
 */
class GearStorage
{
public:
    
    /// Xgvf
    class element_t : public std::pair < unsigned int, GearArray * >
    {
    public:
        
        typedef std::pair < unsigned int, GearArray * > parent_t;
        
    public:
        
        /// RXgN^
        element_t ( unsigned int id, GearArray * ary )
                : parent_t (id, ary)
        {
        }
        
        /// rZq
        bool operator < ( const element_t & rhs ) const
        {
            // l傫擪ɎĂ̂ɒӁI
            return first > rhs.first;
        }
        
        /// rZq
        bool operator == ( unsigned int id ) const
        {
            return first == id;
        }
        
    };
    
    /// Xg^
    typedef std::vector < element_t > list_t;
    
private:
    
    /// XgIuWFNg
    list_t ary_list;
    
public:
    
    /// RXgN^
    GearStorage ( void );
    
    /// fXgN^
    ~GearStorage ();
    
    /// MA̓o^
    void add_gear ( Gear & gear );
    
    /// MA̍폜
    /**
     * @return 폜ꂽMA
     */
    Gear * erase_gear ( Gear * gear );
    
    /// SMA̔j
    void clear ( void );
    
    /// ^C}[CxgzM
    /**
     * @param t [in] Cxg̔zM
     */
    void broadcast ( FrameTimer::time_t t );
    
    /// Ruby Kx[WRNgp}[N
    void ruby_gc_mark ( void );
    
    /// o^ĂMA̐擾
    unsigned int size ( void ) const;
    
};


} /* namespace BK */


/*   Init/Exit ֐
------------------------------------------------------------------- */
namespace BK {


/// AvP[VfoCXEMȀ
void Init_application_gear_GearArray ( void );


/// AvP[VfoCXEMȀI
void Exit_application_gear_GearArray ( void );


} /* namespace BK */


#endif /* _SCHEMA_APPLICATION_GEARARRAY_H_20031212Fri_112713_ */
