/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - LN^[ - ScriptSequence
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: LN^[: ScriptSequence
 *
 * XNvgi[AAĎs邽߂̃XNvgIuWFNgłB
 *
 * @author ABE Shigeru
 * @date 2003/12/05
 */
#ifndef _SCHEMA_APPLICATION_CHARACTER_SCRIPTSEQUENCE_H_20031205Fri_200315_
#define _SCHEMA_APPLICATION_CHARACTER_SCRIPTSEQUENCE_H_20031205Fri_200315_


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// AXNvgRei
class ScriptSequence : public ContainerScript
{
public:
    
    /// eNX
    typedef ContainerScript parent_t;
    
private: /* static ϐ */
    
    /// Ruby NX: ScriptSequence
    static VALUE ruby_class_object;
    
public: /* static \bh */
    
    /// Ruby NX擾
    static VALUE get_ruby_class ( void );
    
    /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
    static bool is_kind_of ( VALUE obj )
    {
        return xrb_is_kind_of(obj, get_ruby_class());
    }
    
    /// Ruby IuWFNgIuWFNgɕϊ
    static ScriptSequence * value_to_data ( VALUE obj )
    {
        return ruby_basecast< ScriptSequence, CharacterScript >( obj );
    }
    
protected: /* Ruby IuWFNgpC^[tFCX */
    
    /// Ruby NXIuWFNg擾
    VALUE get_ruby_class_object ( void ) const
    {
        return get_ruby_class();
    }
    
public: /* Ruby IuWFNgpC^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    void ruby_gc_mark ( void );
    
    /// Kx[WRNg̃ObZ[Wo̓tO擾
    //virtual bool is_ruby_gc_log_enabled ( void ) const;
    
    /// Ruby inspect \bh
    //virtual char * ruby_inspect ( char * buf, unsigned int cap ) const;
    
    /// Ruby IuWFNgɂ郉bsOCxg
    virtual void on_ruby_wrap ( void );
    
public: /* CharacterScript ̌p\bh */
    
    /// G[WFg̍쐬
    CharacterScript::Agent * create_agent ( void );
    
public: /* ContainerScript p\bh */
    
    /// XNvg̒ǉ
    void add ( CharacterScript * script );
    
    /// XNvg̍폜
    void erase ( CharacterScript * script );
    
    /// XNvg̎擾
    CharacterScript * at ( unsigned int n );
    
    /// o^ĂXNvg̎擾
    unsigned int size ( void ) const;
    
public:
    
    /// Xg^
    typedef std::vector < CharacterScript * > list_t;
    
    /// G[WFg
    class Agent : public parent_t::Agent
    {
    public:
        
        /// eNX
        typedef parent_t::Agent agent_parent_t;
        
    public: /* CharacterScript::Agent C^[tFCX */
        
        /// LN^[̓o^
        //virtual bool connect_character ( Character * chr );
        
        /// G[WFg̎s
        virtual void execute ( void );
        
    private:
        
        /// XNvgւ̎Q
        ScriptSequence * const ptr_script;
        
        /// ݎs̃XNvg̃CfNX
        unsigned int num_current_index;
        
        /// ݎs̃XNvg
        CharacterScript * ptr_current_script;
        
        /// XNvgG[WFg
        CharacterScript::Agent * ptr_current_agent;
        
    public:
        
        /// RXgN^
        Agent ( ScriptSequence & script );
        
        /// fXgN^
        ~Agent ();
        
    };
    
private:
    
    /// XNvgXg
    list_t ary_script;
    
public:
    
    /// RXgN^
    ScriptSequence ( void );
    
    /// fXgN^
    ~ScriptSequence ();
    
};


} /* namespace BK */


/*   Init/Exit ֐
------------------------------------------------------------------- */
namespace BK {


/// AvP[VfoCXELN^[̏
void Init_application_character_ScriptSequence ( void );


/// AvP[VfoCXELN^[̏I
void Exit_application_character_ScriptSequence ( void );


} /* namespace BK */


#endif /* _SCHEMA_APPLICATION_CHARACTER_SCRIPTSEQUENCE_H_20031205Fri_200315_ */
