/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - LN^[ - SpriteCharacter
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: LN^[: SpriteCharacter
 *
 * SpriteCharacter NX̒`s܂B
 *
 * @author ABE Shigeru
 * @date 2003/12/05
 */
#ifndef _SCHEMA_APPLICATION_CHARACTER_SPRITECHARACTER_H_20031205Fri_162004_
#define _SCHEMA_APPLICATION_CHARACTER_SPRITECHARACTER_H_20031205Fri_162004_


/*   NX̐錾
------------------------------------------------------------------- */
namespace BK {

class SpriteField;

} /* namespace BK */


/*   NX`
------------------------------------------------------------------- */
namespace BK {


class SpriteCharacter : public Character
{
public:
    
    /// eNX
    typedef Character parent_t;
    
private: /* static ϐ */
    
    /// Ruby NX: SpriteCharacter
    static VALUE ruby_class_object;
    
public: /* static \bh */
    
    /// Ruby NX擾
    static VALUE get_ruby_class ( void );
    
    /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
    static bool is_kind_of ( VALUE obj )
    {
        return xrb_is_kind_of(obj, get_ruby_class());
    }
    
    /// Ruby IuWFNgIuWFNgɕϊ
    static SpriteCharacter * value_to_data ( VALUE obj )
    {
        return ruby_basecast< SpriteCharacter, RubyObject >( obj );
    }
    
protected: /* RubyObject C^[tFCX */
    
    /// Ruby NXIuWFNg擾
    virtual VALUE get_ruby_class_object ( void ) const
    {
        return get_ruby_class();
    }
    
public: /* RubyObject C^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    virtual void ruby_gc_mark ( void );
    
    /// Kx[WRNg̃ObZ[Wo̓tO擾
    //virtual bool is_ruby_gc_log_enabled ( void ) const;
    
    /// Ruby inspect \bh
    //virtual char * ruby_inspect ( char * buf, unsigned int cap ) const;
    
    /// Ruby IuWFNgɂ郉bsOCxg
    virtual void on_ruby_wrap ( void );
    
protected: /* OnOffObject C^[tFCX */
    
    /// ANeBuԂωƂ̃Cxgnh
    virtual void on_activate ( stat_t status );
    
public: /* Character C^[tFCX */
    
    /// LN^[̑
    virtual void execute ( void );
    
public:
    
    /// eNX
    typedef Character parent_t;
    
private:
    
    /// gpĂXvCgtB[h
    SpriteField & obj_field;
    
    /// gpĂXvCgf[^
    const SpriteFieldData * ptr_sprite;
    
    /// ]̈
    ProjectionInfo * ptr_projection;
    
    /// \S_
    Point2 point_center;
    
    /// g嗦
    /** p[Zgŕ\B */
    unsigned int num_zoom;
    
    /// ]px
    /** WAł͂ȂAxPʁB */
    int num_angle;
    
    /// `F
    /**  NULL ̏ꍇALɂȂ܂B */
    AlphaColor * ptr_color;
    
public:
    
    /// RXgN^
    SpriteCharacter ( SpriteField & field );
    
    /// fXgN^
    ~SpriteCharacter ();
    
    /// XvCgݒ肷
    /**
     * ̃LN^[gp摜Aw肳ꂽÕXvCgɐݒ肵܂B
     *
     * @exception argument_exception w肳ꂽÕXvCg̓XvCgtB[hɓo^ĂȂ
     */
    void set_sprite ( const char * name );
    
    /// S_擾
    const Point2 & get_center ( void ) const
    {
        return point_center;
    }
    
    /// S_ݒ肷
    void set_center ( const Point2 & p );
    
    /// `F擾
    /**
     * @return `Fւ̃|C^
     * @retval NULL `Fݒ肳ĂȂ
     */
    const AlphaColor * const & get_color ( void ) const
    {
        return ptr_color;
    }
    
    /// `Fݒ肷
    /** NULL w肵ꍇ͕`F̐ݒ肪܂B */
    void set_color ( const AlphaColor * color );
    
    /// g嗦擾
    /**
     * @retval p[Zg\L̊g嗦
     */
    unsigned int get_zoom ( void ) const
    {
        return num_zoom;
    }
    
    /// g嗦ݒ肷
    /**
     * @param n [in] p[Zg\L̊g嗦
     */
    void set_zoom ( unsigned int n );
    
};


} /* namespace BK */


/*   Init/Exit ֐
------------------------------------------------------------------- */
namespace BK {


/// AvP[VfoCXELN^[̏
void Init_application_character_SpriteCharacter ( void );


/// AvP[VfoCXELN^[̏I
void Exit_application_character_SpriteCharacter ( void );


} /* namespace BK */


#endif /* _SCHEMA_APPLICATION_CHARACTER_SPRITECHARACTER_H_20031205Fri_162004_ */
