/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - [eBeB - ǂݎ
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: [eBeB: ǂݎ
 *
 * Ruby  C++ IuWFNgɕϊ邽߂̃[eBeBNX
 * `܂B
 *
 * @author ABE Shigeru
 * @date 2003/12/12
 */
#ifndef _SCHEMA_UTILITY_ARGSCANNER_H_20031212Fri_224959_
#define _SCHEMA_UTILITY_ARGSCANNER_H_20031212Fri_224959_


/*   NX`
------------------------------------------------------------------- */
namespace BK {
namespace Ruby {


/// Ruby \bhp[^̓IuWFNg
/**
 * VALUE z񂩂Aef[^擾܂B
 * G[Ƃ C++ O𑗏o܂B
 */
class ArgScanner
{
private:
    
    /// \bh
    const char * str_target;
    
    /// ŏɎw肳ꂽp[^
    const int num_initial_arg;
    
    /// cp[^
    int num_arg;
    
    /// p[^̔z
    VALUE * ptr_arg;
    
public:
    
    /// RXgN^
    /**
     * @param target [in] \bh
     * @param argc [in] p[^
     * @param argv [in] p[^z
     */
    ArgScanner ( const char * target, int argc, VALUE * argv );
    
    /// fXgN^
    ~ArgScanner ();
    
    /// p[^cĂ邩𒲂ׂ
    /**
     * @retval true ׂẴp[^ǂݍ܂ꂽ
     * @retval false ܂ǂݍ܂ĂȂp[^
     */
    bool is_empty ( void ) const
    {
        return num_arg <= 0;
    }
    
    /// ɓǂ܂p[^擾
    /**
     * ǂݍ݃|C^͐i݂܂B
     * ԂIuWFNg͈łB(IuWFNgň̃f[^\ꍇ͍l܂)
     * ׂẴp[^ǂݍ܂ĂꍇAO argument_exception ܂B
     *
     * @return ɓǂݍ܂ Ruby IuWFNg
     */
    VALUE current ( void ) const;
    
    /// cp[^݂ȂƂ`FbN
    /**
     * ǂݍ݂IAĂяo܂B
     *
     * @exception argument_exception ǂݍ߂p[^cĂ
     */
    void finish ( void );
    
    /// p[^擾
    /**
     * @param name [in] 擾f[^̖O
     * @return ݈ʒũp[^
     */
    VALUE fetch_value ( const char * name = NULL );
    
    /// Color 擾
    /**
     * @param name [in] 擾f[^̖O
     * @return \zꂽF
     */
    Color fetch_Color ( const char * name = NULL );
    
    /// AlphaColor 擾
    /**
     * @param name [in] 擾f[^̖O
     * @return \zꂽF
     */
    AlphaColor fetch_AlphaColor ( const char * name = NULL );
    
    /// Size2 擾
    /**
     * @param name [in] 擾f[^̖O
     * @return \zꂽTCY
     */
    Size2 fetch_Size2 ( const char * name = NULL );
    
    /// Point2 擾
    /**
     * @param name [in] 擾f[^̖O
     * @return \zꂽW
     */
    Point2 fetch_Point2 ( const char * name = NULL );
    
    /// Rect2 擾
    /**
     * @param name [in] 擾f[^̖O
     * @return \zꂽ`
     */
    Rect2 fetch_Rect2 ( const char * name = NULL );
    
};


} /* namespcae Ruby */
} /* namespace BK */


/*   Init/Exit ֐
------------------------------------------------------------------- */
namespace BK {


/// [eBeB̏
void Init_utility_ArgScanner ( void );


/// [eBeB̏I
void Exit_utility_ArgScanner ( void );


} /* namespace BK */


#endif /* _SCHEMA_UTILITY_ARGSCANNER_H_20031212Fri_224959_ */
