/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - [eBeB - AXyNg`
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: [eBeB: AXyNg`
 *
 * 񎟌AXyNg`\̃f[^`܂B
 *
 * @author ABE Shigeru
 * @date 2003/12/11
 */
#ifndef _SCHEMA_UTILITY_ASPECTRECT2_H_20031211Thu_114810_
#define _SCHEMA_UTILITY_ASPECTRECT2_H_20031211Thu_114810_


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// AXyNg`
/**
 * `̊eWŕ\IuWFNgłB
 *
 * DirectX ̃eNX`ȂǂŎgp܂B
 */
class AspectRect2
{
private: /* static ϐ */
    
    /// Ruby NX: AspectRect2
    static VALUE ruby_class_object;
    
public: /* static \bh */
    
    /// Ruby NX擾
    static VALUE get_ruby_class ( void );
    
    /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
    static bool is_kind_of ( VALUE obj )
    {
        return xrb_is_kind_of(obj, get_ruby_class());
    }
    
    /// Ruby IuWFNgIuWFNgɕϊ
    static AspectRect2 * value_to_data ( VALUE obj )
    {
        return ruby_cast< AspectRect2 >( obj );
    }
    
public:
    
    /// f[^^
    typedef float num_t;
    
private:
    
    /// [ʒu
    num_t  num_left;
    
    /// E[ʒu
    num_t  num_right;
    
    /// [ʒu
    num_t  num_top;
    
    /// [ʒu
    num_t  num_bottom;
    
public:
    
    /// [̈ʒu擾
    const num_t & get_left ( void ) const
    {
        return num_left;
    }
    
    /// [̈ʒuݒ肷
    const num_t & set_left ( const num_t & n )
    {
        return num_left = n;
    }
    
    /// E[̈ʒu擾
    const num_t & get_right ( void ) const
    {
        return num_right;
    }
    
    /// E[̈ʒuݒ肷
    const num_t & set_right ( const num_t & n )
    {
        return num_right = n;
    }
    
    /// [̈ʒu擾
    const num_t & get_top ( void ) const
    {
        return num_top;
    }
    
    /// [̈ʒuݒ肷
    const num_t & set_top ( const num_t & n )
    {
        return num_top = n;
    }
    
    /// [̈ʒu擾
    const num_t & get_bottom ( void ) const
    {
        return num_bottom;
    }
    
    /// [̈ʒuݒ肷
    const num_t & set_bottom ( const num_t & n )
    {
        return num_bottom = n;
    }
    
    /// `̐ݒ
    void set_rect ( const Rect2 & r, const Size2 & s )
    {
        set_left( static_cast< num_t >(r.get_left()) / s.get_width() );
        set_right( static_cast< num_t >(r.get_right()) / s.get_width() );
        set_top( static_cast< num_t >(r.get_top()) / s.get_height() );
        set_bottom( static_cast< num_t >(r.get_bottom()) / s.get_height() );
    }
    
    /// `̐ݒ
    void set_rect ( const num_t & l, const num_t & t, const num_t & r, const num_t & b )
    {
        set_left( l );
        set_right( r );
        set_top( t );
        set_bottom( b );
    }
    
    /// RXgN^
    AspectRect2 ( void )
    {
        set_rect( 0.0, 0.0, 0.0, 0.0 );
    }
    
    /// RXgN^
    /**
     * @param r [in] Ώە̋`
     * @param s [in] eNX`̃TCY
     */
    AspectRect2 ( const Rect2 & r, const Size2 & s )
    {
        set_rect( r, s );
    }
    
    /// RXgN^
    AspectRect2 ( const num_t & l, const num_t & t, const num_t & r, const num_t & b )
    {
        set_rect( l, t, r, b );
    }
    
    /// vr
    bool operator == ( const AspectRect2 & s ) const
    {
        return
            get_left() == s.get_left() && get_right() == s.get_right() &&
            get_top() == s.get_top() && get_bottom() == s.get_bottom();
    }
    
    /// svr
    bool operator != ( const AspectRect2 & r ) const
    {
        return !operator==( r );
    }
    
    /// ̃IuWFNg\擾 (string )
    std::string to_string ( void ) const;
    
    /// ̃IuWFNg\擾
    /**
     * @param buf [out] ̏o͐
     * @param cap [in] o͐̃obt@e (k܂)
     * @return o͂ꂽ char 
     */
    int get_string ( char * buf, unsigned int cap ) const;
    
    /// ̃IuWFNgQƂ Ruby IuWFNg𐶐
    VALUE create_ruby_reference ( void );
    
    /// ̃IuWFNgRs[ Ruby IuWFNg𐶐
    VALUE create_ruby_object ( void ) const;
    
};


} /* namespace BK */


/*   Init/Exit ֐
------------------------------------------------------------------- */
namespace BK {


/// 2D NX̏
void Init_utility_AspectRect2 ( void );


/// 2D NX̏I
void Exit_utility_AspectRect2 ( void );


} /* namespace BK */


#endif /* _SCHEMA_UTILITY_ASPECTRECT2_H_20031211Thu_114810_ */
