/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - [eBeB - CAEg
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: [eBeB: CAEg
 *
 * qCAEgo^ĂAォxɃCAEg̒sA
 * CAEgReiNXłB
 * CAEgsz肵Ă܂B
 * ۂɂ̓TuNXgp܂B
 *
 * @author ABE Shigeru
 * @date 2004/03/12
 */
#ifndef _SCHEMA_UTILITY_DOCUMENTLAYOUT_H_20040312Fri_065816_
#define _SCHEMA_UTILITY_DOCUMENTLAYOUT_H_20040312Fri_065816_


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// CAEg
/**
 * ɕCAEgׂ郌CAEg\܂B
 */
class DocumentLayout : public Layout
{
public:
    
    /// eNX
    typedef Layout parent_t;
    
private: /* static ϐ */
    
    /// Ruby NX: DocumentLayout
    static VALUE ruby_class_object;
    
public: /* static \bh */
    
    /// Ruby NX擾
    static VALUE get_ruby_class ( void );
    
    /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
    static bool is_kind_of ( VALUE obj )
    {
        return xrb_is_kind_of(obj, get_ruby_class());
    }
    
    /// Ruby IuWFNgIuWFNgɕϊ
    static DocumentLayout * value_to_data ( VALUE obj )
    {
        return ruby_basecast< DocumentLayout, RubyObject >( obj );
    }
    
protected: /* Ruby IuWFNgpC^[tFCX */
    
    /// Ruby NXIuWFNg擾
    virtual VALUE get_ruby_class_object ( void ) const
    {
        return get_ruby_class();
    }
    
public: /* Ruby IuWFNgpC^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    virtual void ruby_gc_mark ( void );
    
    /// Kx[WRNg̃ObZ[Wo̓tO擾
    //virtual bool is_ruby_gc_log_enabled ( void ) const;
    
    /// Ruby inspect \bh
    //virtual char * ruby_inspect ( char * buf, unsigned int cap ) const;
    
    /// Ruby IuWFNgɂ郉bsOCxg
    virtual void on_ruby_wrap ( void );
    
public: /* Layout C^[tFCX */
    
    /// CAEgXVȌ
    /**
     * o^ꂽCAEgSĂɑ΂čXVs܂B
     * TCYύXꂽCAEg݂ꍇÃCAEg̍XVKvɂȂ܂B
     */
    virtual void on_invoke_update ( void );
    
    /// CAEg̍XV
    //virtual void on_update ( void );
    
    /// CAEg̕sړ
    virtual void on_set_point ( const Point2 & delta );
    
public:
    
    /// CAEgXǧ^
    typedef std::vector < Layout * > list_t;
    
public: /* DocumentLayout C^[tFCX */
    
    /// CAEg̒ǉ
    /**
     * ReiɃCAEgo^܂BNULL ͓o^܂B
     * o^ update() ĂяoŁACAEgzum肵܂B
     *
     * @param layouts [in] ǉ郌CAEg
     * @param len [in] CAEg
     */
    virtual void add_layout ( Layout * * layouts, unsigned int len );
    
    /// ݓo^Ă郌CAEg폜
    /**
     * ̃CAEgɔzuꂽCAEgo^܂B
     * zuĂȂCAEg͓o^܂B
     * ̃CAEgzuɂ́Aēx update() ĂяoKv܂B
     */
    virtual void clear_registered_layouts ( void );
    
private:
    
    /// CAEgXg
    list_t ary_list;
    
    /// ̈Oւ̓o^tO
    bool bool_overflow;
    
    /// ̈ɓo^ꂽCAEg
    unsigned int num_registered_layouts;
    
    /// ̈ʒu킹
    align_t align_horizontal;
    
    /// c̈ʒu킹
    align_t align_vertical;
    
protected:
    
    /// ̈ɓo^CAEgݒ肷
    /**
     * update() ɌĂяo܂B
     * ̃\bhł́ACAEgԂ͕ύX܂B
     */
    void set_registered_layouts_count ( unsigned int num );
    
public:
    
    /// RXgN^
    /**
     * ftHgł́ÄOւ̓o^͋֎~Ă܂B
     */
    DocumentLayout ( void );
    
    /// fXgN^
    virtual ~DocumentLayout ();
    
    /// o^Ă郌CAEgׂč폜
    void clear ( void );
    
    /// o^Ă郌CAEgׂčXV
    /**
     * ̃CAEgɓo^ĂqCAEg̍XVs܂B
     * CAEgł́AqCAEg̃TCŶ݂邽߁AqCAEg
     * TCYύXo܂B
     *
     * @retval true qCAEgTCŶꂩXVꂽ
     * @retval false qCAEgTCY͂ǂXVȂ
     */
    bool update_document_layouts ( void );
    
    /// ̈Oւ̓o^ۂ擾
    bool is_overflow_enabled ( void ) const
    {
        return bool_overflow;
    }
    
    /// c̈ʒu킹擾
    align_t get_vertical_align ( void ) const
    {
        return align_vertical;
    }
    
    /// ̈ʒu킹擾
    align_t get_horizontal_align ( void ) const
    {
        return align_horizontal;
    }
    
    /// o^ꂽCAEg̑擾
    unsigned int count_document_layouts ( void ) const
    {
        return static_cast< unsigned int >( ary_list.size() );
    }
    
    /// o^ꂽSCAEg̃Xg𓾂
    /**
     * ̃CAEgɒǉꂽSCAEg擾܂B
     *
     * @param buf [out] CAEg̏o͐obt@
     * @param len [in] obt@̃TCY
     * @return obt@ɏ܂ꂽCAEg
     */
    unsigned int get_document_layouts ( Layout * * buf, unsigned int len ) const;
    
    /// CAEgɓo^ꂽCAEg擾
    unsigned int count_registered_layouts ( void ) const
    {
        return num_registered_layouts;
    }
    
    /// CAEgɓo^ꂽCAEg̃Xg𓾂
    /**
     * ̃CAEgɔzuꂽCAEg擾܂B
     *
     * @param buf [out] CAEg̏o͐obt@
     * @param len [in] obt@̃TCY
     * @return obt@ɏ܂ꂽCAEg
     */
    unsigned int get_registered_layouts ( Layout * * buf, unsigned int len ) const;
    
    /// ̈Oւ̓o^ۂݒ肷
    /**
     * true ݒ肳ꂽꍇAȍ~̃CAEgǉɂāA
     * ̈Oւ̒ǉs悤ɂȂ܂B
     * ̓IȒǉ@̓TuNXɈˑ܂B
     *
     * @param flag [in] ݒ肷tOl
     */
    void set_overflow_enabled ( bool flag );
    
    /// c̈ʒu킹ݒ肷
    void set_vertical_align ( align_t align );
    
    /// ̈ʒu킹ݒ肷
    void set_horizontal_align ( align_t align );
    
    /// o^Ă郌CAEgōł擾
    Size2::num_t get_minimum_height ( void ) const;
    
};


} /* namespace BK */


/*   CN[h
------------------------------------------------------------------- */
#include "bk_LabelLayout.h"
#include "bk_TextLayout.h"


/*   Init/Exit ֐
------------------------------------------------------------------- */
namespace BK {


/// [eBeB̏
void Init_utility_DocumentLayout ( void );


/// [eBeB̏I
void Exit_utility_DocumentLayout ( void );


} /* namespace BK */


#endif /* _SCHEMA_UTILITY_DOCUMENTLAYOUT_H_20040312Fri_065816_ */
