/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - [eBeB - ANeBuIuWFNg
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: [eBeB: ANeBuIuWFNg
 *
 * ANeBuEANeBuԂǗ邽߂̃NX`܂B
 *
 * @author ABE Shigeru
 * @date 2003/12/12
 */
#ifndef _SCHEMA_UTILITY_ONOFFOBJECT_H_20031212Fri_115633_
#define _SCHEMA_UTILITY_ONOFFOBJECT_H_20031212Fri_115633_


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// ANeButIuWFNg
/**
 * IuWFNg̏Ԃ߂̃IuWFNgłB
 * ̎O̏Ԃ邱Ƃł܂B
 *  - ANeBu
 *  - ANeBu
 *  - ~
 * ~ԂɂȂIuWFNgANeBuɂ邱Ƃ͂ł܂B
 */
class OnOffObject
{
public:
    
    /// Ԏʎq
    enum stat_t
    {
        /// IuWFNg̓ANeBu
        STAT_ACTIVE,
        
        /// IuWFNg͔ANeBu - jȂ
        STAT_INACTIVE,
        
        /// IuWFNg͒~ - j
        STAT_TERMINATED,
    };
    
private:
    
    /// ݂̃ANeBu
    stat_t num_status;
    
protected: /* OnOffObject C^[tFCX */
    
    /// ANeBuԂωƂ̃Cxgnh
    /**
     * ANeBuԂωƂɁû݁vĂяo܂B
     * RXgN^ŏƂ͌ĂяoȂ̂ŒӂĂB
     *
     * on_activate() ̎sIAIuWFNgۗLԃf[^ύX܂B
     * IOɌĂяoꂽ is_active() Ȃǂ́AύXȌԃf[^ŌʂԂ܂B
     *
     * @param status [in] ݒ肳
     */
    virtual void on_activate ( stat_t status )
    {
    }
    
public:
    
    /// RXgN^
    /**
     * ftHgł́AIuWFNg̓ANeBuԂō\z܂B
     * \zA on_activate() ͌Ăяo܂B
     */
    OnOffObject ( stat_t status = STAT_ACTIVE )
            : num_status (status)
    {
    }
    
    /// fXgN^
    virtual ~OnOffObject ()
    {
    }
    
    /// ANeBuԂɂ
    void activate ( void );
    
    /// ANeBuԂɂ
    void deactivate ( void );
    
    /// IuWFNg~Ԃɂ
    void terminate ( void );
    
    /// ANeBuԂł邩𒲂ׂ
    bool is_active ( void ) const
    {
        return num_status == STAT_ACTIVE;
    }
    
    /// IuWFNg~Ԃɂ邩𒲂ׂ
    bool is_terminated ( void ) const
    {
        return num_status == STAT_TERMINATED;
    }
    
};


} /* namespace BK */


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// ON/OFF IuWFNgXg
/**
 * ~Ԃ OnOffObject 菜@\ۗLAIuWFNgXgłB
 * {Iȋ@\݂̂܂AǂȂ悤ɐ݌vĂ܂B
 *
 * ev[g value_t ɂ́AOnOffObject ̃TuNXw肵܂B
 */
template < typename value_t >
class OnOffObjectArray
{
private:
    
    /// Xg
    value_t * * ptr_buffer;
    
    /// Xg̒
    unsigned int num_length;
    
    /// Xg̃LpVeB
    unsigned int num_capacity;
    
public:
    
    /// RXgN^
    /**
     * KvɉāAobt@͓{Ă܂B
     *
     * @param initcap [in] obt@TCY
     */
    OnOffObjectArray ( unsigned int initcap = 256 )
            : ptr_buffer (NULL),
              num_length (0),
              num_capacity ((initcap < 8) ? 8 : initcap)
    {
        ptr_buffer = reinterpret_cast< value_t * * >( malloc(num_capacity * sizeof(value_t *)) );
        
        OnOffObject * const forcheck = ptr_buffer[0]; // ev[ǧ^`FbN
    }
    
    /// fXgN^
    virtual ~OnOffObjectArray ()
    {
        if( ptr_buffer != NULL ) {
            free( ptr_buffer );
        }
    }
    
    /// IuWFNg̒ǉ
    /**
     * Xgɂ͎Q (|C^) o^܂B
     */
    value_t * add ( value_t & info )
    {
        if( num_length >= num_capacity ) {
            num_capacity *= 2;
            ptr_buffer = reinterpret_cast< value_t * * >( realloc(ptr_buffer, num_capacity * sizeof(value_t *)) );
        }
        ptr_buffer[ num_length++ ] = &info;
        
        return &info;
    }
    
    /// IuWFNg̍폜
    /**
     * w肳ꂽIuWFNĝ͍̂폜܂B
     *
     * @retval true IuWFNg͍폜ꂽ
     * @retval false w肳ꂽIuWFNg͓o^ĂȂ
     */
    bool erase ( const value_t & info )
    {
        for( unsigned int i = 0; i < num_length; ++i ) {
            if( ptr_buffer[i] == &info ) {
                ptr_buffer[i] = ptr_buffer[--num_length];
                return true;
            }
        }
        return false;
    }
    
    /// Xg̃NA
    /**
     * ׂẴIuWFNg̓o^܂B
     * IuWFNĝ͍̂폜܂B
     */
    void clear ( void )
    {
        num_length = 0;
    }
    
    /// ̃IuWFNǧ
    bool is_exist ( const value_t & info ) const
    {
        for( unsigned int i = 0; i < num_length; ++i ) {
            if( ptr_buffer[i] == &info ) {
                return true;
            }
        }
        return false;
    }
    
    /// o^Ă]̈̐擾
    unsigned int size ( void ) const
    {
        return num_length;
    }
    
    /// ~IuWFNg̔j
    /**
     * ~Ԃ̃IuWFNgAXg폜܂B
     * IuWFNĝ͍폜܂B
     */
    void sweep ( void )
    {
        unsigned int s = num_length;
        unsigned int i = 0;
        
        while( i < s ) {
            value_t * const value = ptr_buffer[i];
            
            if( value->is_terminated() ) {
                ptr_buffer[i] = ptr_buffer[ --s ];
            } else {
                ++i;
            }
        }
        num_length = s;
    }
    
    /// gp\IuWFNg̎擾ƃXg\z
    /**
     * ev[g list_t ɂ́Avalue_t *  STL Reiw肵܂B
     * ̃\bhsƁAeׂ͂č폜܂B
     * is_active_t ́AƂ value_t & Ƃ֐IuWFNgłBIuWFNg
     * gp\ł邩ǂ𔻒肵܂B
     *
     * ̃\bhsƁA~Ԃ̃IuWFNgXg폜܂B
     *
     * @param list [out] ʂi[郊Xg
     * @param is_active [in] IuWFNggp\ł邩𒲂ׂ֐IuWFNg
     */
    template < typename list_t, typename is_active_t >
    void sweep ( list_t & list, is_active_t & is_active )
    {
        unsigned int s = num_length;
        unsigned int i = 0;
        
        list.clear();
        while( i < s ) {
            value_t * const value = ptr_buffer[i];
            
            if( value->is_terminated() ) {
                ptr_buffer[i] = ptr_buffer[ --s ];
            } else {
                if( value->is_active() && is_active(*value) ) {
                    list.push_back( value );
                }
                ++i;
            }
        }
        num_length = s;
    }
    
    /// evfɑ΂鑀̎s
    /**
     * execute_t ́AƂ value_t & Ƃ֐IuWFNgłB
     *
     * @param execute [in] \֐IuWFNg
     */
    template < typename execute_t >
    void for_each ( execute_t & execute )
    {
        for( unsigned int i = 0; i < num_length; ++i ) {
            execute( *ptr_buffer[i] );
        }
    }
    
};


} /* namespace BK */


/*   Ruby [eBeB
------------------------------------------------------------------- */
namespace BK {


/// IuWFNg̃ANeBuԂ𒲂ׂ Ruby \bh
inline VALUE OnOffObject_is_active ( BK::OnOffObject * ptr )
{
    return (ptr->is_active()) ? Qtrue : Qfalse;
}


/// IuWFNg̃ANeBus Ruby \bh
inline void OnOffObject_activate ( BK::OnOffObject * ptr )
{
    try {
        ptr->activate();
    }
    catch ( BK::exception_base * e ) {
        BK::ruby_throw( e );
    }
}


/// IuWFNg̔ANeBus Ruby \bh
inline void OnOffObject_deactivate ( BK::OnOffObject * ptr )
{
    try {
        ptr->deactivate();
    }
    catch ( BK::exception_base * e ) {
        BK::ruby_throw( e );
    }
}


/// IuWFNg̔js Ruby \bh
inline void OnOffObject_terminate ( BK::OnOffObject * ptr )
{
    try {
        ptr->terminate();
    }
    catch ( BK::exception_base * e ) {
        BK::ruby_throw( e );
    }
}


} /* namespace BK */


/*   Init/Exit ֐
------------------------------------------------------------------- */
namespace BK {


/// [eBeB̏
void Init_utility_OnOffObject ( void );


/// [eBeB̏I
void Exit_utility_OnOffObject ( void );


} /* namespace BK */


#endif /* _SCHEMA_UTILITY_ONOFFOBJECT_H_20031212Fri_115633_ */
