/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - [eBeB - ]̈
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: [eBeB: ]̈
 *
 * ]̈pɎgf[^`܂B
 *
 * @author ABE Shigeru
 * @date 2003/12/11
 */
#ifndef _SCHEMA_UTILITY_PROJECTIONINFO_H_20031211Thu_165300_
#define _SCHEMA_UTILITY_PROJECTIONINFO_H_20031211Thu_165300_


/*   NX錾
------------------------------------------------------------------- */
namespace BK {

class SpriteFieldData;

} /* namespace BK */


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// ]̈IuWFNg
/**
 * `̈Aʂ̏ꏊ֓]ۂɎgpf[^\łB
 * ]ʒȕۗL܂B
 *
 * ]Ɠ]ŁÄ̃TCYς邱Ƃł܂B
 * ]́Al_Ŏw肳̈w肷邱ƂłAX`Ȃǂݒł܂B
 *
 * ̂߁Aۂɂ́A]]ɍ킹TuNXgp܂B
 * ܂ÃNX́AʂɂĂ͎gȂ܂ł܂B
 *
 * - m̃TuNX
 *   - TextureProjectionInfo (DirectX)
 */
class ProjectionInfo : public OnOffObject, public RubyObject
{
private: /* static ϐ */
    
    /// Ruby NX: ProjectionInfo
    static VALUE ruby_class_object;
    
public: /* static \bh */
    
    /// Ruby NX擾
    static VALUE get_ruby_class ( void );
    
    /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
    static bool is_kind_of ( VALUE obj )
    {
        return xrb_is_kind_of(obj, get_ruby_class());
    }
    
    /// Ruby IuWFNgIuWFNgɕϊ
    static ProjectionInfo * value_to_data ( VALUE obj )
    {
        return ruby_basecast< ProjectionInfo, RubyObject >( obj );
    }
    
protected: /* RubyObject C^[tFCX */
    
    /// Ruby NXIuWFNg擾
    virtual VALUE get_ruby_class_object ( void ) const
    {
        return get_ruby_class();
    }
    
public: /* RubyObject C^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    //virtual void ruby_gc_mark ( void );
    
    /// Kx[WRNg̃ObZ[Wo̓tO擾
    virtual bool is_ruby_gc_log_enabled ( void ) const;
    
    /// Ruby inspect \bh
    virtual char * ruby_inspect ( char * buf, unsigned int cap ) const;
    
    /// Ruby IuWFNgɂ郉bsOCxg
    //virtual void on_ruby_wrap ( void );
    
protected: /* OnOffObject C^[tFCX */
    
    /// ANeBuԂωƂ̃Cxgnh
    //gvirtual void on_activate ( stat_t status );
    
public:
    
    /// ]IuWFNg
    struct destination_t
    {
        /// ̍W
        Point2 topleft;
        
        /// E̍W
        Point2 topright;
        
        /// ̍W
        Point2 bottomleft;
        
        /// E̍W
        Point2 bottomright;
        
        /// RXgN^
        destination_t ( void )
        {
        }
        
        /// RXgN^
        /**
         * ẂAォ甽vɎw肵܂B
         */
        destination_t ( const Point2 & tl, const Point2 & tr, const Point2 & br, const Point2 & bl )
                : topleft (tl),
                  topright (tr),
                  bottomleft (bl),
                  bottomright (br)
        {
        }
        
        /// `ւ̕ϊ
        /**
         * ƉE̍W`\z܂B
         * Kꂽ`Ԃ܂B
         */
        Rect2 get_rect ( void ) const
        {
            return Rect2(topleft, bottomright).normalize();
        }
    };
    
public: /* ProjectionInfo C^[tFCX */
    
    /// ]W̐ݒ
    /**
     * w肳ꂽ_̏ ProjectionInfo ۗL]f[^ɃRs[܂B
     * W͍ォ甽vɎw肵܂B
     *
     * @param dest [in] ]
     */
    virtual void set_destination ( const destination_t & dest );
    
    /// ]̈̐ݒ
    /**
     * w肳ꂽ`̏ ProjectionInfo ۗL]`f[^ɃRs[܂B
     */
    virtual void set_source ( const Rect2 & r );
    
    /// ]̈̐ݒ
    /**
     * w肳ꂽXvCg񂩂A]`f[^擾܂B
     * Wł́A`݂̂Rs[܂B
     */
    virtual void set_source ( const SpriteFieldData & sprite );
    
    /// Z W̐ݒ
    /**
     * w肳ꂽ Z W̏ ProjectionInfo ۗL Z Wf[^ɃRs[܂B
     */
    virtual void set_z ( int z );
    
    /// ]F̐ݒ
    /**
     * c  NULL ̏ꍇA]ɐFf[^͎gpȂȂ܂B(NULL ɐݒ肳) 
     * NULL ȊȌꍇAw肳ꂽFf[^ ProjectionInfo ۗLFf[^ɃRs[܂B
     */
    virtual void set_color ( const AlphaColor * c );
    
private:
    
    /// ]̈IuWFNg
    Rect2 rect_src;
    
    /// ]WIuWFNg
    destination_t obj_dest;
    
    /// Z W
    int num_z;
    
    /// ]ɒǉF
    AlphaColor * ptr_color;
    
public:
    
    /// RXgN^
    /**
     * \źA
     *  - ]: (0, 0, 0, 0)
     *  - ]: (0, 0, 0, 0)
     *  - Z W: 0
     *  - ǉF: Ȃ
     * ɂȂĂ܂B
     */
    ProjectionInfo ( void );
    
    /// fXgN^
    virtual ~ProjectionInfo ();
    
    /// ]W̐ݒ
    /**
     * w肳ꂽ`ōWݒ肵܂B
     */
    void set_destination ( const Rect2 & r )
    {
        set_destination(
            destination_t( Point2(r.get_left(), r.get_top()),
                           Point2(r.get_right(), r.get_top()),
                           Point2(r.get_right(), r.get_bottom()),
                           Point2(r.get_left(), r.get_bottom()) )
            );
    }
    
    /// ̓]̈̃Rs[
    /**
     * obj Ŏw肳ꂽ]̈悩
     *  - ]̈
     *  - ]̈
     *  - Z W
     *  - Ff[^
     * Rs[܂B
     */
    void set_projection ( const ProjectionInfo & obj )
    {
        set_destination( obj.get_destination() );
        set_source( obj.get_source() );
        set_z( obj.get_z() );
        set_color( obj.get_color() );
    }
    
    /// ]̈悪ł邩𒲂ׂ
    /**
     * ̓_ƉE̓_vꍇA]̈悪Ƃ݂Ȃ܂B
     */
    bool is_empty ( void ) const
    {
        return obj_dest.topleft == obj_dest.bottomright;
    }
    
    /// ]̎擾
    const destination_t & get_destination ( void ) const
    {
        return obj_dest;
    }
    
    /// ]̈`̎擾
    /**
     * ̓_ƉE̓_`\z܂B
     */
    Rect2 get_destination_rect ( void ) const
    {
        return Rect2(obj_dest.topleft, obj_dest.bottomright);
    }
    
    /// ]`̎擾
    const Rect2 & get_source ( void ) const
    {
        return rect_src;
    }
    
    /// Z W̎擾
    int get_z ( void ) const
    {
        return num_z;
    }
    
    /// ]F̎擾
    /**
     * @retval NULL ]Fݒ肳ĂȂ
     */
    const AlphaColor * get_color ( void ) const
    {
        return ptr_color;
    }
    
};


} /* namespace BK */


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// ]̈̃Xg
/**
 * ]̈gp郌C[̃ReiNXłB
 * ev[g info_t ɂ ProjectionInfo ̃TuNXw肵܂B
 */
template < typename info_t >
class ProjectionInfoArray : public OnOffObjectArray < info_t >
{
public:
    
    /// eNX̌^
    typedef OnOffObjectArray < info_t > parent_t;
    
    /// ]̈̃Xg^
    typedef std::vector < info_t * > list_t;
    
private:
    
    /// ]̈̃Xg
    /** Ɨp̗̈łB */
    list_t ary_sorted_info;
    
    /// IuWFNggp\ł邩𔻕ʂ֐IuWFNg
    class is_active_t
    {
    public:
        bool operator () ( const ProjectionInfo & inf ) const
        {
            return !inf.is_empty();
        }
    };
    
    /// Z \[gZq
    class Z_Less
    {
    public:
        bool operator () ( const ProjectionInfo * const & p1, const ProjectionInfo * const & p2 ) const
        {
            return p1->get_z() > p2->get_z();
        }
    };
    
public:
    
    /// RXgN^
    /**
     * @param infotcap [in] ]̈̏obt@TCY
     * @param vertexcap [in] _f[^̏obt@TCY
     */
    ProjectionInfoArray ( unsigned int infocap )
            : parent_t (infocap)
    {
    }
    
    /// fXgN^
    virtual ~ProjectionInfoArray ()
    {
    }
    
    /// Ruby Kx[WRN^p}[N
    void ruby_gc_mark ( void )
    {
        for_each( RubyObjectMarker() );
    }
    
    /// Ruby bsO
    void on_ruby_wrap ( void )
    {
        for_each( RubyObjectWrapper() );
    }
    
    /// ]̈̃Xg擾
    /**
     * Lȓ]̈AZ W̒l𖳎ăXgɐݒ肵܂B(\[gȂ)
     * nꂽXg̓NAA]̈悪o^܂B
     *
     * @param list [out] ]̈i[郊Xg
     * @return list g
     */
    list_t & get_array ( list_t & list )
    {
        sweep( list, is_active_t() );
        return list;
    }
    
    /// ]̈̃\[g
    /**
     * ]̈ Z Wɂ\[gʂ̃Xg擾܂B
     * Z W傫ɕт܂B
     *
     * @return \[gς݂̓]̈惊Xg
     */
    const list_t & get_sorted_array ( void )
    {
        get_array( ary_sorted_info );
        
        std::sort( ary_sorted_info.begin(), ary_sorted_info.end(), Z_Less() );
        
        return ary_sorted_info;
    }
    
};


} /* namespace BK */


/*   Init/Exit ֐
------------------------------------------------------------------- */
namespace BK {


/// [eBeB̏
void Init_utility_ProjectionInfo ( void );


/// [eBeB̏I
void Exit_utility_ProjectionInfo ( void );


} /* namespace BK */


#endif /* _SCHEMA_UTILITY_PROJECTIONINFO_H_20031211Thu_165300_ */
