/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - OtBbN - C[ - tBC[
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: OtBbN: C[: tBC[
 *
 * ̈̓hԂs߂̓]C[`܂B
 *
 * @author ABE Shigeru
 * @date 2003/12/14
 */
#ifndef _SCHEMA_GRAPHIC_LAYER_FILLLAYER_H_20031214Sun_180850_
#define _SCHEMA_GRAPHIC_LAYER_FILLLAYER_H_20031214Sun_180850_


/*   NX̒`
------------------------------------------------------------------- */
namespace BK {


/// tBC[
/**
 * XN[̓̈hԂ߂̃C[łB
 * ]̈o^邱ƂɂAhԂ̈ݒ肷邱Ƃo܂B
 * ̃C[ŁÄ̗𓯎ɓhԂƂ\łB
 */
class FillLayer : public ProjectionLayer
{
public:
    
    /// eNX
    typedef ProjectionLayer parent_t;
    
private: /* static ϐ */
    
    /// Ruby NX: FillLayer
    static VALUE ruby_class_object;
    
public: /* static \bh */
    
    /// Ruby NX擾
    static VALUE get_ruby_class ( void );
    
    /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
    static bool is_kind_of ( VALUE obj )
    {
        return xrb_is_kind_of(obj, get_ruby_class());
    }
    
    /// Ruby IuWFNgIuWFNgɕϊ
    static FillLayer * value_to_data ( VALUE obj )
    {
        return ruby_basecast< FillLayer, RubyObject >( obj );
    }
    
protected: /* RubyObject C^[tFCX */
    
    /// Ruby NXIuWFNg擾
    virtual VALUE get_ruby_class_object ( void ) const
    {
        return get_ruby_class();
    }
    
public: /* RubyObject C^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    //virtual void ruby_gc_mark ( void );
    
    /// Kx[WRNg̃ObZ[Wo̓tO擾
    //virtual bool is_ruby_gc_log_enabled ( void ) const;
    
    /// Ruby inspect \bh
    //virtual char * ruby_inspect ( char * buf, unsigned int cap ) const;
    
    /// Ruby IuWFNgɂ郉bsOCxg
    //virtual void on_ruby_wrap ( void );
    
public: /* Layer C^[tFCX */
    
    /// `Cxg
    virtual void execute ( GraphicDevice * dev ) = 0;
    
public: /* ProjectionLayer C^[tFCX */
    
    /// ]̈̓o^
    virtual ProjectionInfo * register_projection ( void ) = 0;
    
    /// ]̈̍폜
    virtual void delete_projection ( ProjectionInfo * ptr ) = 0;
    
    /// o^Ă]̈̐擾
    virtual unsigned int count_projection ( void ) const = 0;
    
public:
    
    /// RXgN^
    FillLayer ( void );
    
    /// fXgN^
    virtual ~FillLayer ();
    
};


} /* namespace BK */


/*   Init/Exit ֐
------------------------------------------------------------------- */
namespace BK {


/// OtBbNfoCXEC[̏
void Init_graphic_layer_FillLayer ( void );


/// OtBbNfoCXEC[̏I
void Exit_graphic_layer_FillLayer ( void );


} /* namespace BK */


#endif /* _SCHEMA_GRAPHIC_LAYER_FILLLAYER_H_20031214Sun_180850_ */
