/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - [eBeB - tB
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: [eBeB: tB
 *
 * At@݂̂i[v[\tB`܂B
 *
 * @author ABE Shigeru
 * @date 2003/12/11
 */
#ifndef _SCHEMA_UTILITY_FILM_H_20031211Thu_092138_
#define _SCHEMA_UTILITY_FILM_H_20031211Thu_092138_


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// tB
/**
 * At@lɂrbg}bvC[W\܂B
 * ̃IuWFNǵAFf[^܂B
 * O^ꂽFf[^ƁAC[WAt@lgĕ`s܂B
 *
 * esNZ 0 ȏ COLOR_ELEMENT_MAX ȉ̒l܂B
 */
class Film : public RubyObject
{
public:
    
    /// eNX
    typedef RubyObject parent_t;
    
private: /* static ϐ */
    
    /// Ruby NX: Film
    static VALUE ruby_class_object;
    
public: /* static \bh */
    
    /// Ruby NX擾
    static VALUE get_ruby_class ( void );
    
    /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
    static bool is_kind_of ( VALUE obj )
    {
        return xrb_is_kind_of(obj, get_ruby_class());
    }
    
    /// Ruby IuWFNgIuWFNgɕϊ
    static Film * value_to_data ( VALUE obj )
    {
        return ruby_basecast< Film, RubyObject >( obj );
    }
    
protected: /* RubyObject C^[tFCX */
    
    /// Ruby NXIuWFNg擾
    VALUE get_ruby_class_object ( void ) const
    {
        return get_ruby_class();
    }
    
public: /* RubyObject C^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    //virtual void ruby_gc_mark ( void );
    
    /// Kx[WRNg̃ObZ[Wo̓tO擾
    virtual bool is_ruby_gc_log_enabled ( void ) const
    {
        return false;
    }
    
    /// Ruby inspect \bh
    //virtual char * ruby_inspect ( char * buf, unsigned int cap ) const;
    
    /// Ruby IuWFNgɂ郉bsOCxg
    //virtual void on_ruby_wrap ( void );
    
public:
    
    /// rbg}bṽsNZɎg^
    typedef Color::element_t pixel_t;
    
private:
    
    /// tB̃TCY
    Size2 size_image;
    
    /// rbg}bvC[W
    pixel_t * ary_image;
    
    /// wʒuɑΉrbg}bvC[W̃ItZbgAhX擾
    unsigned int at_image_offset ( Point2 const & p ) const
    {
        return p.get_x() + size_image.get_width() * p.get_y();
    }
    
public:
    
    /// RXgN^
    /**
     * w肳ꂽTCYŃC[W𐶐܂B
     * Ԃł́AȃtBłB
     *
     * @param size [in] C[W̃TCY
     */
    Film ( const Size2 & size );
    
    /// RXgN^
    /**
     * w肳ꂽC[WtB𐶐܂B
     * size ɂ\zAset_image() ɂ菉̂ƓlłB
     *
     * @param size [in] C[W̃TCY
     * @param img [in] C[W (size ̖ʐςƓTCY)
     */
    Film ( const Size2 & size, const pixel_t * img );
    
    /// fXgN^
    virtual ~Film ();
    
    /// C[W̃TCY擾
    const Size2 & get_size ( void ) const
    {
        return size_image;
    }
    
    /// C[W̃TCYݒ肷
    /**
     * g啔͓F (0) Ŗ߂܂B
     * ̃\bh͎iKłBKv΁A폜܂B
     *
     * @param s [in] VC[W̃TCY
     */
    void set_size ( const Size2 & s );
    
    /// rbg}bvC[W擾
    /**
     * @return C[W̍p|C^
     */
    const pixel_t * get_image ( void ) const
    {
        return ary_image;
    }
    
    /// rbg}bvC[W擾
    /**
     * @param p [in] C[W̍W
     * @return C[W̎wW|C^
     */
    const pixel_t * get_image ( const Point2 & p ) const
    {
        return ary_image + (p.get_x() + size_image.get_width() * p.get_y());
    }
    
    /// rbg}bvC[W擾
    /**
     * C[WɂAw肳ꂽ_AhX擾܂B
     *
     * @param p [in] C[W̍W
     * @return C[W̎wW|C^
     */
    const pixel_t * at ( const Point2 & p ) const
    {
        return get_image(p);
    }
    
    /// rbg}bvC[W̐ݒ
    /**
     * rbg}bvC[W̐ݒs܂B
     * img  r ̖ʐςƓTCYłȂ΂Ȃ܂B
     *
     * @param img [in] ݒ肷C[W
     * @param r [in] (Kς݂) ݒ̈
     */
    void set_image ( const pixel_t * img, const Rect2 & r );
    
};


} /* namespace BK */


/*   Init/Exit ֐
------------------------------------------------------------------- */
namespace BK {


/// [eBeB̏
void Init_graphic_Film ( void );


/// [eBeB̏I
void Exit_graphic_Film ( void );


} /* namespace BK */


#endif /* _SCHEMA_UTILITY_FILM_H_20031211Thu_092138_ */
