/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - OtBbN - C[ - tBC[
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: OtBbN: C[: tBC[
 *
 * tBgp]C[`܂B
 *
 * @author ABE Shigeru
 * @date 2003/12/27
 */
#ifndef _SCHEMA_GRAPHIC_LAYER_FILMLAYER_H_20031227Sat_210213_
#define _SCHEMA_GRAPHIC_LAYER_FILMLAYER_H_20031227Sat_210213_


/*   NX̒`
------------------------------------------------------------------- */
namespace BK {


/// tBC[
/**
 * XN[̓ʒuɃtB]邽߂̃C[łB
 * 擾]̈̏邱ƂŁA]ʒuȂǂύX܂B
 */
class FilmLayer : public ProjectionLayer
{
public:
    
    /// eNX
    typedef ProjectionLayer parent_t;
    
private: /* static ϐ */
    
    /// Ruby NX: FilmLayer
    static VALUE ruby_class_object;
    
public: /* static \bh */
    
    /// Ruby NX擾
    static VALUE get_ruby_class ( void );
    
    /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
    static bool is_kind_of ( VALUE obj )
    {
        return xrb_is_kind_of(obj, get_ruby_class());
    }
    
    /// Ruby IuWFNgIuWFNgɕϊ
    static FilmLayer * value_to_data ( VALUE obj )
    {
        return ruby_basecast< FilmLayer, RubyObject >( obj );
    }
    
protected: /* RubyObject C^[tFCX */
    
    /// Ruby NXIuWFNg擾
    virtual VALUE get_ruby_class_object ( void ) const
    {
        return get_ruby_class();
    }
    
public: /* RubyObject C^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    virtual void ruby_gc_mark ( void );
    
    /// Kx[WRNg̃ObZ[Wo̓tO擾
    //virtual bool is_ruby_gc_log_enabled ( void ) const;
    
    /// Ruby inspect \bh
    //virtual char * ruby_inspect ( char * buf, unsigned int cap ) const;
    
    /// Ruby IuWFNgɂ郉bsOCxg
    virtual void on_ruby_wrap ( void );
    
public: /* Layer C^[tFCX */
    
    /// `Cxg
    virtual void execute ( GraphicDevice * dev );
    
public: /* ProjectionLayer C^[tFCX */
    
    /// ]̈̓o^
    virtual ProjectionInfo * register_projection ( void );
    
    /// ]̈̍폜
    virtual void delete_projection ( ProjectionInfo * ptr );
    
    /// o^Ă]̈̐擾
    virtual unsigned int count_projection ( void ) const;
    
public:
    
    /// tBC[p̓]̈
    class info_t : public ProjectionInfo
    {
    public:
        
        /// eNX
        typedef ProjectionInfo parent_t;
        
    private: /* static ϐ */
        
        /// Ruby NX: FilmLayer::ProjectionInfo
        static VALUE ruby_class_object;
        
    public: /* static \bh */
        
        /// Ruby NX擾
        static VALUE get_ruby_class ( void );
        
        /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
        static bool is_kind_of ( VALUE obj )
        {
            return xrb_is_kind_of(obj, get_ruby_class());
        }
        
        /// Ruby IuWFNgIuWFNgɕϊ
        static info_t * value_to_data ( VALUE obj )
        {
            return ruby_basecast< info_t, RubyObject >( obj );
        }
        
    protected: /* RubyObject C^[tFCX */
        
        /// Ruby NXIuWFNg擾
        virtual VALUE get_ruby_class_object ( void ) const
        {
            return get_ruby_class();
        }
        
    public: /* RubyObject C^[tFCX */
        
        /// Ruby Kx[WRNgp}[N
        virtual void ruby_gc_mark ( void );
        
        /// Kx[WRNg̃ObZ[Wo̓tO擾
        //virtual bool is_ruby_gc_log_enabled ( void ) const;
        
        /// Ruby inspect \bh
        //virtual char * ruby_inspect ( char * buf, unsigned int cap ) const;
        
        /// Ruby IuWFNgɂ郉bsOCxg
        virtual void on_ruby_wrap ( void );
        
    public:
        
        /// eNX̌^
        typedef ProjectionInfo parent_t;
        
    private:
        
        /// ]ɎgptBIuWFNg
        Film * ptr_film;
        
    public:
        
        /// RXgN^
        info_t ( void );
        
        /// tB擾
        Film * get_film ( void ) const
        {
            return ptr_film;
        }
        
        /// gptBݒ肷
        virtual void set_film ( Film * film );
        
    };
    
    /// ]̈惊Xǧ^
    typedef ProjectionInfoArray < info_t > list_t;
    
private:
    
    /// ]̈̃Xg
    list_t obj_list;
    
    /// tBC[̍ƗpC[W
    Image * ptr_image;
    
private:
    
    /// XN[̃LoXgp execute 
    /**
     * ]ɎԂ炵AȂᑬB
     */
    void execute_by_canvas ( GraphicDevice * dev );
    
    /// ImageLayer gp execute 
    void execute_by_ImageLayer ( GraphicDevice * dev );
    
public:
    
    /// RXgN^
    FilmLayer ( void );
    
    /// fXgN^
    virtual ~FilmLayer ();
    
};


} /* namespace BK */


/*   Init/Exit ֐
------------------------------------------------------------------- */
namespace BK {


/// OtBbNfoCXEC[̏
void Init_graphic_layer_FilmLayer ( void );


/// OtBbNfoCXEC[̏I
void Exit_graphic_layer_FilmLayer ( void );


} /* namespace BK */


#endif /* _SCHEMA_GRAPHIC_LAYER_FILMLAYER_H_20031227Sat_210213_ */
