/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - OtBbN - tHg
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: OtBbN: tHg
 *
 * tHgƕ̏񋟂܂B
 *
 * @author ABE Shigeru
 * @date 2003/12/11
 */
#ifndef _SCHEMA_GRAPHIC_FONT_H_20031211Thu_092550_
#define _SCHEMA_GRAPHIC_FONT_H_20031211Thu_092550_


/*   ^錾
------------------------------------------------------------------- */
namespace BK {


class Glyph;
class Font;


} /* namespace BK */


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// IuWFNg
/**
 * tHg\镶vf\IuWFNgłB
 *
 * ̃rbg}bvp^[́Amg[rbg}bvŕ\܂B
 * esNZ͐F\AAt@\܂B
 */
class Glyph : public RubyObject
{
public:
    
    /// eNX
    typedef RubyObject parent_t;
    
private: /* static ϐ */
    
    /// Ruby NX: Glyph
    static VALUE ruby_class_object;
    
public: /* static \bh */
    
    /// Ruby NX擾
    static VALUE get_ruby_class ( void );
    
    /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
    static bool is_kind_of ( VALUE obj )
    {
        return xrb_is_kind_of(obj, get_ruby_class());
    }
    
    /// Ruby IuWFNgIuWFNgɕϊ
    static Glyph * value_to_data ( VALUE obj )
    {
        return ruby_basecast< Glyph, RubyObject >( obj );
    }
    
protected: /* RubyObject C^[tFCX */
    
    /// Ruby NXIuWFNg擾
    virtual VALUE get_ruby_class_object ( void ) const
    {
        return get_ruby_class();
    }
    
public: /* RubyObject C^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    virtual void ruby_gc_mark ( void );
    
    /// Kx[WRNg̃ObZ[Wo̓tO擾
    virtual bool is_ruby_gc_log_enabled ( void ) const
    {
        return false;
    }
    
    /// Ruby inspect \bh
    virtual char * ruby_inspect ( char * buf, unsigned int cap ) const;
    
    /// Ruby IuWFNgɂ郉bsOCxg
    virtual void on_ruby_wrap ( void );
    
public:
    
    /// ABC 
    struct ABC_t
    {
        /// ̍ItZbg
        int a;
        
        /// Iȕ̉
        unsigned int b;
        
        /// ̉EItZbg
        int c;
        
        /// RXgN^
        ABC_t ( int pa, unsigned int pb, int pc )
                : a (pa), b (pb), c (pc)
        {
        }
    };
    
private:
    
    /// ̃IuWFNg̕\
    const std::string str_character;
    
    /// ̕ ABC 
    const ABC_t obj_abc;
    
    /// rbg}bvC[W
    Film * const ptr_image;
    
public:
    
    /// RXgN^
    /**
     * nꂽtBIuWFNǵARuby IuWFNgŃbsOĂKv܂B
     * 
     * @param str [in] IuWFNg
     * @param img [in] rbg}bvC[W
     * @param abc [in] tHg̈ʒu
     */
    Glyph ( const char * str, Film * img, const ABC_t & abc );
    
    /// fXgN^
    virtual ~Glyph ();
    
    /// ̃IuWFNg\擾
    const char * get_character ( void ) const
    {
        return str_character.c_str();
    }
    
    /// ̃IuWFNg\擾
    const std::string & get_character_string ( void ) const
    {
        return str_character;
    }
    
    /// ̃TCY擾
    /**
     * ]܂߂TCY擾܂B
     */
    const Size2 & get_size ( void ) const
    {
        return ptr_image->get_size();
    }
    
    /// rbg}bvC[W擾
    /**
     * rbg}bv̊esNZ̓At@ (0 ` 255) \܂B
     *
     * @return C[W̍p|C^
     */
    const Film::pixel_t * get_image ( void ) const
    {
        return ptr_image->get_image();
    }
    
    /// tBIuWFNg擾
    Film * get_film ( void )
    {
        return ptr_image;
    }
    
    ///  ABC 擾
    const ABC_t & get_ABC ( void ) const
    {
        return obj_abc;
    }
    
};


/// tHg
/**
 * tHg\IuWFNgłB
 * 쐬łtHg͊ɂĈقȂ܂B
 */
class Font : public RubyObject
{
public:
    
    /// eNX
    typedef RubyObject parent_t;
    
private: /* static ϐ */
    
    /// Ruby NX: Font
    static VALUE ruby_class_object;
    
public: /* static \bh */
    
    /// Ruby NX擾
    static VALUE get_ruby_class ( void );
    
    /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
    static bool is_kind_of ( VALUE obj )
    {
        return xrb_is_kind_of(obj, get_ruby_class());
    }
    
    /// Ruby IuWFNgIuWFNgɕϊ
    static Font * value_to_data ( VALUE obj )
    {
        return ruby_basecast< Font, RubyObject >( obj );
    }
    
protected: /* Ruby IuWFNgpC^[tFCX */
    
    /// Ruby NXIuWFNg擾
    virtual VALUE get_ruby_class_object ( void ) const
    {
        return get_ruby_class();
    }
    
public: /* Ruby IuWFNgpC^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    //virtual void ruby_gc_mark ( void );
    
    /// Ruby inspect \bh
    //virtual char * ruby_inspect ( char * buf, unsigned int cap ) const;
    
public: /* Font C^[tFCX */
    
    /// gptHg擾
    /**
     * ԂtHg͊ˑłB
     * tHgf[^x[Xɓo^閼Oł͂Ȃ̂ŒӂĂB
     *
     * @return tHg
     */
    virtual const char * get_font_name ( void ) const = 0;
    
    /// R[h̎擾
    /**
     * str œnꂽ̐擪ꕶAR[hlɕϊ܂B
     * Ԃ镶R[h͊ɂĈقȂAPɘÂƂ͌܂B
     *
     * XL[}ZNVł́AnbVL[ƂĎgp܂B
     *
     * @param str [in] 
     * @return R[h
     */
    virtual unsigned int get_charcode ( const char * str ) const = 0;
    
    /// Ot𐶐
    /**
     * nꂽ񂩂OtIuWFNg𐶐܂B
     *
     * str œnꂽ̐擪ꕶgp܂B
     * ǂݍ񂾕̒́AԂOt擾ĂB
     *
     * Ot쐬łȂꍇ argument_exception O܂B
     *
     * @param str [in] Ot\ (擪ꕶgp)
     * @return ꂽOt (new ꂽIuWFNg)
     * @retval NULL ΉOt݂Ȃ (䕶Ȃ)
     */
    virtual Glyph * create_glyph ( const char * str ) = 0;
    
    /// w肳ꂽ̃TCY擾
    /**
     * ͍̂ŏ̈ꕶ݂̂łB
     *
     * @param str [in] ׂ镶 (擪ꕶgp)
     * @return Ot̃TCY
     */
    virtual Size2 query_size ( const char * str ) = 0;
    
public:
    
    /// tHg
    struct info_t
    {
        /// tHg̑\l^
        typedef int weight_t;
        
        /// tHg
        std::string font_name;
        
        /// tHg̍
        /**
         * sNZPʂ̃TCY () w肵܂B
         * 0 ̓ftHg̃TCY܂B
         */
        int font_height;
        
        /// v|[VitHg
        /**
         * tHgłꍇ false ɂȂ܂B
         * ftHg false łB
         */
        bool is_proportional;
        
        /// tHg̑
        /**
         * CSS ȂǂƓ悤 0  1000 ܂ł̐lŕ\܂B
         *
         * - Ql
         *   - 0: ftHg
         *   - 400: W
         *   - 700: {[h
         */
        weight_t font_weight;
        
        /// C^bNtHg
        bool is_italic;
        
        /// X^tHgD悷
        /**
         * ftHg false łB
         */
        bool is_raster_prior;
        
        /// RXgN^
        info_t ( void );
    };
    
protected:
    
    /// RXgN^
    Font ( void );
    
public:
    
    /// fXgN^
    virtual ~Font ();
    
    /// w肳ꂽɑΉf[^擾
    /**
     * create_glyph() ƓlłÃ\bh͐OtLbV܂B
     * łɓLbVɑ݂ꍇ́ALbVOtԂ܂B
     *
     * @param str [in] Ot\ (擪ꕶgp)
     * @return IuWFNg
     * @retval NULL ɑΉOt݂Ȃ (䕶Ȃ)
     */
    Glyph * get_glyph ( const char * str );
    
};


/// tHgf[^x[X
/**
 * ꂽtHgIuWFNg~Ă߂̃f[^x[XIuWFNgłB
 * tHg ([U[閼O) ɂAtHgIuWFNgǗ邱Ƃł܂B
 *
 * ܂AtHgOt̃LbV܂B
 */
class FontDatabase
{
private: /* static ϐ */
    
    /// Singleton IuWFNg
    static FontDatabase * singleton_object;
    
public: /* static \bh */
    
    /// Singleton IuWFNg̎擾
    static FontDatabase * get_instance ( void )
    {
        return singleton_object;
    }
    
public:
    
    /// OtLbVp̃L[
    class key_t
    {
    private:
        
        /// OtێtHgIuWFNg
        const Font * const ptr_font;
        
        /// R[h
        /** OtɑΉ镶R[h\܂B */
        const unsigned int num_code;
        
    public:
        
        /// RXgN^
        key_t ( const Font & font, const char * str )
                : ptr_font (&font),
                  num_code (font.get_charcode(str))
        {
        }
        
        /// RXgN^
        key_t ( const Font & font, unsigned int code )
                : ptr_font (&font),
                  num_code (code)
        {
        }
        
        /// QƂĂtHg擾
        const Font * get_font ( void ) const
        {
            return ptr_font;
        }
        
        /// Ot\̃R[h擾
        const unsigned int get_code ( void ) const
        {
            return num_code;
        }
        
        /// rZq
        bool operator < ( const key_t & rhs ) const
        {
            if( get_code() == rhs.get_code() ) {
                return get_font() < rhs.get_font();
            }
            return get_code() < rhs.get_code();
        }
        
        /// rZq
        bool operator == ( const key_t & rhs ) const
        {
            return (get_font() == rhs.get_font()) && (get_code() == rhs.get_code());
        }
    };
    
    /// LbVXg̗vf
    class elem_t : public key_t
    {
    private:
        
        /// L[ɑΉOt
        Glyph * const ptr_glyph;
        
    public:
        
        /// RXgN^
        elem_t ( const key_t & key, Glyph * glyph )
                : key_t (key),
                  ptr_glyph (glyph)
        {
        }
        
        /// 蓖ĂĂOt擾
        Glyph * get_glyph ( void ) const
        {
            return ptr_glyph;
        }
        
    };
    
    /// tHg}bv̌^
    typedef std::map < std::string, Font * > fontmap_t;
    
    /// LbVXǧ^
    typedef std::list < elem_t > cachelist_t;
    
private:
    
    /// tHg}bv
    fontmap_t map_font;
    
    /// OtLbV
    cachelist_t ary_cache;
    
    /// OtLbV̍őTCY
    /** ftHg 1024 łB */
    unsigned int num_cache_size;
    
    /// 
    /** get_glyph() Ăяoꂽ񐔂L^܂B */
    unsigned int num_search_total;
    
    /// LbVqbg
    /** tHgŃLbVɃqbg񐔂L^܂B */
    unsigned int num_hit_total;
    
public:
    
    /// RXgN^
    FontDatabase ( void );
    
    /// fXgN^
    ~FontDatabase ();
    
    /// Ruby Kx[WRNgp}[N
    void ruby_gc_mark ( void );
    
    /// tHg̓o^
    /**
     * w肳ꂽtHgIuWFNgւ̎QƂo^܂B
     *
     * łɓ̃tHgo^ĂꍇAw肳ꂽtHgŏ㏑܂B
     *
     * @param name [in] tHg
     * @param font [in] o^tHgIuWFNg
     */
    void add_font ( const char * name, Font & font );
    
    /// tHg̍폜
    /**
     * o^ĂtHg폜܂B
     * tHgIuWFNĝ폜킯ł͂܂B
     *
     * @param font [in] 폜tHg
     * @return 폜ꂽtHgIuWFNg
     * @exception argument_exception w肳ꂽtHg͓o^ĂȂ
     */
    Font * erase_font ( const char * name );
    
    /// Ot̎擾
    /**
     * f[^x[XLbVĂOt擾܂B
     * LbVɃOtȂꍇ́AtHgOt܂B
     *
     * @param font [in] Ot̃tHg
     * @paran str [in] Ot̕ (擪̈ꕶg܂)
     * @return OtIuWFNg
     * @retval NULL 󕶎񂪓nꂽ
     * @exception argument_exception NULL nꂽ
     */
    Glyph * get_glyph ( Font & font, const char * str );
    
    /// LbVTCY擾
    unsigned int get_cache_size ( void ) const
    {
        return num_cache_size;
    }
    
    /// LbVTCYݒ肷
    void set_cache_size ( unsigned int n );
    
    /// LbVqbg擾
    /**
     * p[ZgPʂŕԂ܂B
     *
     * @return LbVqbg
     */
    double get_cache_hit_percent ( void ) const
    {
        if( num_hit_total == 0 ) {
            return 0.0;
        }
        return static_cast< double >(num_hit_total * 100) / num_search_total;
    }
    
};


} /* namespace BK */


/*   CN[h
------------------------------------------------------------------- */
#include "gd_GlyphLayout.h"


/*   Init/Exit ֐
------------------------------------------------------------------- */
namespace BK {


/// tHgNX̏
void Init_graphic_Font ( void );


/// tHgNX̏I
void Exit_graphic_Font ( void );


} /* namespace BK */


#endif /* _SCHEMA_GRAPHIC_FONT_H_20031211Thu_092550_ */
