/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - [eBeB - CAEg
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: [eBeB: CAEg
 *
 * IuWFNgۗLALN^CAEgNX`܂B
 *
 * @author ABE Shigeru
 * @date 2004/01/24
 */
#ifndef _SCHEMA_GRAPHIC_GLYPHLAYOUT_H_20040124Sat_215749_
#define _SCHEMA_GRAPHIC_GLYPHLAYOUT_H_20040124Sat_215749_


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// LN^CAEg
/**
 * ̃CAEgIuWFNǵAꕶ̃CAEg\܂B
 * xCAEgAeLXgCAEgȂǂŎgp܂B
 */
class GlyphLayout : public CharLayout
{
public:
    
    /// eNX
    typedef CharLayout parent_t;
    
private: /* static ϐ */
    
    /// Ruby NX: GlyphLayout
    static VALUE ruby_class_object;
    
public: /* static \bh */
    
    /// Ruby NX擾
    static VALUE get_ruby_class ( void );
    
    /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
    static bool is_kind_of ( VALUE obj )
    {
        return xrb_is_kind_of(obj, get_ruby_class());
    }
    
    /// Ruby IuWFNgIuWFNgɕϊ
    static GlyphLayout * value_to_data ( VALUE obj )
    {
        return ruby_basecast< GlyphLayout, Layout >( obj );
    }
    
protected: /* RubyObject C^[tFCX */
    
    /// Ruby NXIuWFNg擾
    virtual VALUE get_ruby_class_object ( void ) const
    {
        return get_ruby_class();
    }
    
public: /* RubyObject C^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    virtual void ruby_gc_mark ( void );
    
    /// Kx[WRNg̃ObZ[Wo̓tO擾
    //virtual bool is_ruby_gc_log_enabled ( void ) const;
    
    /// Ruby inspect \bh
    char * ruby_inspect ( char * buf, unsigned int cap ) const;
    
    /// Ruby IuWFNgɂ郉bsOCxg
    virtual void on_ruby_wrap ( void );
    
public: /* Layout C^[tFCX */
    
    /// vf̍XV
    //virtual bool update ( void );
    
    /// CAEg̈ړ
    //virtual void on_move_layout ( const Point2 & delta );
    
private:
    
    /// ۗL镶IuWFNg
    Glyph * ptr_glyph;
    
public:
    
    /// RXgN^
    GlyphLayout ( void );
    
    /// fXgN^
    virtual ~GlyphLayout ();
    
    /// ݒ肳ꂽIuWFNg擾
    /**
     * @retval NULL IuWFNgݒ肳ĂȂ
     */
    Glyph * get_glyph ( void ) const
    {
        return ptr_glyph;
    }
    
    /// CAEgɕIuWFNgݒ肷
    /**
     * CAEg̃TCÝAIuWFNgƓɒ߂܂B
     * NULL w肵ꍇ́ACAEgƕIuWFNg̊֘A菜܂B
     *
     * @param glyph [in] ݒ肷IuWFNg
     */
    void set_glyph ( Glyph * glyph );
    
};


} /* namespace BK */


/*   Init/Exit ֐
------------------------------------------------------------------- */
namespace BK {


/// [eBeB̏
void Init_graphic_GlyphLayout ( void );


/// [eBeB̏I
void Exit_graphic_GlyphLayout ( void );


} /* namespace BK */


#endif /* _SCHEMA_GRAPHIC_GLYPHLAYOUT_H_20040124Sat_215749_ */
