/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - OtBbNfoCX
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: OtBbNfoCX
 *
 * OtBbN@\񋟂foCX̃NX`܂B
 *
 * @author ABE Shigeru
 * @date 2003/12/19
 */
#ifndef _SCHEMA_GRAPHIC_GRAPHICDEVICE_H_20031219Fri_095027_
#define _SCHEMA_GRAPHIC_GRAPHICDEVICE_H_20031219Fri_095027_


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// OtBbNfoCX
/**
 * OtBbN@\񋟂foCXłB
 * قڂׂĂ̋@\TuNXŎ܂B
 *
 * AvP[VfoCX\złȂ΁A\zł܂B
 */
class GraphicDevice : public ServiceDevice
{
public:
    
    /// eNX
    typedef ServiceDevice parent_t;
    
private: /* static ϐ */
    
    /// Singleton IuWFNg
    static GraphicDevice * singleton_object;
    
    /// tXN[NtO
    static bool flag_initial_fullscreen;
    
public: /* static \bh */
    
    /// \zꂽAvP[VfoCX擾
    static GraphicDevice * get_instance ( void )
    {
        return singleton_object;
    }
    
    /// tXN[NtO擾
    static bool is_initial_fullscreen ( void )
    {
        return flag_initial_fullscreen;
    }
    
    /// tXN[NtOݒ肷
    static void set_initial_fullscreen ( bool flag )
    {
        flag_initial_fullscreen = flag;
    }
    
protected: /* ServiceDevice C^[tFCX */
    
    /// foCX̊Jn
    virtual void _start ( void );
    
    /// foCX̏I
    virtual void _stop ( void );
    
public: /* ServiceDevice C^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    virtual void ruby_gc_mark ( void );
    
    /// foCX̎擾
    virtual const char * get_device_name ( void ) const;
    
public: /* GraphicDevice C^[tFCX */
    
    /// XN[̍XV
    /**
     * obNobt@tgXN[ɓ]܂B
     * ̃\bhł́AC[̃_O͍s܂B
     * pNXł́Ae update_screen() ̌ĂяoYꂸɍsĂB
     */
    virtual void update_screen ( void );
    
    /// obNobt@\LoX̎擾
    /**
     * obNobt@̎w肳ꂽ̈\ALoXIuWFNg𐶐܂B
     * NULL w肳ꂽꍇ́AobNobt@̑Sʂgp܂B
     *
     * gp delete ܂ close_canvas() ŃIuWFNgKv܂B
     * ȂꍇAXN[̍XVsƂłȂ\܂B
     * ܂AłɃLoXĂꍇÃ\bh͎s܂B
     *
     * @param area [in] LoXɊ蓖ĂobNobt@̗̈
     * @return ꂽLoXIuWFNg
     */
    virtual Canvas * create_canvas ( Rect2 const * area = NULL ) = 0;
    
    /// XN[̃tB
    /**
     * SʂwFœhԂ܂B
     *
     * @param color [in] hԂF
     */
    virtual void fill_screen ( Color const & color ) = 0;
    
    /// XN[̎ẅtB
    /**
     * ʂ̂Aw肳ꂽ̈hԂ܂B
     *
     * @param r [in] hԂ̈
     * @param color [in] hԂF
     */
    virtual void fill_screen ( Rect2 const & r, Color const & color ) = 0;
    
    /// XN[ɃsN`]
    /**
     * ʂ̎w肳ꂽʒuɁAsN`̎ẅ]܂B
     * rect  NULL w肳ꂽꍇ̓sN`̑Sʂgp܂B
     * rbgRs[s܂B
     *
     * @param p [in] ]ʒu
     * @param pict [in] ]sN`
     * @param rect [in] sN`̓]̈
     */
    virtual void blit_picture ( Point2 const & p, Picture * pict, const Rect2 * rect = NULL ) = 0;
    
    /// XN[ɃC[W]
    /**
     * C[W̉摜Aw肳ꂽ]̈ɏ]ĉʂɕ`悵܂B
     * At@ufBOs܂B
     */
    //virtual void draw_image ( Image * img, ProjectionInfo * * info, unsigned int len ) = 0;
    
    /// ̃sN`𐶐
    /**
     * ܂ĂȂsN`\z܂B
     * sN`́Â܂܃XN[ɓ]ł`ɂȂACɔzu܂B
     *
     * ԂꂽsN`IuWFNǵAgI delete Ȃ΂Ȃ܂B
     *
     * @return VꂽsN`IuWFNg
     */
    virtual Picture * create_picture ( const Size2 & size ) = 0;
    
    /// t@CsN`[h
    /**
     * t@C̃f[^ǂݍ (T|[g`͎ɂĈقȂ܂)AsN`\z܂B
     * [hsN`́Â܂܃XN[ɓ]ł`ɂȂAVXeɔzu܂B
     *
     * ԂꂽsN`IuWFNǵAgI delete Ȃ΂Ȃ܂B
     *
     * @return VꂽsN`IuWFNg
     */
    virtual Picture * load_picture_from_file ( const char * filename ) = 0;
    
    /// ̃t@CsN`[h
    /**
     * ̃f[^AsN`\z܂B
     * {Iɂ load_picture_from_file() ƓlłB
     * 
     * @see load_picture_from_file()
     */
    virtual Picture * load_picture_from_memory ( void const * src, unsigned int cap ) = 0;
    
    /// ̃C[W𐶐
    /**
     * ܂ĂȂC[W\z܂B
     * C[ẂAVRAM ɔzu܂B
     *
     * ԂꂽC[WIuWFNǵAgI delete Ȃ΂Ȃ܂B
     *
     * @return VꂽC[WIuWFNg
     */
    virtual Image * create_image ( const Size2 & size ) = 0;
    
    /// t@CC[W[h
    /**
     * C[Wǂݍ load_picture_from_file() łB
     * C[ẂAVRAM ɔzu܂B
     *
     * @return VꂽsN`IuWFNg
     */
    virtual Image * load_image_from_file ( const char * filename ) = 0;
    
    /// ̃t@CC[W[h
    /**
     * ̃f[^AC[W\z܂B
     * {Iɂ load_image_from_file() ƓlłB
     * 
     * @see load_image_from_file()
     */
    virtual Image * load_image_from_memory ( void const * src, unsigned int cap ) = 0;
    
    /// ̃sN`f[^𐶐
    /**
     * @see create_picture()
     */
    virtual PictureData * create_picture_data ( const Size2 & size ) = 0;
    
    /// t@CsN`f[^[h
    /**
     * @see load_picture_from_file()
     */
    virtual PictureData * load_picture_data_from_file ( const char * filename ) = 0;
    
    /// ̃t@CsN`f[^[h
    /**
     * @see load_picture_from_memory()
     */
    virtual PictureData * load_picture_data_from_memory ( void const * src, unsigned int cap ) = 0;
    
private:
    
    /// C[Xg
    /** CXN[Ɏgp郌C[̃XgłB */
    LayerArray * ptr_layer_array;
    
    /// XN[XVJE^
    /**
     * update_screen() s邽т 1 ܂B
     */
    unsigned int num_screen_update_counter;
    
public:
    
    /// RXgN^
    GraphicDevice ( void );
    
    /// fXgN^
    virtual ~GraphicDevice ();
    
    /// C[Xg̐ݒ
    /**
     * @return ȑOɐݒ肳ĂC[Xg
     */
    LayerArray * set_layer_array ( LayerArray * ptr );
    
    /// C[Xg̎擾
    LayerArray * get_layer_array ( void ) const
    {
        return ptr_layer_array;
    }
    
    /// XN[̕`
    /**
     * ׂẴC[ɃbZ[W𑗂AXN[̕` (obNobt@) s܂B
     * XN[̓]͊܂܂܂BKvɉ update_screen() sĂB
     */
    void broadcast ( void );
    
    /// ݂̃XN[XV񐔂擾
    /**
     * VXeJnĂ update_screen() Ăяoꂽ񐔂擾܂B
     * unsigned int 𒴂ꍇAJEg 0 ɖ߂܂B
     */
    unsigned int get_screen_update_count ( void ) const
    {
        return num_screen_update_counter;
    }
    
    /// XN[TCY擾
    /**
     * AvP[V̗̈TCYƓȂ܂B
     */
    Size2 get_screen_size ( void ) const;
    
};


} /* namespace BK */


/*   Init/Exit ֐
------------------------------------------------------------------- */
namespace BK {


/// OtBbNfoCX̏
void Init_graphic_GraphicDevice ( void );


/// OtBbNfoCX̏I
void Exit_graphic_GraphicDevice ( void );


} /* namespace BK */


#endif /* _SCHEMA_GRAPHIC_GRAPHICDEVICE_H_20031219Fri_095027_ */
