/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - OtBbN - C[ - eLXgC[
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: OtBbN: C[: eLXgC[
 *
 * eLXg`悷邽߂̃C[łB
 * xeLXgGAȂǂgp܂B
 *
 * @author ABE Shigeru
 * @date 2004/01/24
 */
#ifndef _SCHEMA_GRAPHIC_TEXTLAYER_H_20040124Sat_205952_
#define _SCHEMA_GRAPHIC_TEXTLAYER_H_20040124Sat_205952_


/*   NX̐錾
------------------------------------------------------------------- */
namespace BK {

class TextLabel;

} /* namespace BK */


/*   NX̒`
------------------------------------------------------------------- */
namespace BK {


/// eLXgC[
/**
 * eLXgXN[ɕ`悷邽߂̃C[łB
 * ́AXN[ւ̃rbgRs[ɂ`悳܂BeNX`Ȃǂ͎gp܂B
 */
class TextLayer : public Layer
{
private: /* static ϐ */
    
    /// Ruby NX: TextLayer
    static VALUE ruby_class_object;
    
public: /* static \bh */
    
    /// Ruby NX擾
    static VALUE get_ruby_class ( void );
    
    /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
    static bool is_kind_of ( VALUE obj )
    {
        return xrb_is_kind_of(obj, get_ruby_class());
    }
    
    /// Ruby IuWFNgIuWFNgɕϊ
    static TextLayer * value_to_data ( VALUE obj )
    {
        return ruby_basecast< TextLayer, Layer >( obj );
    }
    
protected: /* Ruby IuWFNgpC^[tFCX */
    
    /// Ruby NXIuWFNg擾
    virtual VALUE get_ruby_class_object ( void ) const
    {
        return get_ruby_class();
    }
    
public: /* Ruby IuWFNgpC^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    virtual void ruby_gc_mark ( void );
    
    /// Ruby inspect \bh
    //virtual char * ruby_inspect ( char * buf, unsigned int cap );
    
public: /* Layer C^[tFCX */
    
    /// `Cxg
    virtual void execute ( GraphicDevice * dev );
    
public:
    
    /// eLXgC[vf
    /**
     * eLXgC[ɓo^vfIuWFNg̊NXłB
     * vfIuWFNgɂ́AeLXgxeLXgtB[h܂B
     */
    class Element : public Layout, public OnOffObject
    {
    private: /* static ϐ */
        
        /// Ruby NX: TextLayer::Element
        static VALUE ruby_class_object;
        
    public: /* static \bh */
        
        /// Ruby NX擾
        static VALUE get_ruby_class ( void );
        
        /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
        static bool is_kind_of ( VALUE obj )
        {
            return xrb_is_kind_of(obj, get_ruby_class());
        }
        
        /// Ruby IuWFNgIuWFNgɕϊ
        static Element * value_to_data ( VALUE obj )
        {
            return ruby_basecast< Element, RubyObject >( obj );
        }
        
    protected: /* Ruby IuWFNgpC^[tFCX */
        
        /// Ruby NXIuWFNg擾
        virtual VALUE get_ruby_class_object ( void ) const
        {
            return get_ruby_class();
        }
        
    public: /* Ruby IuWFNgpC^[tFCX */
        
        /// Ruby Kx[WRNgp}[N
        //virtual void ruby_gc_mark ( void );
        
        /// Ruby inspect \bh
        //virtual char * ruby_inspect ( char * buf, unsigned int cap );
        
    public: /* TextLayer::Element C^[tFCX */
        
        /// `揈
        virtual void execute ( Canvas * dev ) = 0;
        
    public: /* Layout C^[tFCX */
        
        /// CAEg̍XV
        //virtual bool update ( void );
        
    public:
        
        /// RXgN^
        Element ( void );
        
        /// fXgN^
        virtual ~Element ();
        
    };
    
    /// C[vf̃Xg^
    typedef OnOffObjectArray < Element > list_t;
    
private:
    
    /// C[vf̃Xg
    list_t ary_element;
    
public:
    
    /// RXgN^
    TextLayer ( void );
    
    /// fXgN^
    virtual ~TextLayer ();
    
    /// C[vf̒ǉ
    /**
     * w肳ꂽC[vfւ̎QƂAC[ɓo^܂B
     * o^ꂽIuWFNg~ԂɂȂƁAC[菜܂B
     *
     * @param elem [in] o^郌C[vf
     * @exception argument_exception łɓ̗vfo^Ă
     */
    void add_element ( Element & elem );
    
};


/// eLXgx
/**
 * eLXgC[p̍\IuWFNgłB
 *
 * [U[́ÃIuWFNg쐬ł܂BeLXgC[݂̂ł܂B
 */
class TextLabel : public TextLayer::Element
{
private: /* static ϐ */
    
    /// Ruby NX: TextLabel
    static VALUE ruby_class_object;
    
public: /* static \bh */
    
    /// Ruby NX擾
    static VALUE get_ruby_class ( void );
    
    /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
    static bool is_kind_of ( VALUE obj )
    {
        return xrb_is_kind_of(obj, get_ruby_class());
    }
    
    /// Ruby IuWFNgIuWFNgɕϊ
    static TextLabel * value_to_data ( VALUE obj )
    {
        return ruby_cast< TextLabel >( obj );
    }
    
protected: /* Ruby IuWFNgpC^[tFCX */
    
    /// Ruby NXIuWFNg擾
    virtual VALUE get_ruby_class_object ( void ) const
    {
        return get_ruby_class();
    }
    
public: /* Ruby IuWFNgpC^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    virtual void ruby_gc_mark ( void );
    
    /// Ruby inspect \bh
    //virtual char * ruby_inspect ( char * buf, unsigned int cap );
    
public: /* TextLayer::Element C^[tFCX */
    
    /// `揈
    virtual void execute ( GraphicDevice * dev );
    
public: /* Layout C^[tFCX */
    
    /// CAEg̍XV
    virtual bool update ( void );
    
public:
    
    /// eNX̌^
    typedef TextLayer::Element parent_t;
    
    /// CAEgXǧ^
    typedef std::vector < GlyphLayout * > list_t;
    
private:
    
    /// CAEg̃Xg
    list_t ary_glyph;
    
public:
    
    /// RXgN^
    TextLabel ( void );
    
    /// fXgN^
    virtual ~TextLabel ();
    
};


} /* namespace BK */


/*   Init/Exit ֐
------------------------------------------------------------------- */
namespace BK {


/// OtBbNfoCXEC[̏
void Init_graphic_layer_TextLayer ( void );


/// OtBbNfoCXEC[̏I
void Exit_graphic_layer_TextLayer ( void );


} /* namespace BK */


#endif /* _SCHEMA_GRAPHIC_TEXTLAYER_H_20040124Sat_205952_ */
