#include "stdafx.h"
#include "body/main.h"

//////////////////////////////////////////////////////////////////////
////  t@C[JȒ萔
//
namespace {


/// ]̈obt@̏TCY
const unsigned int INITIAL_INFO_CAPACITY = 16;


/// _obt@̏TCY
const unsigned int INITIAL_VERTEX_CAPACITY = INITIAL_INFO_CAPACITY * 6;


} /* namespace */
//////////////////////////////////////////////////////////////////////
////  BK::Dx9FillLayer::info_t
//

unsigned int BK::Dx9FillLayer::info_t::initialize_vertex ( BK::Dx9FillLayer::vertex_t * vbuf )
{
    return DirectX::write_points_trilist( vbuf, get_destination(), get_diffuse() );
}

//////////////////////////////////////////////////////////////////////
////  BK::Dx9FillLayer
//

BK::Dx9FillLayer::Dx9FillLayer ( void )
        : obj_list (INITIAL_INFO_CAPACITY, INITIAL_VERTEX_CAPACITY)
{
    if( Dx9GraphicDevice::get_instance() == NULL ) {
        throw new logic_exception("DirectX OtBbNfoCX\zO DirecX tBC[\z͕s.");
    }
}

BK::Dx9FillLayer::~Dx9FillLayer ()
{
}

void BK::Dx9FillLayer::execute ( BK::GraphicDevice * dev )
{
    Dx9GraphicDevice * const nativedev = Dx9GraphicDevice::get_instance();
    
    // _O
    nativedev->render_triangle(NULL, obj_list);
}

BK::ProjectionInfo * BK::Dx9FillLayer::register_projection ( void )
{
    info_t * const info = new info_t ();
    
    if( info == NULL ) {
        throw new runtime_exception("Dx9ImageLayer p̓]̈mۂɎs.");
    }
    
    return obj_list.add( *info );
}

void BK::Dx9FillLayer::delete_projection ( BK::ProjectionInfo * ptr )
{
    info_t * const info = dynamic_cast< info_t * >( ptr );
    
    if( info == NULL ) {
        throw new argument_exception("قȂ^̓]̈ <%s> w肳܂.", typeid(*ptr).name());
    }
    
    if( !obj_list.erase( *info ) ) {
        throw new argument_exception("w肳ꂽ]̈ <%p> ̓C[WC[ɑ݂܂.", ptr);
    }
}

unsigned int BK::Dx9FillLayer::count_projection ( void ) const
{
    return obj_list.size();
}

//////////////////////////////////////////////////////////////////////
