#include "stdafx.h"
#include "body/main.h"

//////////////////////////////////////////////////////////////////////
////  BK::Dx9PictureLayer
//

BK::Dx9PictureLayer::Dx9PictureLayer ( BK::Picture * picture )
        : PictureLayer (picture),
          ptr_surface (NULL)
{
    if( Dx9GraphicDevice::get_instance() == NULL ) {
        throw new logic_exception("DirectX OtBbNfoCX\zO DirecX sN`C[\z͕s.");
    }
    
    ptr_surface = dynamic_cast< Dx9Surface* >( get_picture() );
    if( ptr_surface == NULL ) {
        throw new argument_exception(
            "PictureLayer T|[gȂsN` <%s> n܂.", typeid(*picture).name());
    }
}

BK::Dx9PictureLayer::~Dx9PictureLayer ()
{
}

void BK::Dx9PictureLayer::execute ( BK::GraphicDevice * dev )
{
    Dx9GraphicDevice * nativedev = Dx9GraphicDevice::get_instance();
    
    Point2 p ( 0, 0 );
    
    nativedev->copy_surface( p, *ptr_surface );
}

//////////////////////////////////////////////////////////////////////
