#include "stdafx.h"
#include "body/main.h"

//////////////////////////////////////////////////////////////////////
////  t@C[JȒ`
//
namespace {


/// PNG t@C̃VOl`TCY (oCg)
const int PNGSignatureSize = 8;


} /* namespace */
//////////////////////////////////////////////////////////////////////
////  PNGData
//

BK::PNGData::PNGData ( void )
        : ptr_png (NULL),
          ptr_png_info (NULL),
          ptr_end_info (NULL)
{
    try {
        ptr_png = png_create_read_struct(PNG_LIBRARY_VER_STRING, NULL, NULL, NULL);
        if( ptr_png == NULL ) {
            throw new runtime_exception("PNG t@Cf[^̍\zɎs.");
        }
        
        ptr_png_info = png_create_info_struct(ptr_png);
        if( ptr_png_info == NULL ) {
            throw new runtime_exception("PNG f[^̍\zɎs.");
        }
        
        ptr_end_info = png_create_info_struct(ptr_png);
        if( ptr_end_info == NULL ) {
            throw new runtime_exception("PNG I[f[^̍\zɎs.");
        }
    } catch ( exception_base * ) {
        png_destroy_read_struct( &ptr_png, &ptr_png_info, &ptr_end_info );
        throw;
    }
}

BK::PNGData::~PNGData ()
{
    png_destroy_read_struct( &ptr_png, &ptr_png_info, &ptr_end_info );
}

bool BK::PNGData::read_file ( FILE * file )
{
    png_init_io( ptr_png, file );
    png_set_sig_bytes( ptr_png, PNGSignatureSize );
    png_read_info( ptr_png, ptr_png_info );
    png_get_IHDR( ptr_png, ptr_png_info, &num_width, &num_height, &num_depth, &num_color_format, NULL, NULL, NULL );
    
    if( num_depth < 8 ) {
    }
}

//////////////////////////////////////////////////////////////////////
////  PNGTool
//

void * BK::PNGTool::read_file ( const char * filename )
{
    FILE * const file = fopen( filename, "r" );
    png_byte buffer [ PNGSignatureSize ];
    
    if( file == NULL ) {
        throw new windows_exception("PNG t@C '%s' ̃I[vɎs.", filename);
    }
    try {
        if( fread(buffer, sizeof(png_byte), PNGSignatureSize, file) != PNGSignatureSize ) {
            throw new windows_exception("PNG t@C '%s' ̃wb_ǂݍ݂Ɏs.", filename);
        }
        if( is_png_signature(buffer, PNGSignatureSize) ) {
            return NULL;
        }
        
        
        
    } catch ( exception_base * ) {
        fclose( file );
        throw;
    }
}

bool BK::PNGTool::is_png_signature ( void * buffer, unsigned int cap )
{
    return png_sig_cmp(buffer, 0, cap) == 0;
}

//////////////////////////////////////////////////////////////////////
