#include "stdafx.h"
#include "body/main.h"

//////////////////////////////////////////////////////////////////////
////  t@C[JȒ萔
//
namespace {


/// ]̈obt@̏TCY
const int INITIAL_INFO_CAPACITY = 128;


} /* namespace */
//////////////////////////////////////////////////////////////////////
////  BK::W32FilmLayer
//

BK::W32FilmLayer::W32FilmLayer ( void )
        : obj_list (INITIAL_INFO_CAPACITY)
{
}

BK::W32FilmLayer::~W32FilmLayer ()
{
}

void BK::W32FilmLayer::ruby_gc_mark ( void )
{
    obj_list.ruby_gc_mark();
}

BK::ProjectionInfo * BK::W32FilmLayer::register_projection ( void )
{
    info_t * const info = new info_t ();
    
    if( info == NULL ) {
        throw new runtime_exception("W32FilmLayer p̓]̈mۂɎs.");
    }
    
    return obj_list.add( *info );
}

void BK::W32FilmLayer::delete_projection ( BK::ProjectionInfo * ptr )
{
    info_t * const info = dynamic_cast< info_t * >( ptr );
    
    if( info == NULL ) {
        throw new argument_exception("قȂ^̓]̈ <%s> w肳܂.", typeid(*ptr).name());
    }
    
    if( !obj_list.erase( *info ) ) {
        throw new argument_exception("w肳ꂽ]̈ <%p> ̓tBC[ɑ݂܂.", ptr);
    }
}

unsigned int BK::W32FilmLayer::count_projection ( void ) const
{
    return obj_list.size();
}

void BK::W32FilmLayer::execute ( GraphicDevice * dev )
{
    typedef list_t::list_t list_t;
    
    const list_t & list = obj_list.execute();
    const list_t::const_iterator end = list.end();
    list_t::const_iterator itr;
    
    Canvas * const canvas = dev->create_canvas();
    try {
        for( itr = list.begin(); itr != end; ++itr ) {
            const info_t * const info = *itr;
            const AlphaColor * const color = info->get_color();
            const Film * const film = info->get_film();
            
            if( color != NULL && film != NULL ) {
                canvas->draw_film( info->get_destination()[0], *color, *film, Rect2(film->get_size()) );
            }
        }
    } catch ( exception_base * ) {
        delete canvas;
        throw;
    }
    delete canvas;
}

//////////////////////////////////////////////////////////////////////
