#include "stdafx.h"
#include "schema/main.h"

//////////////////////////////////////////////////////////////////////
////  BK::CharacterScript::Agent
//

BK::CharacterScript::Agent::Agent ( BK::CharacterScript & script )
        : ptr_character (NULL),
          ptr_script (&script)
{
}

BK::CharacterScript::Agent::~Agent ()
{
}

bool BK::CharacterScript::Agent::connect_character ( BK::Character * chr )
{
    ptr_character = chr;
    return true;
}

//////////////////////////////////////////////////////////////////////
////  BK::CharacterScript
//

VALUE BK::CharacterScript::ruby_class_object = Qnil;

BK::CharacterScript::CharacterScript ( void )
{
}

BK::CharacterScript::~CharacterScript ()
{
}

VALUE BK::CharacterScript::get_ruby_class ( void )
{
    if( !NIL_P(ruby_class_object) ) {
        return ruby_class_object;
    }
    VALUE c;
    
    c = ruby_class_object = define_ruby_bk_class( "CharacterScript", parent_t::get_ruby_class() );
    
    return ruby_class_object;
}

bool BK::CharacterScript::is_ruby_gc_log_enabled ( void ) const
{
    return false;
}

//////////////////////////////////////////////////////////////////////
////  Init ֐
//

void BK::Init_application_character_CharacterScript ( void )
{
    CharacterScript::get_ruby_class();
    
    Init_application_character_FrameConditionScript();
    Init_application_character_EventConditionScript();
    Init_application_character_ContainerScript();
}

//////////////////////////////////////////////////////////////////////
////  Exit ֐
//

void BK::Exit_application_character_CharacterScript ( void )
{
    Exit_application_character_FrameConditionScript();
    Exit_application_character_EventConditionScript();
    Exit_application_character_ContainerScript();
}

//////////////////////////////////////////////////////////////////////
