#include "stdafx.h"
#include "schema/main.h"

//////////////////////////////////////////////////////////////////////
////  Ruby IuWFNg: BK::FrameConditionScript
//
namespace {
extern "C" {

/// XNvgI܂ł̃t[擾
VALUE FrameConditionScript_get_length ( VALUE self )
{
    BK::FrameConditionScript * const ptr = BK::FrameConditionScript::value_to_data( self );
    
    return UINT2NUM( ptr->get_length() );
}

/// XNvgI܂ł̃t[ݒ肷
VALUE FrameConditionScript_set_length ( VALUE self, VALUE lenobj )
{
    using namespace BK;
    FrameConditionScript * const ptr = FrameConditionScript::value_to_data( self );
    unsigned int len = NUM2UINT(lenobj);
    
    try {
        ptr->set_length( len );
    } catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return lenobj;
}

} /* extern "C" */
} /* namespace */
//////////////////////////////////////////////////////////////////////
////  FrameConditionScript::Agent
//

BK::FrameConditionScript::Agent::Agent ( BK::FrameConditionScript & script )
        : agent_parent_t  (script),
          num_current     (0)
{
}

BK::FrameConditionScript::Agent::~Agent ()
{
}

void BK::FrameConditionScript::Agent::set_current ( unsigned int num )
{
    num_current = num;
}

//////////////////////////////////////////////////////////////////////
////  FrameConditionScript
//

VALUE BK::FrameConditionScript::ruby_class_object = Qnil;

BK::FrameConditionScript::FrameConditionScript ( void )
        : num_length (0)
{
}

BK::FrameConditionScript::FrameConditionScript ( unsigned int len )
        : num_length (len)
{
}

BK::FrameConditionScript::~FrameConditionScript ( void )
{
}

VALUE BK::FrameConditionScript::get_ruby_class ( void )
{
    if( !NIL_P(ruby_class_object) ) {
        return ruby_class_object;
    }
    VALUE c;
    
    c = ruby_class_object = define_ruby_bk_class( "FrameConditionScript", parent_t::get_ruby_class() );
    
    xrb_define_0arg_method( c, "length", FrameConditionScript_get_length );
    xrb_define_1arg_method( c, "length=", FrameConditionScript_set_length );
    
    return ruby_class_object;
}

void BK::FrameConditionScript::set_length ( unsigned int length )
{
    num_length = length;
}

//////////////////////////////////////////////////////////////////////
////  Init ֐
//

void BK::Init_application_character_FrameConditionScript ( void )
{
    FrameConditionScript::get_ruby_class();
    
    Init_application_character_TimerScript();
    Init_application_character_LinearAlphaScript();
}

//////////////////////////////////////////////////////////////////////
////  Exit ֐
//

void BK::Exit_application_character_FrameConditionScript ( void )
{
    Exit_application_character_TimerScript();
    Exit_application_character_LinearAlphaScript();
}

//////////////////////////////////////////////////////////////////////
