#include "stdafx.h"
#include "schema/main.h"

//////////////////////////////////////////////////////////////////////
////  Ruby IuWFNg: TimerScript
//
namespace {
extern "C" {

/// XNvg̐
VALUE TimerScript_new ( VALUE klass )
{
    using namespace BK;
    VALUE volatile obj = Qnil;
    
    try {
        TimerScript * const ptr = new TimerScript ();
        obj = ptr->ruby_wrap();
    }
    catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    rb_obj_call_init( obj, 0, NULL );
    
    return obj;
}

/// XNvg̏
VALUE TimerScript_initialize ( VALUE self )
{
    return self;
}

} /* extern "C" */
} /* namespace */
//////////////////////////////////////////////////////////////////////
////  BK::TimerScript::Agent
//

BK::TimerScript::Agent::Agent ( BK::TimerScript & script )
        : agent_parent_t  (script),
          ptr_script      (&script)
{
}

BK::TimerScript::Agent::~Agent ()
{
}

void BK::TimerScript::Agent::execute ( void )
{
    const unsigned int c = get_current() + 1;
    
    set_current( c );
    
    if( c >= ptr_script->get_length() ) {
        terminate();
    }
}

//////////////////////////////////////////////////////////////////////
////  BK::TimerScript
//

VALUE BK::TimerScript::ruby_class_object = Qnil;

BK::TimerScript::TimerScript ( void )
{
}

BK::TimerScript::~TimerScript ()
{
}

VALUE BK::TimerScript::get_ruby_class ( void )
{
    if( !NIL_P(ruby_class_object) ) {
        return ruby_class_object;
    }
    VALUE c;
    
    c = ruby_class_object = define_ruby_bk_class( "TimerScript", parent_t::get_ruby_class() );
    
    xrb_define_0arg_singleton_method( ruby_class_object, "new", TimerScript_new );
    
    xrb_define_0arg_method( c, "initialize", TimerScript_initialize );
    
    return ruby_class_object;
}

BK::CharacterScript::Agent * BK::TimerScript::create_agent ( void )
{
    return new Agent( *this );
}

//////////////////////////////////////////////////////////////////////
////  Init ֐
//

void BK::Init_application_character_TimerScript ( void )
{
    TimerScript::get_ruby_class();
}

//////////////////////////////////////////////////////////////////////
////  Exit ֐
//

void BK::Exit_application_character_TimerScript ( void )
{
}

//////////////////////////////////////////////////////////////////////
