#include "stdafx.h"
#include "schema/main.h"

//////////////////////////////////////////////////////////////////////
////  t@C[JȃNX
//
namespace {

using namespace BK;

/// CAEgƐݒ肷W̍ƗpIuWFNg
/**
 * WύXĂACAEgɂ͔f܂B
 * Ɨp̈ꎞIȃIuWFNgƂĎgp܂B
 */
class layoutpoint_t
{
private:
    
    /// QƂ郌CAEg
    Layout * ptr_layout;
    
    /// CAEg̍W
    Point2 point_layout;
    
public:
    
    /// RXgN^
    layoutpoint_t ( void )
    {
    }
    
    /// RXgN^
    layoutpoint_t ( Layout & layout )
            : ptr_layout (&layout)
    {
    }
    
    /// RXgN^
    layoutpoint_t ( Layout & layout, const Point2 & p )
            : ptr_layout (&layout),
              point_layout (p)
    {
    }
    
    /// QƂĂ郌CAEg擾
    Layout & get_layout ( void )
    {
        return *ptr_layout;
    }
    
    /// CAEg̃TCY擾
    const Size2 & get_size ( void ) const
    {
        return ptr_layout->get_size();
    }
    
    /// CAEg̉擾
    Size2::num_t get_width ( void ) const
    {
        return get_size().get_width();
    }
    
    /// CAEg̏c擾
    Size2::num_t get_height ( void ) const
    {
        return get_size().get_height();
    }
    
    /// CAEg̉W擾
    const Point2 & get_point ( void ) const
    {
        return point_layout;
    }
    
    /// CAEg̉Wݒ肷
    void set_point ( const Point2 & p )
    {
        point_layout = p;
    }
    
    /// CAEg̉WɒڃANZX
    Point2 & the_point ( void )
    {
        return point_layout;
    }
    
    /// CAEgɉW𔽉f
    void update ( void )
    {
        ptr_layout->set_point( point_layout );
    }
    
};

/// sRei
/**
 * s̃ReiCAEg\IuWFNgłB
 */
class line_t
{
public:
    
    /// CAEgXǧ^
    typedef std::vector < layoutpoint_t > list_t;
    
private:
    
    /// I[i[̃xCAEg
    LabelLayout & obj_owner;
    
    /// CAEg̃Xg
    list_t ary_char;
    
    /// s̉ (LbV)
    int num_width;
    
    /// s̏c (LbV)
    int num_height;
    
private:
    
    /// ̍Wݒ
    void set_horizontal_point ( void );
    
    /// ̍Wݒ
    void set_vertical_point ( void );
    
public:
    
    /// RXgN^
    /**
     * @param owner [in] I[i[ƂȂ郌CAEg
     */
    line_t ( LabelLayout & owner )
            : obj_owner (owner),
              num_width (0),
              num_height (0)
    {
    }
    
    /// fXgN^
    virtual ~line_t ()
    {
    }
    
    /// f[^ǉ
    /**
     * @param layouts [in] ǉ郌CAEg̔z
     * @param len [in] z
     * @return ǉꂽCAEg
     */
    unsigned int add_char ( Layout * const * layouts, unsigned int len );
    
    /// CAEg̈ʒuXV
    void update ( void );
    
    /// o^Ă郌CAEg擾
    unsigned int count_registered_layouts ( void ) const
    {
        return ary_char.size();
    }
    
};


unsigned int line_t::add_char ( Layout * const * layouts, unsigned int len )
{
    const Size2::num_t areawidth = obj_owner.get_size().get_width();
    unsigned int i;
    int x = num_width;
    
    for( i = 0; i < len; ++i ) {
        Layout * const layout = layouts[i];
        
        if( layout == NULL ) {
            continue;
        }
        layoutpoint_t lp ( *layout );
        
        // LN^Ԋuݒł悤ɂȂƂKv
        //if( ary_char.size() > 0 ) {
        //    x += LN^Ԋu
        //}
        
        int xx = x + layout->get_size().get_width();
        
        lp.the_point().set_x( x );
        if( !obj_owner.is_overflow_enabled() && xx > areawidth ) {
            break;
        }
        x = xx;
        
        ary_char.push_back( lp );
    }
    num_width = x;
    return i;
}

void line_t::update ( void )
{
    const list_t::iterator e = ary_char.end();
    list_t::iterator itr;
    
    set_vertical_point();
    set_horizontal_point();
    
    for( itr = ary_char.begin(); itr != e; ++itr ) {
        itr->update();
    }
}

void line_t::set_horizontal_point ( void )
{
    const Size2::num_t width = obj_owner.get_size().get_width();
    list_t & ary = ary_char;
    
    const list_t::iterator e = ary.end();
    list_t::iterator itr;
    
    Layout::align_t align = obj_owner.get_horizontal_align();
    
    if( align == Layout::FIT ) {
        if( ary.size() < 2 ) {
            align = Layout::CENTER;
        }
    }
    
    Point2::num_t xbase = obj_owner.get_point().get_x();
    
    switch( align )
    {
    case Layout::FIT:
        {
            const int left = ary.front().get_width() / 2;
            const int right = width - ary.back().get_width() / 2;
            unsigned int allcount = ary.size() - 1;
            unsigned int count = 0;
            
            for( itr = ary.begin(); itr != e; ++itr ) {
                itr->the_point().set_x( xbase + (left + (right - left) * count / allcount) );
                ++count;
            }
        }
        break;
        
    case Layout::RIGHT:
    case Layout::CENTER:
    case Layout::LEFT:
    default:
        {
            switch( align ) {
            case Layout::RIGHT:
                xbase += width - num_width;
                break;
                
            case Layout::CENTER:
                xbase += (width - num_width) / 2;
                break;
            }
            for( itr = ary.begin(); itr != e; ++itr ) {
                itr->the_point().add_x( xbase );
            }
        }
        break;
    }
}

void line_t::set_vertical_point ( void )
{
    const Size2::num_t height = obj_owner.get_size().get_height();
    const Point2::num_t ybase = obj_owner.get_point().get_y();
    list_t & ary = ary_char;
    
    const list_t::iterator e = ary.end();
    list_t::iterator itr;
    
    Layout::align_t align = obj_owner.get_horizontal_align();
    
    switch( align ) {
    case Layout::TOP:
        for( itr = ary.begin(); itr != e; ++itr ) {
            itr->the_point().set_y( ybase );
        }
        break;
        
    case Layout::CENTER:
    case Layout::FIT:
        for( itr = ary.begin(); itr != e; ++itr ) {
            itr->the_point().set_y( ybase + (height - itr->get_height()) / 2 );
        }
        break;
        
    case Layout::BOTTOM:
    default:
        for( itr = ary.begin(); itr != e; ++itr ) {
            itr->the_point().set_y( ybase + height - itr->get_height() );
        }
        break;
    }
}

} /* namespace */
//////////////////////////////////////////////////////////////////////
////  Ruby IuWFNg: BK::LabelLayout
//
namespace {

/// xCAEgIuWFNg̐
VALUE LabelLayout_new ( int argc, VALUE * argv, VALUE klass )
{
    using namespace BK;
    VALUE volatile obj = Qnil;
    
    try {
        Ruby::ArgScanner scanner("LabelLayout.new", argc, argv);
        Size2 size;
        
        size = scanner.fetch_Size2("CAEgTCY");
        
        scanner.finish();
        
        LabelLayout * const ptr = new LabelLayout ();
        
        ptr->set_size( size );
        
        obj = ptr->ruby_wrap();
        rb_obj_call_init( obj, argc, argv );
        
    } catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return obj;
}

/// xCAEg̏
VALUE LabelLayout_initialize ( int argc, VALUE * argv, VALUE self )
{
    return self;
}

} /* namespace */
//////////////////////////////////////////////////////////////////////
////  BK::LabelLayout
//

VALUE BK::LabelLayout::ruby_class_object = Qnil;

BK::LabelLayout::LabelLayout ( void )
{
}

BK::LabelLayout::~LabelLayout ()
{
}

VALUE BK::LabelLayout::get_ruby_class ( void )
{
    if( !NIL_P(ruby_class_object) ) {
        return ruby_class_object;
    }
    VALUE c;
    
    c = ruby_class_object = define_ruby_bk_class( "LabelLayout", parent_t::get_ruby_class() );
    
    xrb_define_narg_singleton_method( c, "new", LabelLayout_new );
    
    xrb_define_narg_method( c, "initialize", LabelLayout_initialize );
    
    return ruby_class_object;
}

void BK::LabelLayout::on_update ( void )
{
    parent_t::on_update();
    
    const unsigned int cap = count_document_layouts();
    Layout * * const layouts = ALLOCA_N(Layout*, cap);
    
    line_t line ( *this );
    line.add_char( layouts, get_document_layouts(layouts, cap) );
    line.update();
    
    set_registered_layouts_count( line.count_registered_layouts() );
}

//////////////////////////////////////////////////////////////////////
////  Init ֐
//

void BK::Init_utility_LabelLayout ( void )
{
    BK::LabelLayout::get_ruby_class();
}

//////////////////////////////////////////////////////////////////////
////  Exit ֐
//

void BK::Exit_utility_LabelLayout ( void )
{
}

//////////////////////////////////////////////////////////////////////
