#include "stdafx.h"
#include "schema/main.h"
#include <algorithm>

//////////////////////////////////////////////////////////////////////
////  Ruby NX: BK::Rect2
//
namespace {
extern "C" {

/// Rect2  (QƔ)
void Rect2_ref_free ( BK::Rect2 * ptr )
{
}

/// Rect2 
void Rect2_free ( BK::Rect2 * ptr )
{
    delete ptr;
}

/// Rect2 𐶐
VALUE Rect2_new ( int argc, VALUE * argv, VALUE klass )
{
    using namespace BK;
    VALUE volatile objvalue;
    Rect2 * obj;
    
    try {
        Ruby::ArgScanner scanner("Rect2.new", argc, argv);
        
        obj = new Rect2 ();
        *obj = scanner.fetch_Rect2();
        scanner.finish();
    } catch ( exception_base * e ) {
        ruby_throw(e);
    }
    
    // Rect2  RubyObject pĂȂ̂ ruby_wrap() gȂ
    objvalue = Data_Wrap_Struct( BK::Rect2::get_ruby_class(), NULL, Rect2_free, obj );
    
    rb_obj_call_init( objvalue, argc, argv );
    
    return objvalue;
}

/// 
VALUE Rect2_initialize ( int argc, VALUE * argv, VALUE self )
{
    return self;
}

/// IuWFNgRs[
VALUE Rect2_initialize_copy ( VALUE self, VALUE obj )
{
    if( !BK::Rect2::is_kind_of(obj) ) {
        rb_raise(rb_eArgError, "%s  Rect2 ɃRs[ł܂.", rb_obj_classname(obj));
    }
    const BK::Rect2 * const src = BK::Rect2::value_to_data( obj );
    
    if( !BK::Rect2::is_kind_of(self) ) {
        rb_raise(rb_eTypeError, "%s  Rect2.initialize_copy Kp܂.", rb_obj_classname(self));
    }
    xrb_update_Data( self, NULL, Rect2_free, new BK::Rect2( *src ) );
    
    return self;
}

/// `̉擾
VALUE Rect2_get_width ( VALUE self )
{
    BK::Rect2 * rect = BK::Rect2::value_to_data( self );
    
    return rb_fix_new( rect->get_width() );
}

/// `̏c擾
VALUE Rect2_get_height ( VALUE self )
{
    BK::Rect2 * rect = BK::Rect2::value_to_data( self );
    
    return rb_fix_new( rect->get_height() );
}

/// `̍[ʒu擾
VALUE Rect2_get_left ( VALUE self )
{
    BK::Rect2 * rect = BK::Rect2::value_to_data( self );
    
    return rb_fix_new( rect->get_left() );
}

/// `̉E[ʒu擾
VALUE Rect2_get_right ( VALUE self )
{
    BK::Rect2 * rect = BK::Rect2::value_to_data( self );
    
    return rb_fix_new( rect->get_right() );
}

/// `̏[ʒu擾
VALUE Rect2_get_top ( VALUE self )
{
    BK::Rect2 * rect = BK::Rect2::value_to_data( self );
    
    return rb_fix_new( rect->get_top() );
}

/// `̉[ʒu擾
VALUE Rect2_get_bottom ( VALUE self )
{
    BK::Rect2 * rect = BK::Rect2::value_to_data( self );
    
    return rb_fix_new( rect->get_bottom() );
}

/// `̍[ʒuݒ肷
VALUE Rect2_set_left ( VALUE self, VALUE numobj )
{
    rb_check_frozen( self );
    
    BK::Rect2 * rect = BK::Rect2::value_to_data( self );
    
    rect->set_left( NUM2INT( numobj ) );
    return numobj;
}

/// `̉E[ʒuݒ肷
VALUE Rect2_set_right ( VALUE self, VALUE numobj )
{
    rb_check_frozen( self );
    
    BK::Rect2 * rect = BK::Rect2::value_to_data( self );
    
    rect->set_right( NUM2INT( numobj ) );
    return numobj;
}

/// `̏[ʒuݒ肷
VALUE Rect2_set_top ( VALUE self, VALUE numobj )
{
    rb_check_frozen( self );
    
    BK::Rect2 * rect = BK::Rect2::value_to_data( self );
    
    rect->set_top( NUM2INT( numobj ) );
    return numobj;
}

/// `̉[ʒuݒ肷
VALUE Rect2_set_bottom ( VALUE self, VALUE numobj )
{
    rb_check_frozen( self );
    
    BK::Rect2 * rect = BK::Rect2::value_to_data( self );
    
    rect->set_bottom( NUM2INT( numobj ) );
    return numobj;
}

/// `̃TCY擾
VALUE Rect2_get_size ( VALUE self )
{
    BK::Rect2 * rect = BK::Rect2::value_to_data( self );
    
    return rect->get_size().create_ruby_object();
}

/// `𕶎ɕϊ
VALUE Rect2_to_s ( VALUE self )
{
    BK::Rect2 * rect = BK::Rect2::value_to_data( self );
    char buf [64];
    int len;
    
    len = rect->get_string( buf, 64 );
    
    return rb_str_new(buf, len);
}

/// `IuWFNg̔r
VALUE Rect2_p_eql ( VALUE self, VALUE obj )
{
    BK::Rect2 * r = BK::Rect2::value_to_data( self );
    
    if( !BK::Rect2::is_kind_of(obj) ) {
        return Qfalse;
    }
    BK::Rect2 * rhs = BK::Rect2::value_to_data( obj );
    
    return (*r == *rhs) ? Qtrue : Qfalse;
}

/// `IuWFNg̃nbVl擾
VALUE Rect2_get_hash ( VALUE self )
{
    BK::Rect2 * r = BK::Rect2::value_to_data( self );
    
    return rb_fix_new( (r->get_right()) ^ (r->get_bottom() << 8) ^ (r->get_left() << 16) ^ (r->get_top() << 24) );
}

} /* extern "C" */
} /* namespace */
//////////////////////////////////////////////////////////////////////
////  BK::Rect2
//

VALUE BK::Rect2::ruby_class_object = Qnil;

VALUE BK::Rect2::get_ruby_class ( void )
{
    if( !NIL_P(ruby_class_object) ) {
        return ruby_class_object;
    }
    VALUE c;
    
    c = ruby_class_object = define_ruby_bk_class( "Rect2", rb_cData );
    
    xrb_define_narg_singleton_method( c, "new", Rect2_new );
    
    xrb_define_narg_method( c, "initialize", Rect2_initialize );
    xrb_define_1arg_method( c, "initialize_copy", Rect2_initialize_copy );
    xrb_define_0arg_method( c, "left", Rect2_get_left );
    xrb_define_0arg_method( c, "right", Rect2_get_right );
    xrb_define_0arg_method( c, "top", Rect2_get_top );
    xrb_define_0arg_method( c, "bottom", Rect2_get_bottom );
    xrb_define_1arg_method( c, "left=", Rect2_set_left );
    xrb_define_1arg_method( c, "right=", Rect2_set_right );
    xrb_define_1arg_method( c, "top=", Rect2_set_top );
    xrb_define_1arg_method( c, "bottom=", Rect2_set_bottom );
    xrb_define_0arg_method( c, "width", Rect2_get_width );
    xrb_define_0arg_method( c, "height", Rect2_get_height );
    xrb_define_0arg_method( c, "size", Rect2_get_size );
    xrb_define_0arg_method( c, "to_s", Rect2_to_s );
    xrb_define_1arg_method( c, "==", Rect2_p_eql );
    xrb_define_1arg_method( c, "eql?", Rect2_p_eql );
    xrb_define_0arg_method( c, "hash", Rect2_get_hash );
    
    xrb_define_narg_global_function( "Rect2", Rect2_new );
    
    return ruby_class_object;
}

std::string BK::Rect2::to_string ( void ) const
{
    char buf [64];
    
    get_string( buf, 64 );
    
    return std::string( buf );
}

int BK::Rect2::get_string ( char * buf, unsigned int cap ) const
{
    if( buf != NULL ) {
        return snprintf( buf, cap, "(%d,%d)-(%d,%d)", get_left(), get_top(), get_right(), get_bottom() );
    }
    return 0;
}

VALUE BK::Rect2::create_ruby_reference ( void )
{
    return Data_Wrap_Struct( get_ruby_class(), NULL, Rect2_ref_free, this );
}

VALUE BK::Rect2::create_ruby_object ( void ) const
{
    Rect2 * dupobj = new Rect2( *this );
    
    return Data_Wrap_Struct( get_ruby_class(), NULL, Rect2_free, dupobj );
}

//////////////////////////////////////////////////////////////////////
////  Init ֐
//

void BK::Init_utility_Rect2 ( void )
{
    Rect2::get_ruby_class();
}

//////////////////////////////////////////////////////////////////////
////  Exit ֐
//

void BK::Exit_utility_Rect2 ( void )
{
}

//////////////////////////////////////////////////////////////////////
