#include "stdafx.h"
#include "schema/main.h"

//////////////////////////////////////////////////////////////////////
////  Ruby IuWFNg: BK::FillLayer
//
namespace {
extern "C" {

/// FillLayer CX^X̐
VALUE FillLayer_new ( VALUE klass )
{
    using namespace BK;
    VALUE volatile obj = Qnil;
    
    try {
        FillLayer * const layer = create_FillLayer();
        obj = layer->ruby_wrap();
        rb_obj_call_init( obj, 0, NULL );
    }
    catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return obj;
}

/// C[̏
VALUE FillLayer_initialize ( VALUE self )
{
    return self;
}

} /* extern "C" */
} /* namespace */
//////////////////////////////////////////////////////////////////////
////  BK::FillLayer
//

VALUE BK::FillLayer::ruby_class_object = Qnil;

VALUE BK::FillLayer::get_ruby_class ( void )
{
    if( !NIL_P(ruby_class_object) ) {
        return ruby_class_object;
    }
    VALUE c;
    
    c = ruby_class_object = define_ruby_bk_class( "FillLayer", BK::ProjectionLayer::get_ruby_class() );
    
    xrb_define_0arg_singleton_method( c, "new", FillLayer_new );
    
    xrb_define_0arg_method( c, "initialize", FillLayer_initialize );
    
    return ruby_class_object;
}

BK::FillLayer::FillLayer ( void )
{
}

BK::FillLayer::~FillLayer ()
{
}

//////////////////////////////////////////////////////////////////////
////  Init ֐
//

void BK::Init_graphic_layer_FillLayer ( void )
{
    BK::FillLayer::get_ruby_class();
}

//////////////////////////////////////////////////////////////////////
////  Exit ֐
//

void BK::Exit_graphic_layer_FillLayer ( void )
{
}

//////////////////////////////////////////////////////////////////////
