# p[^̐ݒ
$stderr = $stdout = File.open("./stdout.log", "w")

$Config['LogDevice.InitialLevel'] = BK::LogDevice::TRACE
$Config['ApplicationDevice.InitialCaption'] = 'XvCg - eXg'

# foCX̋N
begin
  devices = [BK::LogDevice, BK::ApplicationDevice, BK::GraphicDevice, BK::InputDevice]
  for device in devices do
    device.start()
  end
end

# C[WC[
layer = BK::ImageLayer.new( BK::Image.new(256, 256) )

# Aj[Vf[^
w, h = 32, 32
c = [ ]
for y in 0...4 do
  for x in 0...4 do
    r = Rect2(w*x, h*y, w*x+w, h*y+h)
    c << BK::ProjectionSourceSetter.new(r)
  end
end
w = BK::FrameWaiter.new(5)
ary = [c[0], w, c[1], w, c[2], w, c[3], w, c[4], w, c[5], w, c[6], w, c[7], w]
seq = BK::ScriptSequence.new(ary)

# LN^[
gear = BK::CharacterGear.new()


__END__

# XvCg
picture = BK::PictureData.open("./chr128x128.png")
db = BK::SpriteDatabase.new("SampleDB")
w, h = 32, 32
begin
  db["IuWFNg(1)"] = BK::Sprite.new(picture, Rect2(w*0, h*0, w*1, h*1))
  db["IuWFNg(2)"] = BK::Sprite.new(picture, Rect2(w*1, h*0, w*2, h*1))
  db["IuWFNg(3)"] = BK::Sprite.new(picture, Rect2(w*2, h*0, w*3, h*1))
  db["IuWFNg(4)"] = BK::Sprite.new(picture, Rect2(w*3, h*0, w*4, h*1))
  BK::SpriteDatabase.push(db)
  
  set = BK::SpriteSet.new(w*3, h*1)
  #set.add("Step1", BK::SpriteDatabase["IuWFNg(1)"], Point2(w*0, 0))
  set.add("Step1", db["IuWFNg(1)"], Point2(w*0, 0))
  set.add("Step2", db["IuWFNg(2)"], Point2(w*1, 0))
  set.add("Step3", db["IuWFNg(3)"], Point2(w*2, 0))
  BK::SpriteSet["p^[1"] = set
  
  set = BK::SpriteSet.new(w*3, h*1)
  set.add("Step1", db["IuWFNg(1)"], Point2(w*0, 0))
  set.add("Step2", db["IuWFNg(2)"], Point2(w*1, 0))
  set.add("Step3", db["IuWFNg(4)"], Point2(w*2, 0))
  BK::SpriteSet["p^[2"] = set
end

# C[WC[
image = BK::Image.new(w*4, h*4)
layer = BK::ImageLayer.new(image)

#field = BK::SpriteField.new("}[J", image, BK::SpriteSet["p^[1"], Point2(0, 0))
field = BK::SpriteField.new("}[J", image, "p^[1", Point2(0, 0))
# tB[h͎o^

=begin
# [VLN^[̎gXvCg肷ꍇ
gear = BK::CharacterGear.new()
c = gear.generate()
script = BK::SpriteSetter.new(BK::SpriteField["}[J"])
script.set(["Step1", 30, "Step2", 30, "Step3", 30])
early_bind = true
if early_bind then
  script.field = field #  bind ... ǃtB[hŒ肳
  c.add_script(script)
else
  c.add_script(script)
  c.layer = layer
end

# XvCgtB[hLN^[𐶐ꍇ
# LN^[MA̍\ςȂǕKv
gear = BK::ScriptCharacterGear.new()
c = gear.generate(BK::SpriteField["}[J"])
script = BK::SpriteSetter.new()
script.set(["Step1", 30, "Step2", 30, "Step3", 30])
c.add_script( script )
=end

# [VXNvg
#script = BK::ProjectionSetter.new(BK::SpriteField["}[J"])
script = BK::SpriteSetter.new("}[J")
script.set(["Step1", 30, "Step2", 30, "Step3", 30])
#script.field = field #  bind ... ǃtB[hŒ肳

# LN^[
gear = BK::SpriteCharacterGear.new()
#c = gear.generate(field)
c = gear.generate("}[J") #== gear.generate(BK::SpriteField["}[J"])
#c.add_script(script)
#script ̖O
c << script #  bind ... ᑬǎRx傫

# C[v
app = BK::ApplicationDevice.connect()
gear = BK::FrameWaitGear.new()
gear.wait_frame = 600
app.loop(gear)

#field.replace(BK::SpriteSet["p^[2"])
field.replace("p^[2")

gear = BK::FrameWaitGear.new()
gear.wait_frame = 600
app.loop(gear)
