/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - {fBZNV - AvP[V - AvP[VfoCX
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief {fBZNV: AvP[V: AvP[VfoCX
 *
 * AvP[VfoCX̎`܂B
 *
 * @author ABE Shigeru
 * @date 2004/02/04
 */
#ifndef _BODY_APPLICATION_W32APPLICATIONDEVICE_H_20040204Wed_132650_
#define _BODY_APPLICATION_W32APPLICATIONDEVICE_H_20040204Wed_132650_


/*   foCXNX`
------------------------------------------------------------------- */
namespace BK {


/// AvP[VfoCX (Win32)
/**
 * Win32 p̃AvP[VfoCXłB
 */
class W32ApplicationDevice : public ApplicationDevice, public Win32::WindowProcedure
{
private: /* static ϐ */
    
    /// Singleton IuWFNg
    static W32ApplicationDevice * singleton_object;
    
public: /* static \bh */
    
    /// \zꂽAvP[VfoCX擾
    static W32ApplicationDevice * get_instance ( void )
    {
        return singleton_object;
    }
    
protected: /* ServiceDevice C^[tFCX */
    
    /// foCX̊Jn
    virtual void _start ( void );
    
    /// foCX̏I
    virtual void _stop ( void );
    
public: /* ApplicationDevice C^[tFCX */
    
    /// AvP[V̈̑傫擾
    virtual Size2 get_application_area_size ( void ) const;
    
protected: /* ApplicationDevice C^[tFCX */
    
    /// C[vJñCxgnh
    virtual void on_each_loop_beginning ( void );
    
protected: /* Win32::WindowProcedure C^[tFCX */
    
    /// sȃbZ[W
    //virtual LRESULT on_windows_message ( HWND wnd, UINT msg, WPARAM wparam, LPARAM lparam );
    
private:
    
    /// AvP[ṼCX^Xnh
    HINSTANCE  handle_instance;
    
    /// VXe^C}[̐x
    UINT  num_systimer_precision;
    
    /// EBhENX
    WNDCLASSEX  obj_window_class;
    
    /// CEBhẼnh
    HWND  handle_window;
    
private:
    
    /// mۂIuWFNgȂǂ̔p
    /** RXgN^̓fXgN^Ŏgp܂ */
    void finalize_object ( void );
    
public:
    
    /// RXgN^
    W32ApplicationDevice ( void );
    
    /// fXgN^
    ~W32ApplicationDevice ();
    
    /// CX^Xnh擾
    HINSTANCE get_instance_handle ( void ) const
    {
        return handle_instance;
    }
    
    /// EBhEnh擾
    HWND get_window_handle ( void ) const
    {
        return handle_window;
    }
    
    /// EBhE\Ă邩擾
    bool is_window_visible ( void ) const
    {
        return IsWindow(handle_window) && IsWindowVisible(handle_window);
    }
    
    /// VXe^C}[̐x擾
    UINT get_systimer_precision ( void ) const
    {
        return num_systimer_precision;
    }
    
};


} /* namespace BK */


#endif /* _BODY_APPLICATION_W32APPLICATIONDEVICE_H_20040204Wed_132650_ */
