/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - {fBZNV - [eBeB
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief {fBZNV: [eBeB
 *
 * [eBeB̊ˑ񋟂܂B
 *
 * @author ABE Shigeru
 * @date 2003/09/13
 */
#ifndef _BODY_UTILITY_MAIN_H_20030913Sat_074822_
#define _BODY_UTILITY_MAIN_H_20030913Sat_074822_


/*   CN[h
------------------------------------------------------------------- */
#include "schema/main.h"


/*   CN[h
------------------------------------------------------------------- */
#include "bk_exception.h"
#include "bk_W32CriticalSection.h"
#include "bk_W32Event.h"
#include "bk_WindowProcedure.h"
#include "bk_dx.h"


/*   O[o֐
------------------------------------------------------------------- */
namespace BK {


/// RECT  Rect2 ɕϊ
inline BK::Rect2 toRect2 ( RECT r )
{
    return BK::Rect2( r.left, r.top, r.right, r.bottom );
}


/// POINT  Point2 ɕϊ
inline BK::Point2 toPoint2 ( POINT p )
{
    return BK::Point2( p.x, p.y );
}


/// SIZE  Size2 ɕϊ
inline BK::Size2 toSize2 ( SIZE s )
{
    return BK::Size2( s.cx, s.cy );
}


/// Point2  POINT ɕϊ
inline POINT toPOINT ( Point2 const & p )
{
    POINT ret;
    ret.x = p.get_x();
    ret.y = p.get_y();
    return ret;
}


/// Rect2  RECT ɕϊ
inline RECT toRECT ( Rect2 const & r )
{
    RECT ret;
    ret.left = r.get_left();
    ret.right = r.get_right();
    ret.top = r.get_top();
    ret.bottom = r.get_bottom();
    return ret;
}


} /* namespace BK */


/*   Win32 API O[o֐
------------------------------------------------------------------- */
namespace BK {
namespace Win32 {


/// VXe^C}[̐xŏlɐݒ肷
/**
 * @return ݒ肳ꂽ^C}[̐x (msec)
 */
UINT initialize_system_timer ( void );


/// VXe^C}[̐ݒ
/**
 * @param prec [in] ݒ肳ꂽVXe^C}[̐x
 */
bool finalize_system_timer ( UINT prec );


/// CX^Xnh擾
/**
 * ̃vÕCX^Xnh擾܂B
 */
HINSTANCE get_current_instance_handle ( void );


/// vZX̃nh擾
/**
 * ݎs̃vZX̃nh擾܂B
 */
HANDLE get_current_process_handle ( void );


/// ANeBuȃEBhẼnh擾
/**
 * ݃ANeBuɂȂĂEBhẼnh擾܂B
 */
HWND get_active_window_handle ( void );


/// JgXbh ID 擾
/**
 * ݎs̃Xbh ID 擾܂B
 */
DWORD get_current_thread_id ( void );


/// w肳ꂽR[h̃bZ[W擾
/**
 * G[bZ[W̎擾Ɏg܂B
 */
std::string get_message ( DWORD code );


/// ŌɔG[̃bZ[W擾
/**
 * GetLastError() œꂽR[h get_message() ɓn܂B
 */
inline std::string get_lasterror_message ( void )
{
    return get_message(GetLastError());
}


/// GUID 𕶎ɕϊ
std::string GUID_to_str ( GUID const & guid );


} /* namespace Win32 */
} /* namespace BK */


#endif /* _BODY_UTILITY_MAIN_H_20030913Sat_074822_ */
