/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - {fBZNV - OtBbN - C[ - C[WC[
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief {fBZNV: OtBbN: C[: C[WC[
 *
 * C[WC[̎`܂B
 *
 * @author ABE Shigeru
 * @date 2003/12/14
 */
#ifndef _BODY_GRAPHIC_LAYER_DX9IMAGELAYER_H_20031214Sun_223231_
#define _BODY_GRAPHIC_LAYER_DX9IMAGELAYER_H_20031214Sun_223231_


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// DirectX gpC[WC[
class Dx9ImageLayer : public ImageLayer
{
public:
    
    /// eNX
    typedef ImageLayer parent_t;
    
public: /* RubyObject C^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    virtual void ruby_gc_mark ( void );
    
    /// Kx[WRNg̃ObZ[Wo̓tO擾
    //virtual bool is_ruby_gc_log_enabled ( void ) const;
    
    /// Ruby inspect \bh
    //virtual char * ruby_inspect ( char * buf, unsigned int cap ) const;
    
    /// Ruby IuWFNgɂ郉bsOCxg
    virtual void on_ruby_wrap ( void );
    
public: /* Layer C^[tFCX */
    
    /// `Cxg
    virtual void execute ( GraphicDevice * dev );
    
public: /* ProjectionLayer C^[tFCX */
    
    /// ]̈̓o^
    virtual ProjectionInfo * register_projection ( void );
    
    /// ]̈̍폜
    virtual void delete_projection ( ProjectionInfo * ptr );
    
    /// o^Ă]̈̐擾
    virtual unsigned int count_projection ( void ) const;
    
public:
    
    /// gp钸_^
    typedef DirectX::Tex1TLVertex vertex_t;
    
    /// C[WC[p̓]̈
    class info_t : public DirectX::TextureProjectionInfo < vertex_t >
    {
    public:
        
        /// eNX̌^
        typedef DirectX::TextureProjectionInfo < vertex_t > info_parent_t;
        
    public: /* RubyObject C^[tFCX */
        
        /// Ruby Kx[WRNgp}[N
        virtual void ruby_gc_mark ( void );
        
        /// Kx[WRNg̃ObZ[Wo̓tO擾
        //virtual bool is_ruby_gc_log_enabled ( void ) const;
        
        /// Ruby inspect \bh
        //virtual char * ruby_inspect ( char * buf, unsigned int cap ) const;
        
        /// Ruby IuWFNgɂ郉bsOCxg
        virtual void on_ruby_wrap ( void );
        
    public: /* ProjectionInfo C^[tFCX */
        
        /// ]W̐ݒ
        /**
         * ̃IuWFNgC[WQƂĂ邱ƂɂA
         * ݒƓɃAXyNg䂪vZ܂B
         */
        virtual void set_source ( const Rect2 & r );
        
        /// ]̈̐ݒ
        /**
         * Rect2 w肷 set_source() ƈقȂA
         * AXyNg`̓XvCgRs[܂B
         */
        virtual void set_source ( const SpriteFieldData & sprite );
        
    public: /* TextureProjectionInfo C^[tFCX */
        
        /// KvȒ_̎擾
        virtual unsigned int count_vertex ( void ) const
        {
            return 6;
        }
        
        /// _f[^̏
        virtual unsigned int initialize_vertex ( vertex_t * vbuf );
        
    private:
        
        /// QƂĂC[W
        Image & obj_image;
        
        /// AXyNg
        AspectRect2 rect_aspect;
        
    public:
        
        /// RXgN^
        info_t ( Image & image );
        
        /// AXyNg擾
        const AspectRect2 & get_aspect ( void ) const
        {
            return rect_aspect;
        }
        
    };
    
private:
    
    /// C[WIuWFNg
    /**  NULL ۏ؂܂B */
    Dx9Texture * const ptr_image;
    
    /// ]̈̃Xg
    DirectX::ProjectionVertexBuffer < vertex_t, info_t > obj_list;
    
public:
    
    /// RXgN^
    Dx9ImageLayer ( Image & image );
    
    /// fXgN^
    virtual ~Dx9ImageLayer ();
    
};


} /* namespace BK */


#endif /* _BODY_GRAPHIC_LAYER_DX9IMAGELAYER_H_20031214Sun_223231_ */
