/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - {fBZNV - OtBbN - PNG c[
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief {fBZNV: OtBbN: PNG c[
 
 * PNG `̃OtBbNf[^߂̃[eBeBNX`܂B
 *
 * @author ABE Shigeru
 * @date 2003/12/23
 */
#ifndef _BODY_GRAPHIC_PNGTOOL_H_20031223Tue_150430_
#define _BODY_GRAPHIC_PNGTOOL_H_20031223Tue_150430_


/*   CN[h
------------------------------------------------------------------- */
#include "png.h"


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// PNG f[^
class PNGData
{
private:
    
    /// PNG f[^
    png_struct * ptr_png;
    
    /// PNG f[^
    png_info * ptr_png_info;
    
    /// PNG I[
    png_info * ptr_end_info;
    
    /// 
    png_uint_32 num_width;
    
    /// c
    png_uint_32 num_height;
    
    /// rbg[x
    int num_depth;
    
    /// sNZtH[}bg
    int num_color_format;
    
public:
    
    /// RXgN^
    PNGFile ( void );
    
    /// fXgN^
    ~PNGFile ();
    
    /// t@C̓ǂݍ
    bool read_file ( FILE * file );
    
};


/// PNG c[Lbg
/**
 * PNG t@C߂̃c[LbgNXłB
 */
class PNGTool
{
private:
    
public:
    
    /// t@Cǂݍ
    /**
     * @return 
     * @retval NULL w肳ꂽt@C PNG t@Cł͂Ȃ
     */
    static void * read_file ( const char * filename );
    
    /// w肳ꂽf[^ PNG t@C̃wb_ł邩𒲂ׂ
    /**
     * Œł 8 oCg̃f[^pӂKv܂B
     *
     * @param buffer [in] f[^߂ꂽobt@
     * @param cap [in] f[^TCY
     * @retval true PNG t@C̃wb_ł
     * @retval false sȃwb_
     */
    static bool is_png_signature ( void * buffer, unsigned int cap );
    
};


} /* namespace BK */


#endif /* _BODY_GRAPHIC_PNGTOOL_H_20031223Tue_150430_ */
