/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - {fBZNV - OtBbN - ]̈obt@
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief {fBZNV: OtBbN: ]̈obt@
 *
 * _f[^̃obt@ǉA]̈̃obt@NX`܂B
 *
 * @author ABE Shigeru
 * @date 2003/12/19
 */
#ifndef _BODY_GRAPHIC_PROJECTIONVERTEXBUFFER_H_20031229Mon_095401_
#define _BODY_GRAPHIC_PROJECTIONVERTEXBUFFER_H_20031229Mon_095401_


/*   NX`
------------------------------------------------------------------- */
namespace BK {
namespace DirectX {


/// ]̈惌C[p̒_obt@
/**
 * ]̈gp郌C[̃ReiNXłB
 * _obt@Ɠ]̈ǗA_̃\[gȂǂs܂B
 *
 * ܂钸_́Aׂēv~eBułȂ΂Ȃ܂B
 * ꕔ̂ݎOp`t@Aق͎Op`XgcƂg͂ł܂B
 */
template < typename vertex_t, typename info_t >
class ProjectionVertexBuffer : public BK::ProjectionInfoArray < info_t >
{
public:
    
    /// eNX̌^
    typedef BK::ProjectionInfoArray < info_t > parent_t;
    
private:
    
    /// _obt@
    vertex_t * ary_vertex;
    
    /// _f[^
    unsigned int num_vertex_length;
    
    /// _obt@̗e
    unsigned int num_vertex_capacity;
    
public:
    
    /// RXgN^
    /**
     * @param infotcap [in] ]̈̏obt@TCY
     * @param vertexcap [in] _f[^̏obt@TCY
     */
    ProjectionVertexBuffer ( unsigned int infocap, unsigned int vertexcap )
            : parent_t (infocap),
              num_vertex_length (0)
    {
        num_vertex_capacity = vertexcap;
        ary_vertex = reinterpret_cast< vertex_t * >
            (HeapAlloc( GetProcessHeap(), HEAP_NO_SERIALIZE, num_vertex_capacity * sizeof(vertex_t) ));
    }
    
    /// fXgN^
    virtual ~ProjectionVertexBuffer ()
    {
        HeapFree( GetProcessHeap(), HEAP_NO_SERIALIZE, ary_vertex );
    }
    
    /// _obt@̏s
    /**
     * ]̈񂩂A_f[^̃Xg\z܂B
     *
     * @return \[gς݂̓]̈惊Xg
     */
    virtual const list_t & execute ( void )
    {
        const list_t & infoary = parent_t::get_sorted_array();
        
        const list_t::const_iterator e = infoary.end();
        list_t::const_iterator itr;
        
        // _obt@̗p
        unsigned int vs = 0;
        for( itr = infoary.begin(); itr != e; ++itr ) {
            vs += (*itr)->count_vertex();
        }
        if( num_vertex_capacity < vs ) {
            while( num_vertex_capacity < vs ) {
                num_vertex_capacity *= 2;
            }
            ary_vertex = reinterpret_cast< vertex_t * >
                (HeapReAlloc( GetProcessHeap(), HEAP_NO_SERIALIZE, ary_vertex, num_vertex_capacity * sizeof(vertex_t) ));
        }
        
        // _obt@̏
        vertex_t * vptr = ary_vertex;
        
        for( itr = infoary.begin(); itr != e; ++itr ) {
            vptr += (*itr)->initialize_vertex( vptr );
        }
        num_vertex_length = vptr - ary_vertex;
        
        return infoary;
    }
    
    /// _f[^擾
    const vertex_t * get_vertex_array ( void ) const
    {
        return ary_vertex;
    }
    
    /// ݒ肳Ă钸_f[^擾
    unsigned int get_vertex_length ( void ) const
    {
        return num_vertex_length;
    }
    
};


} /* namespace DirectX */
} /* namespace BK */


#endif /* _BODY_GRAPHIC_PROJECTIONVERTEXBUFFER_H_20031229Mon_095401_ */
