/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - {fBZNV - OtBbN - eNX`gp]̈
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief {fBZNV: OtBbN: eNX`gp]̈
 *
 * eNX`gp]̈Ɋւx[XNX`܂B
 *
 * @author ABE Shigeru
 * @date 2003/12/19
 */
#ifndef _BODY_GRAPHIC_TEXTUREPROJECTIONINFO_H_20031219Fri_145605_
#define _BODY_GRAPHIC_TEXTUREPROJECTIONINFO_H_20031219Fri_145605_


/*   NX`
------------------------------------------------------------------- */
namespace BK {
namespace DirectX {


/// eNX`gp]̈̊NX
/**
 * eNX`gp]̈ɊւNXłB
 *
 * ]Fݒ肵Ȃꍇ́AC[Ŵ܂ܕ`܂܂B
 */
template < typename vertex_t >
class TextureProjectionInfo : public ProjectionInfo
{
public: /* RubyObject C^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    //virtual void ruby_gc_mark ( void );
    
    /// Kx[WRNg̃ObZ[Wo̓tO擾
    //virtual bool is_ruby_gc_log_enabled ( void ) const;
    
    /// Ruby inspect \bh
    //virtual char * ruby_inspect ( char * buf, unsigned int cap ) const;
    
    /// Ruby IuWFNgɂ郉bsOCxg
    //virtual void on_ruby_wrap ( void );
    
public: /* ProjectionInfo C^[tFCX */
    
    /// ]F̐ݒ
    virtual void set_color ( const AlphaColor * c )
    {
        ProjectionInfo::set_color( c );
        if( c != NULL ) {
            num_diffuse = DirectX::AlphaColor_to_D3DCOLOR( *c );
        } else {
            num_diffuse = D3DCOLOR_ARGB(0xff, 0xff, 0xff, 0xff);
        }
    }
    
public: /* TextureProjectionInfo C^[tFCX */
    
    /// KvȒ_̎擾
    /**
     * @return ProjectionInfo ɕKvȒ_
     */
    virtual unsigned int count_vertex ( void ) const = 0;
    
    /// _f[^̏
    /**
     * ]̈̏ɊÂA_f[^̏s܂B
     * n钸_f[^ count_vertex() Ԃ͊mۂĂ邱Ƃۏ؂Ă܂B
     *
     * @return 񂾒_
     */
    virtual unsigned int initialize_vertex ( vertex_t * vbuf ) = 0;
    
private:
    
    /// fBt[YF
    D3DCOLOR num_diffuse;
    
public:
    
    /// RXgN^
    TextureProjectionInfo ( void )
        : num_diffuse (D3DCOLOR_ARGB(0xff, 0xff, 0xff, 0xff))
    {
    }
    
    /// fBt[YF̎擾
    D3DCOLOR const & get_diffuse ( void ) const
    {
        return num_diffuse;
    }
    
};


} /* namespace DirectX */
} /* namespace BK */


#endif /* _BODY_GRAPHIC_TEXTUREPROJECTIONINFO_H_20031219Fri_145605_ */
