/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - {fBZNV - OtBbN - C[ - tBC[
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief {fBZNV: OtBbN: C[: tBC[
 *
 * tBC[̎`܂B
 *
 * @author ABE Shigeru
 * @date 2003/12/14
 */
#ifndef _BODY_GRAPHIC_LAYER_W32FILMLAYER_H_20031229Mon_102855_
#define _BODY_GRAPHIC_LAYER_W32FILMLAYER_H_20031229Mon_102855_


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// Win32 ptBC[
class W32FilmLayer : public BK::FilmLayer
{
public: /* RubyObject C^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    virtual void ruby_gc_mark ( void );
    
public: /* Layer C^[tFCX */
    
    /// `Cxg
    virtual void execute ( GraphicDevice * dev );
    
public: /* ProjectionLayer C^[tFCX */
    
    /// ]̈̓o^
    virtual ProjectionInfo * register_projection ( void );
    
    /// ]̈̍폜
    virtual void delete_projection ( ProjectionInfo * ptr );
    
    /// o^Ă]̈̐擾
    virtual unsigned int count_projection ( void ) const;
    
public:
    
    /// ]̈惊Xǧ^
    typedef Win32::ProjectionInfoBuffer < info_t > list_t;
    
private:
    
    /// ]̈̃Xg
    list_t obj_list;
    
public:
    
    /// RXgN^
    W32FilmLayer ( void );
    
    /// fXgN^
    virtual ~W32FilmLayer ();
    
};


} /* namespace BK */


#endif /* _BODY_GRAPHIC_LAYER_W32FILMLAYER_H_20031229Mon_102855_ */
