/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - LN^[ - CharacterScript
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: LN^[: CharacterScript
 *
 * LN^[𐧌䂷̂ɎgAXNvgIuWFNg`܂B
 *
 * @author ABE Shigeru
 * @date 2003/12/05
 */
#ifndef _SCHEMA_APPLICATION_CHARACTER_CHARACTERSCRIPT_H_20031205Fri_162520_
#define _SCHEMA_APPLICATION_CHARACTER_CHARACTERSCRIPT_H_20031205Fri_162520_


/*   NX錾
------------------------------------------------------------------- */
namespace BK {

class Character;

} /* namespace BK */


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// LN^[XNvgNX
/**
 * G[WFg𓮍삳邽߂̃f[^\IuWFNgłB
 */
class CharacterScript : public RubyObject
{
public:
    
    /// eNX
    typedef RubyObject parent_t;
    
private: /* static ϐ */
    
    /// Ruby NX: CharacterScript
    static VALUE ruby_class_object;
    
public: /* static \bh */
    
    /// Ruby NX擾
    static VALUE get_ruby_class ( void );
    
    /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
    static bool is_kind_of ( VALUE obj )
    {
        return xrb_is_kind_of(obj, get_ruby_class());
    }
    
    /// Ruby IuWFNgIuWFNgɕϊ
    static CharacterScript * value_to_data ( VALUE obj )
    {
        return ruby_basecast< CharacterScript, RubyObject >( obj );
    }
    
protected: /* RubyObject C^[tFCX */
    
    /// Ruby NXIuWFNg擾
    virtual VALUE get_ruby_class_object ( void ) const
    {
        return get_ruby_class();
    }
    
public: /* RubyObject C^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    //virtual void ruby_gc_mark ( void );
    
    /// Kx[WRNg̃ObZ[Wo̓tO擾
    virtual bool is_ruby_gc_log_enabled ( void ) const;
    
    /// Ruby inspect \bh
    //virtual char * ruby_inspect ( char * buf, unsigned int cap ) const;
    
    /// Ruby IuWFNgɂ郉bsOCxg
    //virtual void on_ruby_wrap ( void );
    
public:
    
    /// LN^[G[WFg
    /**
     * XNvgƃLN^[̃A\VG[V\ۃNXłB
     * ̂́AXNvgɂč쐬܂B
     * 쐬ꂽG[WFǵALN^[Ɋi[܂B
     *
     * G[WFg 1 Xebvs邱Ƃł܂B
     * I OnOffObject ̒~Ԃɂĕ\܂B
     */
    class Agent : public OnOffObject
    {
    public:
        
        /// eNX
        typedef OnOffObject agent_parent_t;
        
    protected: /* OnOffObject pC^[tFCX */
        
        /// ANeBuԂωƂ̃Cxgnh
        //virtual void on_activate ( stat_t status );
        
    public: /* CharacterScript::Agent C^[tFCX */
        
        /// LN^[̓o^
        /**
         * w肳ꂽLN^[̃G[WFgɓo^܂B
         * łɃLN^[o^ĂꍇAēxAs܂B
         *
         * @retval true o^ɐ
         * @retval false w肳ꂽLN^[ƃXNvg̐ڑ𐶐邱Ƃ͂łȂ
         */
        virtual bool connect_character ( Character * chr );
        
        /// G[WFg̎s
        /**
         * G[WFg 1 Xebvs܂B
         * ׂĂ̎sIꍇAG[WFg~ԂɂKv܂B
         */
        virtual void execute ( void ) = 0;
        
    private:
        
        /// ڑĂLN^[
        Character * ptr_character;
        
        /// ڑĂXNvg
        CharacterScript * const ptr_script;
        
    public:
        
        /// RXgN^
        Agent ( CharacterScript & script );
        
        /// fXgN^
        virtual ~Agent ();
        
        /// ڑĂLN^[擾
        /**
         * @retval NULL LN^[͂܂ڑĂȂ
         */
        Character * get_character ( void ) const
        {
            return ptr_character;
        }
        
        /// ڑĂXNvg擾
        CharacterScript * get_script ( void ) const
        {
            return ptr_script;
        }
        
    };
    
public: /* CharacterScript C^[tFCX */
    
    /// G[WFg̍쐬
    /**
     * ̃XNvgɐڑꂽG[WFg𐶐܂B
     * G[WFggpɂ́ALN^[ƐڑȂ΂Ȃ܂B
     * G[WFǧ^́AXNvgɂČ肳܂B
     */
    virtual Agent * create_agent ( void ) = 0;
    
public:
    
    /// RXgN^
    CharacterScript ( void );
    
    /// fXgN^
    virtual ~CharacterScript ( void );
    
};


} /* namespace BK */


/*   Init/Exit ֐
------------------------------------------------------------------- */
namespace BK {


/// AvP[VfoCXELN^[̏
void Init_application_character_CharacterScript ( void );


/// AvP[VfoCXELN^[̏I
void Exit_application_character_CharacterScript ( void );


} /* namespace BK */


#endif /* _SCHEMA_APPLICATION_CHARACTER_CHARACTERSCRIPT_H_20031205Fri_162520_ */
