/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - LN^[ - ContainerScript
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: LN^[: ContainerScript
 *
 * XNvgi[邽߂̃XNvgNX`܂B
 *
 * @author ABE Shigeru
 * @date 2003/12/05
 */
#ifndef _SCHEMA_APPLICATION_CHARACTER_CONTAINERSCRIPT_H_20031205Fri_182451_
#define _SCHEMA_APPLICATION_CHARACTER_CONTAINERSCRIPT_H_20031205Fri_182451_


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// XNvgi[ReiXNvg
class ContainerScript : public CharacterScript
{
public:
    
    /// eNX
    typedef CharacterScript parent_t;
    
private: /* static ϐ */
    
    /// Ruby NX: ContainerScript
    static VALUE ruby_class_object;
    
public: /* static \bh */
    
    /// Ruby NX擾
    static VALUE get_ruby_class ( void );
    
    /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
    static bool is_kind_of ( VALUE obj )
    {
        return xrb_is_kind_of(obj, get_ruby_class());
    }
    
    /// Ruby IuWFNgIuWFNgɕϊ
    static ContainerScript * value_to_data ( VALUE obj )
    {
        return ruby_basecast< ContainerScript, RubyObject >( obj );
    }
    
protected: /* RubyObject C^[tFCX */
    
    /// Ruby NXIuWFNg擾
    VALUE get_ruby_class_object ( void ) const
    {
        return get_ruby_class();
    }
    
public: /* RubyObject C^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    //virtual void ruby_gc_mark ( void );
    
    /// Kx[WRNg̃ObZ[Wo̓tO擾
    //virtual bool is_ruby_gc_log_enabled ( void ) const;
    
    /// Ruby inspect \bh
    //virtual char * ruby_inspect ( char * buf, unsigned int cap ) const;
    
    /// Ruby IuWFNgɂ郉bsOCxg
    //virtual void on_ruby_wrap ( void );
    
public: /* ContainerScript C^[tFCX */
    
    /// XNvg̒ǉ
    /**
     * w肳ꂽXNvgReiɒǉ܂B
     *
     * @param script [in] ǉXNvg
     */
    virtual void add ( CharacterScript * script ) = 0;
    
    /// XNvg̍폜
    /**
     * w肳ꂽXNvgRei폜܂B
     *
     * @param script [in] 폜XNvg
     * @exception w肳ꂽXNvg͓o^ĂȂ
     */
    virtual void erase ( CharacterScript * script ) = 0;
    
    /// XNvg̎擾
    /**
     * w肳ꂽCfNX̃XNvgRei擾܂B
     *
     * @param n [in] 擾XNvg̃CfNX
     * @retval NULL w肳ꂽCfNX̃XNvg݂͑Ȃ
     */
    virtual CharacterScript * at ( unsigned int n ) = 0;
    
    /// o^ĂXNvg̎擾
    virtual unsigned int size ( void ) const = 0;
    
public:
    
    /// G[WFg
    class Agent : public parent_t::Agent
    {
    public:
        
        /// eNX
        typedef parent_t::Agent agent_parent_t;
        
    public: /* CharacterScript::Agent C^[tFCX */
        
        /// LN^[̓o^
        //virtual bool connect_character ( Character * chr );
        
        /// G[WFg̎s
        //virtual void execute ( void );
        
    public:
        
        /// RXgN^
        Agent ( ContainerScript & script );
        
        /// fXgN^
        ~Agent ();
        
    };
    
public:
    
    /// RXgN^
    ContainerScript ( void );
    
    /// fXgN^
    virtual ~ContainerScript ( void );
    
};


} /* namespace BK */


/*   Init/Exit ֐
------------------------------------------------------------------- */
namespace BK {


/// AvP[VfoCXELN^[̏
void Init_application_character_ContainerScript ( void );


/// AvP[VfoCXELN^[̏I
void Exit_application_character_ContainerScript ( void );


} /* namespace BK */


#endif /* _SCHEMA_APPLICATION_CHARACTER_CONTAINERSCRIPT_H_20031205Fri_182451_ */
