/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - LN^[ - EventConditionScript
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: LN^[: EventConditionScript
 *
 * Cxg̕ωIƂXNvgNX`܂B
 *
 * @author ABE Shigeru
 * @date 2003/12/05
 */
#ifndef _SCHEMA_APPLICATION_CHARACTER_EVENTCONDITIONSCRIPT_H_20031205Fri_171709_
#define _SCHEMA_APPLICATION_CHARACTER_EVENTCONDITIONSCRIPT_H_20031205Fri_171709_


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// CxgŏIXNvg
class EventConditionScript : public CharacterScript
{
public:
    
    /// eNX
    typedef CharacterScript parent_t;
    
private: /* static ϐ */
    
    /// Ruby NX: EventConditionScript
    static VALUE ruby_class_object;
    
public: /* static \bh */
    
    /// Ruby NX擾
    static VALUE get_ruby_class ( void );
    
    /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
    static bool is_kind_of ( VALUE obj )
    {
        return xrb_is_kind_of(obj, get_ruby_class());
    }
    
    /// Ruby IuWFNgIuWFNgɕϊ
    static EventConditionScript * value_to_data ( VALUE obj )
    {
        return ruby_basecast< EventConditionScript, RubyObject >( obj );
    }
    
protected: /* RubyObject C^[tFCX */
    
    /// Ruby NXIuWFNg擾
    VALUE get_ruby_class_object ( void ) const
    {
        return get_ruby_class();
    }
    
public: /* RubyObject C^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    //virtual void ruby_gc_mark ( void );
    
    /// Kx[WRNg̃ObZ[Wo̓tO擾
    //virtual bool is_ruby_gc_log_enabled ( void ) const;
    
    /// Ruby inspect \bh
    //virtual char * ruby_inspect ( char * buf, unsigned int cap ) const;
    
    /// Ruby IuWFNgɂ郉bsOCxg
    //virtual void on_ruby_wrap ( void );
    
public: /* CharacterScript C^[tFCX */
    
    /// G[WFg̍쐬
    //virtual CharacterScript::Agent * create_agent ( void );
    
public:
    
    /// G[WFg
    class Agent : public parent_t::Agent
    {
    public:
        
        /// eNX
        typedef parent_t::Agent agent_parent_t;
        
    public: /* CharacterScript::Agent C^[tFCX */
        
        /// LN^[̓o^
        //virtual bool connect_character ( Character * chr );
        
        /// G[WFg̎s
        //virtual void execute ( void );
        
    public:
        
        /// RXgN^
        Agent ( EventConditionScript & script );
        
        /// fXgN^
        ~Agent ();
        
    };
    
public:
    
    /// RXgN^
    EventConditionScript ( void );
    
    /// fXgN^
    virtual ~EventConditionScript ( void );
    
};


} /* namespace BK */


/*   Init/Exit ֐
------------------------------------------------------------------- */
namespace BK {


/// AvP[VfoCXELN^[̏
void Init_application_character_EventConditionScript ( void );


/// AvP[VfoCXELN^[̏I
void Exit_application_character_EventConditionScript ( void );


} /* namespace BK */


#endif /* _SCHEMA_APPLICATION_CHARACTER_EVENTCONDITIONSCRIPT_H_20031205Fri_171709_ */
