/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - MA - FillScreenGear
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: MA: FillScreenGear
 *
 * XN[Sʂ̓hԂsMA`܂B
 *
 * @author ABE Shigeru
 * @date 2004/02/10
 */
#ifndef _SCHEMA_APPLICATION_FILLSCREENGEAR_H_20040210Tue_223310_
#define _SCHEMA_APPLICATION_FILLSCREENGEAR_H_20040210Tue_223310_


/*   NX錾
------------------------------------------------------------------- */
namespace BK {

class FillLayer;
class LayerArray;

} /* namespace BK */


/*   NX̒`
------------------------------------------------------------------- */
namespace BK {


/// XN[hԂMA
/**
 * XN[̑Sʂ FillLayer ɂēhԂMA񋟂܂B
 *
 * ̃MÁAOtBbNfoCXɐݒ肳Ă郌C[ACɑ΂A
 * VɃC[ǉ܂B
 * iC[ = /FillScreenGear:xxxxxxxxj
 */
class FillScreenGear : public TimerGear
{
public:
    
    /// eNX
    typedef TimerGear parent_t;
    
private: /* static ϐ */
    
    /// Ruby NX: FillScreenGear
    static VALUE ruby_class_object;
    
public: /* static \bh */
    
    /// Ruby NX擾
    static VALUE get_ruby_class ( void );
    
    /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
    static bool is_kind_of ( VALUE obj )
    {
        return xrb_is_kind_of(obj, get_ruby_class());
    }
    
    /// Ruby IuWFNgIuWFNgɕϊ
    static FillScreenGear * value_to_data ( VALUE obj )
    {
        return ruby_basecast< FillScreenGear, RubyObject >( obj );
    }
    
protected: /* RubyObject C^[tFCX */
    
    /// Ruby NXIuWFNg擾
    virtual VALUE get_ruby_class_object ( void ) const
    {
        return get_ruby_class();
    }
    
public: /* RubyObject C^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    virtual void ruby_gc_mark ( void );
    
    /// Kx[WRNg̃ObZ[Wo̓tO擾
    //virtual bool is_ruby_gc_log_enabled ( void ) const;
    
    /// Ruby inspect \bh
    //virtual char * ruby_inspect ( char * buf, unsigned int cap ) const;
    
    /// Ruby IuWFNgɂ郉bsOCxg
    virtual void on_ruby_wrap ( void );
    
public: /* OnOffObject C^[tFCX */
    
    /// ANeBuԂωƂ̃Cxgnh
    virtual void on_activate ( stat_t status );
    
public: /* Gear C^[tFCX */
    
    /// ^C}[Cxg
    //virtual void execute ( void );
    
private:
    
    /// C[
    const std::string str_layername;
    
    /// C[IuWFNg̑郌C[AC
    LayerArray * ptr_layerary;
    
    /// C[IuWFNg
    FillLayer * ptr_layer;
    
    /// hԂ̈
    ProjectionInfo * ptr_projection;
    
public:
    
    /// RXgN^
    /**
     * ftHgł́AtF[hpC[͍ŏʂɒu܂B
     * hԂF #000000@FF łB
     */
    FillScreenGear ( void );
    
    /// fXgN^
    virtual ~FillScreenGear ();
    
    /// hԂF̎擾
    AlphaColor get_fill_color ( void ) const;
    
    /// hԂF̐ݒ
    void set_fill_color ( const AlphaColor & color );
    
    /// x[XC[̐ݒ
    /**
     * tF[hpC[̔zuꏊݒ肵܂B
     * w肳ꂽO̒ɔzu܂B
     * NULL w肵ꍇAłwɔzu܂B
     *
     * @param name [in] tF[hpC[uʒu
     * @exception argument_exception w肳ꂽC[݂Ȃ
     */
    void set_base_layer ( const char * name );
    
};


} /* namespace BK */


/*   CN[h
------------------------------------------------------------------- */
#include "ad_FadeInGear.h"
#include "ad_FadeOutGear.h"


/*   Init/Exit ֐
------------------------------------------------------------------- */
namespace BK {


/// AvP[VfoCXEMȀ
void Init_application_gear_FillScreenGear ( void );


/// AvP[VfoCXEMȀI
void Exit_application_gear_FillScreenGear ( void );


} /* namespace BK */


#endif /* _SCHEMA_APPLICATION_FILLSCREENGEAR_H_20040210Tue_223310_ */
