/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - LN^[ - FrameConditionScript
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: LN^[: FrameConditionScript
 *
 * t[̌o߂IƂXNvgNX`܂B
 *
 * @author ABE Shigeru
 * @date 2003/12/05
 */
#ifndef _SCHEMA_APPLICATION_CHARACTER_FRAMECONDITIONSCRIPT_H_20031205Fri_171103_
#define _SCHEMA_APPLICATION_CHARACTER_FRAMECONDITIONSCRIPT_H_20031205Fri_171103_


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// t[̌o߂ŏIXNvg
/**
 * w肳ꂽt[o߂ɏIXNvg\܂B
 *
 * ̃XNvg̃G[WFǵAXNvg̃t[ 5 w肵ꍇA
 * 5 t[̎sIɒ~܂B
 */
class FrameConditionScript : public CharacterScript
{
public:
    
    /// eNX
    typedef CharacterScript parent_t;
    
private: /* static ϐ */
    
    /// Ruby NX: FrameConditionScript
    static VALUE ruby_class_object;
    
public: /* static \bh */
    
    /// Ruby NX擾
    static VALUE get_ruby_class ( void );
    
    /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
    static bool is_kind_of ( VALUE obj )
    {
        return xrb_is_kind_of(obj, get_ruby_class());
    }
    
    /// Ruby IuWFNgIuWFNgɕϊ
    static FrameConditionScript * value_to_data ( VALUE obj )
    {
        return ruby_basecast< FrameConditionScript, RubyObject >( obj );
    }
    
protected: /* RubyObject C^[tFCX */
    
    /// Ruby NXIuWFNg擾
    VALUE get_ruby_class_object ( void ) const
    {
        return get_ruby_class();
    }
    
public: /* RubyObject C^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    //virtual void ruby_gc_mark ( void );
    
    /// Kx[WRNg̃ObZ[Wo̓tO擾
    //virtual bool is_ruby_gc_log_enabled ( void ) const;
    
    /// Ruby inspect \bh
    //virtual char * ruby_inspect ( char * buf, unsigned int cap ) const;
    
    /// Ruby IuWFNgɂ郉bsOCxg
    //virtual void on_ruby_wrap ( void );
    
public: /* CharacterScript C^[tFCX */
    
    /// G[WFg̍쐬
    //virtual CharacterScript::Agent * create_agent ( void );
    
public: /* FrameConditionScript C^[tFCX */
    
    /// I܂ł̎Ԃݒ肷
    /**
     * @param length [in] I܂ł̎ (~b)
     */
    virtual void set_length ( unsigned int length );
    
public:
    
    /// G[WFg
    class Agent : public parent_t::Agent
    {
    public:
        
        /// eNX
        typedef parent_t::Agent agent_parent_t;
        
    public: /* CharacterScript::Agent C^[tFCX */
        
        /// LN^[̓o^
        //virtual bool connect_character ( Character * chr );
        
        /// G[WFg̎s
        //virtual void execute ( void );
        
    private:
        
        /// ݂̃t[JEg
        unsigned int num_current;
        
    public:
        
        /// RXgN^
        Agent ( FrameConditionScript & script );
        
        /// fXgN^
        ~Agent ();
        
        /// ݂̃t[lݒ肷
        virtual void set_current ( unsigned int num );
        
        /// ݂̃t[l擾
        unsigned int get_current ( void ) const
        {
            return num_current;
        }
        
    };
    
private:
    
    /// I܂ł̎
    unsigned int num_length;
    
public:
    
    /// RXgN^
    /** I܂ł̃t[ 0 ŏ܂B */
    FrameConditionScript ( void );
    
    /// RXgN^
    FrameConditionScript ( unsigned int len );
    
    /// fXgN^
    virtual ~FrameConditionScript ( void );
    
    /// I܂ł̎Ԃ擾
    unsigned int get_length ( void ) const
    {
        return num_length;
    }
    
};


} /* namespace BK */


/*   Init/Exit ֐
------------------------------------------------------------------- */
namespace BK {


/// AvP[VfoCXELN^[̏
void Init_application_character_FrameConditionScript ( void );


/// AvP[VfoCXELN^[̏I
void Exit_application_character_FrameConditionScript ( void );


} /* namespace BK */


#endif /* _SCHEMA_APPLICATION_CHARACTER_FRAMECONDITIONSCRIPT_H_20031205Fri_171103_ */
