/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - LN^[ - LinearAlphaScript
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: LN^[: LinearAlphaScript
 *
 * XvCgLN^[̃At@lύX邽߂̃XNvgłB
 * ωp^[ɂ́A`ωgp܂B
 *
 * @author ABE Shigeru
 * @date 2003/12/05
 */
#ifndef _SCHEMA_APPLICATION_CHARACTER_LINEARALPHASCRIPT_H_20031205Fri_195859_
#define _SCHEMA_APPLICATION_CHARACTER_LINEARALPHASCRIPT_H_20031205Fri_195859_


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// At@̐`ωXNvg
/**
 * LN^[̓]̈ɑ΂āAAt@`ɕω邽߂̃XNvgłB
 * ݒłAt@l 0  COLOR_ELEMENT_MAX ܂łłB
 */
class LinearAlphaScript : public FrameConditionScript
{
public:
    
    /// eNX
    typedef FrameConditionScript parent_t;
    
private: /* static ϐ */
    
    /// Ruby NX: LinearAlphaScript
    static VALUE ruby_class_object;
    
public: /* static \bh */
    
    /// Ruby NX擾
    static VALUE get_ruby_class ( void );
    
    /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
    static bool is_kind_of ( VALUE obj )
    {
        return xrb_is_kind_of(obj, get_ruby_class());
    }
    
    /// Ruby IuWFNgIuWFNgɕϊ
    static LinearAlphaScript * value_to_data ( VALUE obj )
    {
        return ruby_basecast< LinearAlphaScript, CharacterScript >( obj );
    }
    
protected: /* RubyObject C^[tFCX */
    
    /// Ruby NXIuWFNg擾
    virtual VALUE get_ruby_class_object ( void ) const
    {
        return get_ruby_class();
    }
    
public: /* RubyObject C^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    //virtual void ruby_gc_mark ( void );
    
    /// Kx[WRNg̃ObZ[Wo̓tO擾
    //virtual bool is_ruby_gc_log_enabled ( void ) const;
    
    /// Ruby inspect \bh
    //virtual char * ruby_inspect ( char * buf, unsigned int cap ) const;
    
    /// Ruby IuWFNgɂ郉bsOCxg
    //virtual void on_ruby_wrap ( void );
    
public: /* CharacterScript C^[tFCX */
    
    /// G[WFg̍쐬
    virtual CharacterScript::Agent * create_agent ( void );
    
public:
    
    /// G[WFg
    class Agent : public parent_t::Agent
    {
    public:
        
        /// eNX
        typedef parent_t::Agent agent_parent_t;
        
    public: /* CharacterScript::Agent C^[tFCX */
        
        /// LN^[̓o^
        virtual bool connect_character ( Character * chr );
        
        /// G[WFg̎s
        virtual void execute ( void );
        
    private:
        
        /// XNvgւ̎Q
        LinearAlphaScript * const ptr_script;
        
        /// ݒ̃LN^[IuWFNg
        SpriteCharacter * ptr_character;
        
    public:
        
        /// RXgN^
        Agent ( LinearAlphaScript & script );
        
        /// fXgN^
        virtual ~Agent ();
        
    };
    
private:
    
    /// JnAt@l
    unsigned int num_begin;
    
    /// IAt@l
    unsigned int num_end;
    
public:
    
    /// RXgN^
    LinearAlphaScript ( void );
    
    /// fXgN^
    virtual ~LinearAlphaScript ();
    
    /// JnAt@l擾
    unsigned int get_begin ( void ) const
    {
        return num_begin;
    }
    
    /// IAt@l擾
    unsigned int get_end ( void ) const
    {
        return num_end;
    }
    
    /// JnAt@lݒ肷
    void set_begin ( unsigned int n );
    
    /// IAt@lݒ肷
    void set_end ( unsigned int n );
    
};


} /* namespace BK */


/*   Init/Exit ֐
------------------------------------------------------------------- */
namespace BK {


/// AvP[VfoCXELN^[̏
void Init_application_character_LinearAlphaScript ( void );


/// AvP[VfoCXELN^[̏I
void Exit_application_character_LinearAlphaScript ( void );


} /* namespace BK */


#endif /* _SCHEMA_APPLICATION_CHARACTER_LINEARALPHASCRIPT_H_20031205Fri_195859_ */
