/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - MA - TimerGear
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: MA: TimerGear
 *
 * w莞Ԃҋ@MA`܂B
 *
 * @author ABE Shigeru
 * @date 2004/03/25
 */
#ifndef _SCHEMA_APPLICATION_GEAR_TIMERGEAR_H_20040325Thu_111554_
#define _SCHEMA_APPLICATION_GEAR_TIMERGEAR_H_20040325Thu_111554_


/*   NX̒`
------------------------------------------------------------------- */
namespace BK {


/// ^C}[MA
/**
 * ̃t[߂ƒ~ԂɂȂMAłB
 */
class TimerGear : public Gear
{
public:
    
    /// eNX
    typedef Gear parent_t;
    
private: /* static ϐ */
    
    /// Ruby NX: TimerGear
    static VALUE ruby_class_object;
    
public: /* static \bh */
    
    /// Ruby NX擾
    static VALUE get_ruby_class ( void );
    
    /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
    static bool is_kind_of ( VALUE obj )
    {
        return xrb_is_kind_of(obj, get_ruby_class());
    }
    
    /// Ruby IuWFNgIuWFNgɕϊ
    static TimerGear * value_to_data ( VALUE obj )
    {
        return ruby_basecast< TimerGear, RubyObject >( obj );
    }
    
protected: /* RubyObject C^[tFCX */
    
    /// Ruby NXIuWFNg擾
    virtual VALUE get_ruby_class_object ( void ) const
    {
        return get_ruby_class();
    }
    
public: /* RubyObject C^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    //virtual void ruby_gc_mark ( void );
    
    /// Kx[WRNg̃ObZ[Wo̓tO擾
    //virtual bool is_ruby_gc_log_enabled ( void ) const;
    
    /// Ruby inspect \bh
    //virtual char * ruby_inspect ( char * buf, unsigned int cap ) const;
    
    /// Ruby IuWFNgɂ郉bsOCxg
    //virtual void on_ruby_wrap ( void );
    
public: /* Gear C^[tFCX */
    
    /// ^C}[Cxg
    virtual void execute ( void );
    
private:
    
    /// ҋ@
    FrameTimer::time_t num_length;
    
public:
    
    /// RXgN^
    TimerGear ( void );
    
    /// fXgN^
    virtual ~TimerGear ();
    
    /// ҋ@Ԃݒ肷
    void set_length ( FrameTimer::time_t n );
    
    /// ҋ@Ԃ擾
    FrameTimer::time_t get_length ( void ) const
    {
        return this->num_length;
    }
    
    /// Nbvς݂̃ANeBu^C}[擾
    FrameTimer::time_t get_clipped_active_time ( void ) const
    {
        const FrameTimer::time_t t = get_active_time();
        return (t > this->num_length) ? this->num_length : t;
    }
    
};


} /* namespace BK */


/*   CN[h
------------------------------------------------------------------- */
#include "ad_FillScreenGear.h"


/*   Init/Exit ֐
------------------------------------------------------------------- */
namespace BK {


/// AvP[VfoCXEMȀ
void Init_application_gear_TimerGear ( void );


/// AvP[VfoCXEMȀI
void Exit_application_gear_TimerGear ( void );


} /* namespace BK */


#endif /* _SCHEMA_APPLICATION_GEAR_TIMERGEAR_H_20040325Thu_111554_ */
