/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - LN^[ - TimerScript
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: LN^[: TimerScript
 *
 * 莞Ԃҋ@邽߂̃XNvgłB
 *
 * @author ABE Shigeru
 * @date 2004/04/01
 */
#ifndef _SCHAMEA_APPLICATION_CHARACTER_TIMERSCRIPT_H_20040401Thu_073911_
#define _SCHAMEA_APPLICATION_CHARACTER_TIMERSCRIPT_H_20040401Thu_073911_


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// ҋ@XNvg
/**
 * w肳ꂽԂҋ@LN^[XNvgłB
 */
class TimerScript : public FrameConditionScript
{
public:
    
    /// eNX
    typedef FrameConditionScript parent_t;
    
private: /* static ϐ */
    
    /// Ruby NX: TimerScript
    static VALUE ruby_class_object;
    
public: /* static \bh */
    
    /// Ruby NX擾
    static VALUE get_ruby_class ( void );
    
    /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
    static bool is_kind_of ( VALUE obj )
    {
        return xrb_is_kind_of(obj, get_ruby_class());
    }
    
    /// Ruby IuWFNgIuWFNgɕϊ
    static TimerScript * value_to_data ( VALUE obj )
    {
        return ruby_basecast< TimerScript, RubyObject >( obj );
    }
    
protected: /* RubyObject C^[tFCX */
    
    /// Ruby NXIuWFNg擾
    VALUE get_ruby_class_object ( void ) const
    {
        return get_ruby_class();
    }
    
public: /* RubyObject C^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    //virtual void ruby_gc_mark ( void );
    
    /// Kx[WRNg̃ObZ[Wo̓tO擾
    //virtual bool is_ruby_gc_log_enabled ( void ) const;
    
    /// Ruby inspect \bh
    //virtual char * ruby_inspect ( char * buf, unsigned int cap ) const;
    
    /// Ruby IuWFNgɂ郉bsOCxg
    //virtual void on_ruby_wrap ( void );
    
public: /* CharacterScript C^[tFCX */
    
    /// G[WFg̍쐬
    virtual CharacterScript::Agent * create_agent ( void );
    
public:
    
    /// G[WFg
    class Agent : public parent_t::Agent
    {
    public:
        
        /// eNX
        typedef parent_t::Agent agent_parent_t;
        
    private:
        
        /// XNvgւ̎Q
        TimerScript * const ptr_script;
        
    public:
        
        /// RXgN^
        Agent ( TimerScript & script );
        
        /// fXgN^
        ~Agent ();
        
        /// G[WFg̎s
        void execute ( void );
    };
    
public:
    
    /// RXgN^
    TimerScript ( void );
    
    /// fXgN^
    ~TimerScript ();
    
};


} /* namespace BK */


/*   Init/Exit ֐
------------------------------------------------------------------- */
namespace BK {


/// AvP[VfoCXELN^[̏
void Init_application_character_TimerScript ( void );


/// AvP[VfoCXELN^[̏I
void Exit_application_character_TimerScript ( void );


} /* namespace BK */


#endif /* _SCHAMEA_APPLICATION_CHARACTER_TIMERSCRIPT_H_20040401Thu_073911_ */
