/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - [eBeB - Cxg
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: [eBeB - Cxg
 *
 * CxgIuWFNgNX̒`s܂B
 *
 * @author ABE Shigeru
 * @date 2003/12/16
 */
#ifndef _SCHEMA_UTILITY_EVENT_H_20031216Tue_081840_
#define _SCHEMA_UTILITY_EVENT_H_20031216Tue_081840_


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// Cxg
/**
 * VOiM邱Ƃ̂łIuWFNgłB
 * ɂĂ̓[U[vOɂG~[VƂȂꍇ܂A{Iɂ́A
 * OS ̋@\gIuWFNgƂȂ܂B
 * ̃IuWFNg̓lCeBuȃ}`XbhŎgp܂B
 *
 * \źAVOiԂłB
 */
class Event
{
public: /* Event C^[tFCX */
    
    /// Cxg̖O擾
    /**
     * ̃CxgIuWFNg̖O擾܂B
     *
     * @retval NULL O͎w肳ĂȂ
     * @return O\
     */
    virtual const char * get_name ( void ) const = 0;
    
    /// CxgɃVOi𑗂
    /**
     * CxgVOiԂɂ܂B
     */
    virtual void send_signal ( void ) = 0;
    
    /// CxgɃVOipX𑗂
    /**
     * CxguԓIɃVOiԂɂ܂B
     */
    virtual void send_pulse ( void ) = 0;
    
    /// Cxg̏ԂVOiԂɖ߂
    /**
     * CxgVOiԂɂ܂B
     */
    virtual void clear ( void ) = 0;
    
    /// CxgVOiԂɂȂ܂őҋ@
    /**
     * CxgVOiԂɂȂ܂őҋ@܂B
     *
     * @param waitmsec [in] ^CAEg܂ł̎ (~b)
     * @retval true VOiԂɂȂ
     * @retval false ^CAEg
     */
    virtual bool wait ( unsigned int waitmsec ) = 0;
    
public:
    
    /// RXgN^
    Event ( void )
    {
    }
    
    /// fXgN^
    virtual ~Event ()
    {
    }
    
    /// CxgVOiԂɂȂĂ邩𒲂ׂ
    /**
     * wait() \bhAҋ@ԃ[ŌĂяo܂B
     *
     * @see wait_signal()
     */
    bool is_signal ( void )
    {
        return wait(0);
    }
};


} /* namespace BK */


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// Ruby Cxg
/**
 * Ruby ŎgpCxgIuWFNgłB
 * ̃IuWFNg̓lCeBuȃ}`XbhɑΉARuby XbhɑΉ܂B
 *
 * \źAVOiԂłB
 */
class RubyEvent : public RubyObject
{
public:
    
    /// eNX
    typedef RubyObject parent_t;
    
private: /* static ϐ */
    
    /// Ruby NX: Event
    static VALUE ruby_class_object;
    
public: /* static \bh */
    
    /// Ruby NX擾
    static VALUE get_ruby_class ( void );
    
    /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
    static bool is_kind_of ( VALUE obj )
    {
        return xrb_is_kind_of(obj, get_ruby_class());
    }
    
    /// Ruby IuWFNgIuWFNgɕϊ
    static RubyEvent * value_to_data ( VALUE obj )
    {
        return ruby_basecast< RubyEvent, RubyObject >( obj );
    }
    
protected: /* Ruby IuWFNgpC^[tFCX */
    
    /// Ruby NXIuWFNg擾
    virtual VALUE get_ruby_class_object ( void ) const
    {
        return get_ruby_class();
    }
    
public: /* Ruby IuWFNgpC^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    //virtual void ruby_gc_mark ( void );
    
    /// Kx[WRNg̃ObZ[Wo̓tO擾
    virtual bool is_ruby_gc_log_enabled ( void ) const
    {
        return false;
    }
    
    /// Ruby inspect \bh
    //virtual char * ruby_inspect ( char * buf, unsigned int cap ) const;
    
    /// Ruby IuWFNgɂ郉bsOCxg
    //virtual void on_ruby_wrap ( void );
    
private:
    
    /// 
    enum
    {
        STATE_NOT_SIGNAL,
        STATE_SIGNAL,
        STATE_PULSE,
    } num_state;
    
public:
    
    /// RXgN^
    /**
     * VOiԂō\z܂B
     */
    RubyEvent ( void );
    
    /// fXgN^
    virtual ~RubyEvent ();
    
    /// VOiԂł邩
    bool is_signal ( void ) const
    {
        return num_state == STATE_SIGNAL;
    }
    
    /// VOiԂɐݒ肷
    /**
     * CxgVOiԂɐݒ肵܂B
     */
    void set ( void );
    
    /// VOiԂɐݒ肷
    /**
     * CxgVOiԂɐݒ肵܂B
     */
    void reset ( void );
    
};


} /* namespace BK */


/*   Init/Exit ֐
------------------------------------------------------------------- */
namespace BK {


/// [eBeB֘ANX̏
void Init_utility_Event ( void );


/// [eBeB֘ANX̏I
void Exit_utility_Event ( void );


} /* namespace BK */


#endif /* _SCHEMA_UTILITY_EVENT_H_20031216Tue_081840_ */
