/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - [eBeB - CAEg
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: [eBeB: CAEg
 *
 * zus߂̃CAEgIuWFNg`܂B
 *
 * @author ABE Shigeru
 * @date 2004/01/06
 */
#ifndef _SCHEMA_UTILITY_LAYOUT_H_20040106Tue_091734_
#define _SCHEMA_UTILITY_LAYOUT_H_20040106Tue_091734_


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// CAEgpf[^l
/**
 * CAEg̃f[^l\̂ɗpIuWFNgłB
 * sNZPʁA͐eCAEgɑ΂䗦ۗL邱Ƃł܂B
 * ݒ肳ꂽꍇAsNZ̒lD悳܂B
 */
class layoutvalue_t
{
private:
    
    /// sNZlݒ肳Ă邱ƂtO
    bool flag_pixel;
    
    /// sNZPʂ̒l
    int num_pixel;
    
    /// p[ZgPʂ̒lݒ肳Ă邱ƂtO
    bool flag_percent;
    
    /// p[ZgPʂ̒l
    float num_percent;
    
public:
    
    /// RXgN^
    /** Ԃ͉ݒ肳ĂȂԂłB */
    layoutvalue_t ( void )
            : flag_pixel (false),
              flag_percent (false),
              num_pixel (0),
              num_percent (0)
    {
    }
    
    /// sNZPʂ̒lݒ肳Ă邩𒲂ׂ
    bool is_pixel ( void ) const
    {
        return flag_pixel;
    }
    
    /// p[ZgPʂ̒lݒ肳Ă邩𒲂ׂ
    /** sNZPʂ̒lݒ肳Ă (p[ZgPʂ̒lgȂ) ꍇłA^Ԃ܂B */
    bool is_percent ( void ) const
    {
        return flag_percent;
    }
    
    /// lݒ肳ĂȂ𒲂ׂ
    bool is_null ( void ) const
    {
        return !is_pixel() && !is_percent();
    }
    
    /// sNZPʂ̒l擾
    int get_pixel ( void ) const
    {
        return num_pixel;
    }
    
    /// p[ZgPʂ̒l擾
    float get_percent ( void ) const
    {
        return num_percent;
    }
    
    /// sNZPʂ̒lݒ肷
    void set_pixel ( int n )
    {
        flag_pixel = true;
        num_pixel = n;
    }
    
    /// p[ZgPʂ̒lݒ肷
    void set_percent ( float n )
    {
        flag_percent = true;
        num_percent = n;
    }
    
    /// sNZPʂ̒l폜
    void clear_pixel ( void )
    {
        flag_pixel = false;
    }
    
    /// p[ZgPʂ̒l폜
    void clear_percent ( void )
    {
        flag_percent = false;
    }
    
    /// TCYf[^擾
    /**
     * sNZPʁAp[ZgPʁA̒lݒ肳ĂȂꍇ́A
     * ef[^̒l̂܂ܕԂ܂B
     *
     * @param owner [in] ef[^̒l
     */
    int get ( int owner ) const
    {
        if( is_pixel() ) {
            return num_pixel;
        }
        if( is_percent() ) {
            return static_cast< int >( owner * num_percent / 100 );
        }
        return owner;
    }
    
    /// rZq
    bool operator == ( const layoutvalue_t & rhs ) const
    {
        if( is_pixel() ) {
            if( rhs.is_pixel() ) {
                return get_pixel() == rhs.get_pixel();
            }
            return false;
        }
        if( is_percent() ) {
            if( rhs.is_percent() ) {
                return get_percent() == rhs.get_percent();
            }
            return false;
        }
        return true;
    }
    
    /// ƂĎ擾
    /**
     * sNZPʂ̒lݒ肳Ăꍇ "ddd" A
     * p[ZgPʂ̒lݒ肳Ăꍇ "ddd%" Ԃ܂B
     * ǂݒ肳ĂȂꍇ͋󕶎Ԃ܂B
     *
     * @return l\
     */
    std::string to_string ( void ) const;
    
};


/// CAEgIuWFNg
/**
 * CAEgIuWFNg̊NXłB
 *
 * ̃NXł́Aȉ̏ۗL܂B
 *  - CAEg̃TCY
 *
 * CAEg̐ݒl (TCYȂ) ύXꂽꍇACAEgւ̔f
 * ł܂Ƃ߂čs܂B
 */
class Layout : public RubyObject
{
public:
    
    /// eNX
    typedef RubyObject parent_t;
    
private: /* static ϐ */
    
    /// Ruby NX: Layout
    static VALUE ruby_class_object;
    
public: /* static \bh */
    
    /// Ruby NX擾
    static VALUE get_ruby_class ( void );
    
    /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
    static bool is_kind_of ( VALUE obj )
    {
        return xrb_is_kind_of(obj, get_ruby_class());
    }
    
    /// Ruby IuWFNgIuWFNgɕϊ
    static Layout * value_to_data ( VALUE obj )
    {
        return ruby_basecast< Layout, RubyObject >( obj );
    }
    
protected: /* RubyObject C^[tFCX */
    
    /// Ruby NXIuWFNg擾
    virtual VALUE get_ruby_class_object ( void ) const
    {
        return get_ruby_class();
    }
    
public: /* RubyObject C^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    //virtual void ruby_gc_mark ( void );
    
    /// Kx[WRNg̃ObZ[Wo̓tO擾
    //virtual bool is_ruby_gc_log_enabled ( void ) const;
    
    /// Ruby inspect \bh
    //virtual char * ruby_inspect ( char * buf, unsigned int cap ) const;
    
    /// Ruby IuWFNgɂ郉bsOCxg
    //virtual void on_ruby_wrap ( void );
    
protected: /* Layout C^[tFCX */
    
    /// CAEgXVȌ
    /**
     * update() sɌĂяo܂Bon_update() ƈႢAKĂяo܂B
     * qCAEg̍XVȂǂs܂B
     */
    virtual void on_invoke_update ( void )
    {
    }
    
    /// CAEg̍XV
    /**
     * CAEg̍XVKvɂȂƂɂ̂݁AĂяo܂B
     * ftHgł́A܂B
     */
    virtual void on_update ( void )
    {
    }
    
    /// CAEg̕sړ
    /**
     * set_point() \bhɂāACAEg̈ʒuύXꂽƂɌĂяo܂B
     * eCAEg͎qCAEg̈ʒuXVȂ΂Ȃ܂B
     *
     * @param delta [in] ړxNg
     */
    virtual void on_set_point ( const Point2 & delta )
    {
    }
    
public:
    
    /// ʒu킹萔
    /**
     * ͈͊O̒l NONE ƂĈ܂B
     */
    enum align_t
    {
        NONE   = 0,
        LEFT   = 1,
        CENTER = 2,
        RIGHT  = 3,
        TOP    = 4,
        MIDDLE = 5,
        BOTTOM = 6,
        FIT    = 7,
    };
    
public: /* static \bh */
    
    /// ʒu킹萔𕶎ɕϊ
    static const char * align_to_string ( align_t align );
    
    /// ʒu킹萔ɕϊ
    /**
     * ϊł镶͏̒P݂̂łBOɋ󔒂܂܂ĂĂ͂Ȃ܂B
     * str  NULL ̏ꍇA܂͉߂łȂ̏ꍇ NONE Ԃ܂B
     */
    static align_t string_to_align ( const char * str );
    
private:
    
    /// ύXtO
    /** ăCAEgKvȏꍇA^ݒ肵܂B */
    bool flag_modified;
    
    /// CAEg̈ʒu
    Point2 point_layout;
    
    /// CAEg̃TCY
    Size2 size_layout;
    
protected:
    
    /// ύXtO𗧂Ă
    /**
     * CAEg̕ύXKvɂȂꍇÃ\bhĂяo܂B
     */
    void set_modified ( void )
    {
        flag_modified = true;
    }
    
public:
    
    /// RXgN^
    /**
     * ʒu (0, 0)ATCY 0 ~ 0 łB
     */
    Layout ( void );
    
    /// fXgN^
    virtual ~Layout ();
    
    /// ύXtOĂ邩𒲂ׂ
    bool is_modified ( void ) const
    {
        return flag_modified;
    }
    
    /// CAEg̈̈ʒu擾
    const Point2 & get_point ( void ) const
    {
        return point_layout;
    }
    
    /// CAEg̈̃TCY擾
    const Size2 & get_size ( void ) const
    {
        return size_layout;
    }
    
    /// CAEg̈̈ʒuݒ肷
    /**
     * eCAEg̈ʒuύXɉāAqCAEgɕsړ܂B
     * ʒuݒɊւĂ update() \bȟĂяoKv܂B
     * qCAEg̈ړ͐eCAEgɂĎȂ΂Ȃ܂B
     */
    void set_point ( const Point2 & p );
    
    /// CAEg̈̃TCYݒ肷
    /**
     * qCAEg̈ʒuȂǂ͕ύX܂B
     * set_point() ƓlɁAupdate() \bh̎sKvɂȂ܂B
     */
    void set_size ( const Size2 & s );
    
    /// CAEg̍XV
    /**
     * CAEgXV܂B
     *
     * ܂ on_invoke_update() ĂяoǍōXVtOIł΁A
     * on_update() Ăяo܂B
     * XVtÓATCY̕ύXvf̒ǉɂăIɂȂ܂B
     *
     * @retval true XVsꂽ
     * @retval false XV͍sȂ
     */
    bool update ( void );
    
};


} /* namespace BK */


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// CAEgXVp̊֐IuWFNg
/**
 * Layout IuWFNgɑ΂āAupdate() \bhĂяoĂ܂B
 * Reiɑ΂ for_each ȂǂŎgp܂B
 */
class LayoutUpdater
{
private:
    
    /// XV
    bool flag_result;
    
public:
    
    /// RXgN^
    LayoutUpdater ( void )
            : flag_result (false)
    {
    }
    
    /// 
    void operator () ( Layout & layout )
    {
        if( layout.update() ) {
            flag_result = true;
        }
    }
    
    /// 
    void operator () ( Layout * ptr )
    {
        if( ptr != NULL ) {
            operator() ( *ptr );
        }
    }
    
    /// ʂ擾
    bool get_result ( void ) const
    {
        return flag_result;
    }
    
};


} /* namespace BK */


/*   CN[h
------------------------------------------------------------------- */
#include "bk_CharLayout.h"
#include "bk_DocumentLayout.h"


/*   Init/Exit ֐
------------------------------------------------------------------- */
namespace BK {


/// [eBeBECAEg̏
void Init_utility_Layout ( void );


/// [eBeBECAEg̏I
void Exit_utility_Layout ( void );


} /* namespace BK */


#endif /* _SCHEMA_UTILITY_LAYOUT_H_20040106Tue_091734_ */
