/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - [eBeB - W
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: [eBeB: W
 *
 * 񎟌W\f[^`܂B
 *
 * @author ABE Shigeru
 * @date 2003/12/11
 */
#ifndef _SCHEMA_UTILITY_POINT2_H_20031211Thu_114150_
#define _SCHEMA_UTILITY_POINT2_H_20031211Thu_114150_


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// 񎟌ԂɂWf[^
/**
 * X W Y WA̗vff[^łB
 * evf͔Cӂ̐܂B
 */
class Point2
{
private: /* static ϐ */
    
    /// Ruby NX: Point2
    static VALUE ruby_class_object;
    
public: /* static \bh */
    
    /// Ruby NX擾
    static VALUE get_ruby_class ( void );
    
    /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
    static bool is_kind_of ( VALUE obj )
    {
        return xrb_is_kind_of(obj, get_ruby_class());
    }
    
    /// Ruby IuWFNgIuWFNgɕϊ
    static Point2 * value_to_data ( VALUE obj )
    {
        return ruby_cast< Point2 >( obj );
    }
    
public:
    
    /// f[^^
    typedef int num_t;
    
private:
    
    /// X Ẅʒu
    num_t  num_x;
    
    /// Y Ẅʒu
    num_t  num_y;
    
public:
    /// X W擾
    const num_t & get_x ( void ) const
    {
        return num_x;
    }
    
    /// X Wݒ肷
    const num_t & set_x ( const num_t & v )
    {
        return num_x = v;
    }
    
    /// Y W擾
    const num_t & get_y ( void ) const
    {
        return num_y;
    }
    
    /// Y Wݒ肷
    const num_t & set_y ( const num_t & v )
    {
        return num_y = v;
    }
    
    /// Wݒ肷
    Point2 & set_point ( const num_t & x, const num_t & y )
    {
        set_x( x );
        set_y( y );
        return *this;
    }
    
    /// Wݒ肷
    Point2 & set_point ( const Point2 & p )
    {
        return set_point( p.get_x(), p.get_y() );
    }
    
    /// RXgN^
    Point2 ( void )
    {
        set_point( 0, 0 );
    }
    
    /// RXgN^
    Point2 ( const Point2 & p )
    {
        set_point( p.get_x(), p.get_y() );
    }
    
    /// RXgN^
    Point2 ( const num_t & argx, const num_t & argy )
    {
        set_point( argx, argy );
    }
    
    /// X Wւ̉Z
    Point2 & add_x ( const num_t & n )
    {
        set_x( get_x() + n );
        return *this;
    }
    
    /// Y Wւ̉Z
    Point2 & add_y ( const num_t & n )
    {
        set_y( get_y() + n );
        return *this;
    }
    
    /// [xNgł邩𒲂ׂ
    bool is_zero ( void ) const
    {
        return get_x() == 0 && get_y() == 0;
    }
    
    /// Z
    Point2 operator + ( const Point2 & p ) const
    {
        return Point2( get_x() + p.get_x(), get_y() + p.get_y() );
    }
    
    /// Z
    Point2 operator - ( const Point2 & p ) const
    {
        return Point2( get_x() - p.get_x(), get_y() - p.get_y() );
    }
    
    /// Z
    Point2 operator * ( int n ) const
    {
        return Point2( get_x() * n, get_y() * n );
    }
    
    /// Z
    Point2 operator / ( int n ) const
    {
        return Point2( get_x() / n, get_y() / n );
    }
    
    /// Z
    Point2 & operator += ( const Point2 & p )
    {
        return set_point( get_x() + p.get_x(), get_y() + p.get_y() );
    }
    
    /// Z
    Point2 & operator -= ( const Point2 & p )
    {
        return set_point( get_x() - p.get_x(), get_y() - p.get_y() );
    }
    
    /// Z
    Point2 & operator *= ( int n )
    {
        return set_point( get_x() * n, get_y() * n );
    }
    
    /// Z
    Point2 & operator /= ( int n )
    {
        return set_point( get_x() / n, get_y() / n );
    }
    
    /// ւ̔]
    Point2 operator - ( void ) const
    {
        return Point2( -get_x(), -get_y() );
    }
    
    /// vr
    bool operator == ( const Point2 & p ) const
    {
        return get_x() == p.get_x() && get_y() == p.get_y();
    }
    
    /// svr
    bool operator != ( const Point2 & p ) const
    {
        return !operator==( p );
    }
    
    /// ̃IuWFNg\擾 (string )
    std::string to_string ( void ) const;
    
    /// ̃IuWFNg\擾
    /**
     * @param buf [out] ̏o͐
     * @param cap [in] o͐̃obt@e (k܂)
     * @return o͂ꂽ char 
     */
    int get_string ( char * buf, unsigned int cap ) const;
    
    /// ̃IuWFNgQƂ Ruby IuWFNg𐶐
    VALUE create_ruby_reference ( void );
    
    /// ̃IuWFNgRs[ Ruby IuWFNg𐶐
    VALUE create_ruby_object ( void ) const;
    
};


} /* namespace BK */


/*   Init/Exit ֐
------------------------------------------------------------------- */
namespace BK {


/// 2D NX̏
void Init_utility_Point2 ( void );


/// 2D NX̏I
void Exit_utility_Point2 ( void );


} /* namespace BK */


#endif /* _SCHEMA_UTILITY_POINT2_H_20031211Thu_114150_ */
