/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - [eBeB - ͈
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: [eBeB: ͈
 *
 * ƉA͈̓IuWFNg`܂B
 *
 * @author ABE Shigeru
 * @date 2004/01/09
 */
#ifndef _SCHEMA_UTILITY_RANGE_H_20040109Fri_110415_
#define _SCHEMA_UTILITY_RANGE_H_20040109Fri_110415_


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// ͈
/**
 * l̏ƉۗLIuWFNgłB
 * ͒lɊ܂܂܂A͒lɊ܂܂܂B
 *
 * ev[g^ value_t ɂ́A
 *  - Zq <  <=
 *  - Zq -
 * ĂKv܂B
 */
template < typename value_t >
class Range
{
public:
    
    /// g\^
    typedef Range < value_t > self_t;
    
private:
    
    /// 
    value_t obj_minimum;
    
    /// 
    value_t obj_maximum;
    
public:
    
    /// RXgN^
    Range ( const value_t & minimum, const value_t & maximum )
            : obj_minimum (minimum),
              obj_maximum (maximum)
    {
    }
    
    /// 擾
    const value_t & get_minimum ( void ) const
    {
        return obj_minimum;
    }
    
    /// 擾
    const value_t & get_maximum ( void ) const
    {
        return obj_maximum;
    }
    
    /// l̕擾
    value_t distance ( void ) const
    {
        return obj_maximum - obj_minimum;
    }
    
    /// l̒ɂ邩𒲂ׂ
    /** lɊ܂܂Ȃ_ɒӂĂB */
    bool operator == ( const value_t & v ) const
    {
        return obj_minimum <= v && v < obj_maximum;
    }
    
    /// l̊Oɂ邩𒲂ׂ
    /** lɊ܂܂Ȃ_ɒӂĂB */
    bool operator != ( const value_t & v ) const
    {
        return !(operator==( v ));
    }
    
};


} /* namespace BK */


#endif /* _SCHEMA_UTILITY_RANGE_H_20040109Fri_110415_ */
