/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - [eBeB - T[rXfoCX
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: [eBeB: T[rXfoCX
 *
 * T[rX񋟂IuWFNg̊ƂȂNX`܂B
 *
 * @author ABE Shigeru
 * @date 2003/12/16
 */
#ifndef _SCHEMA_UTIL_SERVICEDEVICE_H_20031216Tue_080537_
#define _SCHEMA_UTIL_SERVICEDEVICE_H_20031216Tue_080537_


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// foCX
/**
 * T[rXfoCX̊{Iȋ@\񋟂t[[NNXłB
 * ׂẴT[rXfoCX́ÃIuWFNgp܂B
 *
 * ׂẴT[rXfoCX́ARuby IuWFNgɂȂ܂B
 * T[rXfoCXƂ̒ʐMpIuWFNg\z邱ƂɂAfoCX̑
 * s܂B
 */
class ServiceDevice
{
private:
    
    /// foCX̏ԃtO
    bool bool_started;
    
protected: /* ServiceDevice C^[tFCX */
    
    /// foCX̊Jn ()
    /**
     * start() ōs鏈̖{̂Lq܂B
     */
    virtual void _start ( void ) = 0;
    
    /// foCX̏I ()
    /**
     * stop() ōs鏈̖{̂Lq܂B
     */
    virtual void _stop ( void ) = 0;
    
public: /* ServiceDevice C^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    /**
     * ۗL Ruby IuWFNg}[N܂B
     */
    virtual void ruby_gc_mark ( void );
    
    /// foCX̎擾
    /**
     * foCX擾܂BԂ閼ÓANXłȂĂ܂܂B
     */
    virtual const char * get_device_name ( void ) const = 0;
    
public:
    
    /// RXgN^
    /** \zł́AfoCX͂܂JnĂ܂B */
    ServiceDevice ( void );
    
    /// fXgN^
    virtual ~ServiceDevice ();
    
    /// foCX̊Jn
    /**
     * foCXJn܂B
     * TuNXł _start() Ē`ĂB
     *
     * @exception runtime_exception łɃfoCX͊JnĂ
     */
    void start ( void );
    
    /// foCX̏I
    /**
     * foCX~AT[rXI܂B
     * TuNXł _stop() Ē`ĂB
     *
     * @exception runtime_exception łɃfoCX͒~Ă
     */
    void stop ( void );
    
    /// foCXJnĂ邩𒲂ׂ
    /**
     * start() ŃfoCXJnĂ邩𒲂ׂ܂B
     *
     * @retval true JnĂ
     * @retval false ܂JnĂȂ
     */
    bool is_started ( void ) const;
    
};


} /* namespace BK */


/*   Init/Exit ֐
------------------------------------------------------------------- */
namespace BK {


/// [eBeB̏
void Init_utility_ServiceDevice ( void );


/// [eBeB̏I
void Exit_utility_ServiceDevice ( void );


} /* namespace BK */


#endif /* _SCHEMA_UTIL_SERVICEDEVICE_H_20031216Tue_080537_ */
