/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - [eBeB - TCY
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: [eBeB: TCY
 *
 * 񎟌TCY\̃f[^`܂B
 *
 * @author ABE Shigeru
 * @date 2003/12/11
 */
#ifndef _SCHEMA_UTILITY_SIZE2_H_20031211Thu_113926_
#define _SCHEMA_UTILITY_SIZE2_H_20031211Thu_113926_


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// 񎟌ԂɂTCYf[^
/**
 * ƏcA̗vff[^łB
 * evf͔Cӂ̐Ƃ܂A̒lłƂ̂ݗLłB
 * uȒlv\߁A̒lƂ邱Ƃ\łB
 */
class Size2
{
private: /* static ϐ */
    
    /// Ruby NX: Size2
    static VALUE ruby_class_object;
    
public: /* static \bh */
    
    /// Ruby NX擾
    static VALUE get_ruby_class ( void );
    
    /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
    static bool is_kind_of ( VALUE obj )
    {
        return xrb_is_kind_of(obj, get_ruby_class());
    }
    
    /// Ruby IuWFNgIuWFNgɕϊ
    static Size2 * value_to_data ( VALUE obj )
    {
        return ruby_cast< Size2 >( obj );
    }
    
public:
    
    /// f[^^
    /** K (Ƃ) lłB */
    typedef int num_t;
    
private:
    
    /// 
    num_t  num_width;
    
    /// 
    num_t  num_height;
    
public:
    
    /// 擾
    const num_t & get_width ( void ) const
    {
        return num_width;
    }
    
    /// ݒ肷
    const num_t & set_width ( const num_t & v )
    {
        return num_width = v;
    }
    
    /// c擾
    const num_t & get_height ( void ) const
    {
        return num_height;
    }
    
    /// cݒ肷
    const num_t & set_height ( const num_t & v )
    {
        return num_height = v;
    }
    
    /// TCYݒ肷
    Size2 & set_size ( const num_t & width, const num_t & height )
    {
        set_width( width );
        set_height( height );
        return *this;
    }
    
    /// TCYݒ肷
    Size2 & set_size ( const Size2 & s )
    {
        return set_size( s.get_width(), s.get_height() );
    }
    
    /// RXgN^
    Size2 ( void )
    {
        set_size( 0, 0 );
    }
    
    /// RXgN^
    Size2 ( const Size2 & s )
    {
        set_size( s );
    }
    
    /// RXgN^
    Size2 ( const num_t & width, const num_t & height )
    {
        set_size( width, height );
    }
    
    /// TCYł邩𒲂ׂ
    bool is_empty ( void ) const
    {
        return (get_width() <= 0) || (get_height() <= 0);
    }
    
    /// ʐς̎擾
    /** TCY\̖̈ʐς擾܂B */
    unsigned int get_area ( void ) const
    {
        return (is_empty()) ? 0 : static_cast< unsigned int >( get_width() * get_height() );
    }
    
    /// Z
    Size2 operator * ( int n ) const
    {
        return Size2( get_width() * n, get_height() * n );
    }
    
    /// Z
    Size2 operator / ( int n ) const
    {
        return Size2( get_width() / n, get_height() / n );
    }
    
    /// Z
    Size2 operator + ( const Size2 & s ) const
    {
        return Size2( get_width() + s.get_width(), get_height() + s.get_height() );
    }
    
    /// Z
    Size2 operator - ( const Size2 & s ) const
    {
        return Size2( get_width() - s.get_width(), get_height() - s.get_height() );
    }
    
    /// Z
    Size2 & operator *= ( int n )
    {
        return set_size( get_width() * n, get_height() * n );
    }
    
    /// Z
    Size2 & operator /= ( int n )
    {
        return set_size( get_width() / n, get_height() / n );
    }
    
    /// Z
    Size2 & operator += ( const Size2 & s )
    {
        return set_size( get_width() + s.get_width(), get_height() + s.get_height() );
    }
    
    /// Z
    Size2 & operator -= ( const Size2 & s )
    {
        return set_size( get_width() - s.get_width(), get_height() - s.get_height() );
    }
    
    /// vr
    bool operator == ( const Size2 & s ) const
    {
        return (get_width() == s.get_width()) && (get_height() == s.get_height());
    }
    
    /// svr
    bool operator != ( const Size2 & s ) const
    {
        return !operator==( s );
    }
    
    /// ̃IuWFNg\擾 (string )
    std::string to_string ( void ) const;
    
    /// ̃IuWFNg\擾
    /**
     * @param buf [out] ̏o͐
     * @param cap [in] o͐̃obt@e (k܂)
     * @return o͂ꂽ char 
     */
    int get_string ( char * buf, unsigned int cap ) const;
    
    /// ̃IuWFNgQƂ Ruby IuWFNg𐶐
    VALUE create_ruby_reference ( void );
    
    /// ̃IuWFNgRs[ Ruby IuWFNg𐶐
    VALUE create_ruby_object ( void ) const;
    
};


} /* namespace BK */


/*   Init/Exit ֐
------------------------------------------------------------------- */
namespace BK {


/// 2D NX̏
void Init_utility_Size2 ( void );


/// 2D NX̏I
void Exit_utility_Size2 ( void );


} /* namespace BK */


#endif /* _SCHEMA_UTILITY_SIZE2_H_20031211Thu_113926_ */
