/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - [eBeB - obt@
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: [eBeB: obt@
 *
 * \z邽߂Ɏg镶obt@`܂B
 *
 * @author ABE Shigeru
 * @date 2003/12/12
 */
#ifndef _SCHEMA_UTILITY_STRINGBUFFER_H_20031212Fri_115105_
#define _SCHEMA_UTILITY_STRINGBUFFER_H_20031212Fri_115105_


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// obt@Ŏgꎞobt@̃TCY
const int STRINGBUFFER_TEMPORARY_BUFFER_SIZE = 4096;


/// tH[}bgǉ\ȕobt@
/**
 *  sprintf() \bhŒǉĂƂł܂B
 *
 * [TODO]
 * ɁuĂƁ[vȐ݌vȂ̂AƂĂB
 * o͐̓Xg[ɂׂH
 */
class StringBuffer
{
private:
    
    /// obt@
    std::string str_buffer;
    
public:
    
    /// RXgN^
    /**
     * 󕶎ŏ܂B
     */
    StringBuffer ( void )
    {
    }
    
    /// RXgN^
    /**
     * w肳ꂽ̃Rs[ɁAǉĂ܂B
     */
    
    
    /// ̒ǉ
    StringBuffer & sprintf ( const char * format, ... )
    {
        char buf [ STRINGBUFFER_TEMPORARY_BUFFER_SIZE ];
        va_list arg;
        va_start( arg, format );
        vsprintf( buf, format, arg );
        str_buffer.append( buf );
        va_end( arg );
        return *this;
    }
    
    /// IuWFNg̎擾
    std::string & get_string ( void )
    {
        return str_buffer;
    }
    
    /// IuWFNg̎擾 (const )
    std::string const & get_string ( void ) const
    {
        return str_buffer;
    }
    
    /// IuWFNgւ̕ϊ
    operator std::string & ( void )
    {
        return get_string();
    }
    
    /// IuWFNgւ̕ϊ (const )
    operator std::string const & ( void ) const
    {
        return get_string();
    }
    
};


} /* namespace BK */


/*   Init/Exit ֐
------------------------------------------------------------------- */
namespace BK {


/// [eBeB̏
void Init_utility_StringBuffer ( void );


/// [eBeB̏I
void Exit_utility_StringBuffer ( void );


} /* namespace BK */


#endif /* _SCHEMA_UTILITY_STRINGBUFFER_H_20031212Fri_115105_ */
