/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - [eBeB - eLXgCAEg
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: [eBeB: eLXgCAEg
 *
 * eLXgGA\ACAEgIuWFNg`܂B
 *
 * @author ABE Shigeru
 * @date 2004/02/17
 */
#ifndef _SCHEMA_UTILITY_TEXTLAYOUT_H_20040217Tue_160432_
#define _SCHEMA_UTILITY_TEXTLAYOUT_H_20040217Tue_160432_


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// eLXgCAEg
/**
 * ɕׂAeLXgCAEg`܂B
 */
class TextLayout : public DocumentLayout
{
public:
    
    /// eNX
    typedef DocumentLayout parent_t;
    
private: /* static ϐ */
    
    /// Ruby NX: TextLayout
    static VALUE ruby_class_object;
    
public: /* static \bh */
    
    /// Ruby NX擾
    static VALUE get_ruby_class ( void );
    
    /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
    static bool is_kind_of ( VALUE obj )
    {
        return xrb_is_kind_of(obj, get_ruby_class());
    }
    
    /// Ruby IuWFNgIuWFNgɕϊ
    static TextLayout * value_to_data ( VALUE obj )
    {
        return ruby_basecast< TextLayout, RubyObject >( obj );
    }
    
protected: /* Ruby IuWFNgpC^[tFCX */
    
    /// Ruby NXIuWFNg擾
    virtual VALUE get_ruby_class_object ( void ) const
    {
        return get_ruby_class();
    }
    
public: /* Ruby IuWFNgpC^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    //virtual void ruby_gc_mark ( void );
    
    /// Kx[WRNg̃ObZ[Wo̓tO擾
    //virtual bool is_ruby_gc_log_enabled ( void ) const;
    
    /// Ruby inspect \bh
    //virtual char * ruby_inspect ( char * buf, unsigned int cap ) const;
    
    /// Ruby IuWFNgɂ郉bsOCxg
    //virtual void on_ruby_wrap ( void );
    
public: /* Layout C^[tFCX */
    
    /// CAEgXVȌ
    //virtual void on_invoke_update ( void );
    
    /// CAEg̍XV
    virtual void on_update ( void );
    
    /// CAEg̕sړ
    //virtual void on_set_point ( const Point2 & delta );
    
public: /* DocumentLayout C^[tFCX */
    
    /// CAEg̒ǉ
    virtual void add_layout ( Layout * * layouts, unsigned int len );
    
    /// ݓo^Ă郌CAEg폜
    virtual void clear_registered_layouts ( void );
    
public:
    
    /// _sCAEg̃Xg
    typedef std::vector < unsigned int > lineary_t;
    
private:
    
    /// _sXg
    lineary_t ary_logline;
    
    /// sԊu
    layoutvalue_t obj_line_interval;
    
public:
    
    /// RXgN^
    /**
     * ftHgł́ÄOւ̓o^́usvɐݒ肳Ă܂B
     */
    TextLayout ( void );
    
    /// fXgN^
    virtual ~TextLayout ();
    
    /// ݒ肳ĂsԊu擾
    /**
     * ftHgł́Aݒ肳Ă܂B
     */
    const layoutvalue_t & get_line_interval ( void ) const
    {
        return obj_line_interval;
    }
    
    /// ݒ肳ĂsԊuvZ
    /**
     * @return sԊu (sNZ)
     * @retval -1 sԊuݒ肳ĂȂ
     */
    int calc_line_interval ( void ) const
    {
        return (obj_line_interval.is_null()) ? -1 : obj_line_interval.get(get_size().get_height());
    }
    
    /// sԊuݒ肷
    /**
     * Ԋulݒ肳ĂȂꍇAs쐬ł܂B
     *
     * @param val [in] ݒ肷sԊu
     */
    void set_line_interval ( const layoutvalue_t & val );
    
};


} /* namespace BK */


/*   Init/Exit ֐
------------------------------------------------------------------- */
namespace BK {


/// [eBeB̏
void Init_utility_TextLayout ( void );


/// [eBeB̏I
void Exit_utility_TextLayout ( void );


} /* namespace BK */


#endif /* _SCHEMA_UTILITY_TEXTLAYOUT_H_20040217Tue_160432_ */
