/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - OtBbN - rbg}bv
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: OtBbN: rbg}bv
 *
 * rbg}bvNX`܂B
 *
 * @author ABE Shigeru
 * @date 2003/12/17
 */
#ifndef _SCHEMA_GRAPHIC_BITMAP_H_20031217Wed_205054_
#define _SCHEMA_GRAPHIC_BITMAP_H_20031217Wed_205054_


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// rbg}bvC^[tFCX
/**
 * rbg}bv\IuWFNg̋ʃC^[tFCXłB
 * ׂẴrbg}bvnIuWFNǵÃIuWFNg̃\bhȂ΂Ȃ܂B
 */
class Bitmap : public RubyObject
{
public:
    
    /// eNX
    typedef RubyObject parent_t;
    
private: /* static ϐ */
    
    /// Ruby NX: Bitmap
    static VALUE ruby_class_object;
    
public: /* static \bh */
    
    /// Ruby NX擾
    static VALUE get_ruby_class ( void );
    
    /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
    static bool is_kind_of ( VALUE obj )
    {
        return xrb_is_kind_of(obj, get_ruby_class());
    }
    
    /// Ruby IuWFNgIuWFNgɕϊ
    static Bitmap * value_to_data ( VALUE obj )
    {
        return ruby_basecast< Bitmap, RubyObject >( obj );
    }
    
protected: /* RubyObject C^[tFCX */
    
    /// Ruby NXIuWFNg擾
    virtual VALUE get_ruby_class_object ( void ) const
    {
        return get_ruby_class();
    }
    
public: /* RubyObject C^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    //virtual void ruby_gc_mark ( void );
    
    /// Kx[WRNg̃ObZ[Wo̓tO擾
    //virtual bool is_ruby_gc_log_enabled ( void ) const;
    
    /// Ruby inspect \bh
    virtual char * ruby_inspect ( char * buf, unsigned int cap ) const;
    
    /// Ruby IuWFNgɂ郉bsOCxg
    //virtual void on_ruby_wrap ( void );
    
public:
    
    /// i[ꏊ̗񋓌^
    enum pool_t
    {
        /// i[s
        POOL_Unknown,
        
        /// VRAM Ɋi[Ă
        POOL_VRAM,
        
        /// CɊi[Ă
        POOL_MainMemory,
    };
    
public: /* Bitmap C^[tFCX */
    
    /// rbg}bv̓]
    /**
     * w肳ꂽ_̊_ƂASȃrbg}bvRs[s܂B
     *
     * @param dest [in] Rs[̈ʒu
     * @param src [in] Rs[錳̉摜
     * @param area [in] Rs[̗̈
     */
    virtual void blit ( Point2 const & dest, Bitmap & src, Rect2 const & area ) = 0;
    
    /// ANZXp̃LoX擾
    /**
     * ̃rbg}bvɃANZX邽߂̃LoX擾܂B
     * gpÍAԂꂽIuWFNg delete Kv܂B
     * VXeɂẮALoX擾́AsN`bNꍇ܂B
     * LoX擾͑̑sȂ悤ɂĂB
     *
     * area  NULL nꂽƂALoX̑SʂbN܂B
     *
     * @param area [in] bN̈
     */
    virtual Canvas * create_canvas ( Rect2 const * area = NULL ) = 0;
    
    /// OtBbNC[W̑傫擾
    virtual Size2 get_size ( void ) = 0;
    
    /// IuWFNg̎擾
    virtual std::string inspect ( void ) const = 0;
    
    /// IuWFNg݂ꏊ擾
    virtual pool_t get_pool_info ( void ) const = 0;
    
    /// IuWFNg̃sNZtH[}bg擾
    virtual Canvas::pixel_t get_pixel_info ( void ) const = 0;
    
    /// OtBbNC[Wt@Cɏo͂
    /**
     * ̃rbg}bv\C[Wt@Cɕۑ܂B
     * T|[g`́AnɂĈقȂ܂B
     * ŒÃ\bhɂďo͂ꂽt@ĆAOtBbNfoCX
     * ǂݍނƂłƕۏ؂܂B
     *
     * łɓ̃t@C݂ꍇAf[^㏑܂B
     *
     * @param filename [in] o͐̃t@C
     */
    virtual void write_to_file ( const char * filename ) = 0;
    
public:
    
    /// RXgN^
    Bitmap ( void );
    
    /// fXgN^
    virtual ~Bitmap ();
    
};


} /* namespace BK */


/*   Init/Exit ֐
------------------------------------------------------------------- */
namespace BK {


/// OtBbN̏
void Init_graphic_Bitmap ( void );


/// OtBbN̏I
void Exit_graphic_Bitmap ( void );


} /* namespace BK */


#endif /* _SCHEMA_GRAPHIC_BITMAP_H_20031217Wed_205054_ */
