/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - OtBbN - C[ - rbg}bv]C[
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: OtBbN: C[: rbg}bv]C[
 *
 * rbg}bvXN[ɕ`悷]C[`܂B
 *
 * @author ABE Shigeru
 * @date 2003/12/14
 */
#ifndef _SCHEMA_GRAPHIC_LAYER_BITMAPPROJECTIONLAYER_H_20031214Sun_181511_
#define _SCHEMA_GRAPHIC_LAYER_BITMAPPROJECTIONLAYER_H_20031214Sun_181511_


/*   NX̒`
------------------------------------------------------------------- */
namespace BK {


/// 摜]C[
/**
 * ProjectionLayer ̂Arbg}bv]郌C[\܂B
 *
 * 摜擾邽߂̃C^[tFCXǉ݂̂łB
 */
class BitmapProjectionLayer : public ProjectionLayer
{
public:
    
    /// eNX
    typedef ProjectionLayer parent_t;
    
private: /* static ϐ */
    
    /// Ruby NX: BitmapProjectionLayer
    static VALUE ruby_class_object;
    
public: /* static \bh */
    
    /// Ruby NX擾
    static VALUE get_ruby_class ( void );
    
    /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
    static bool is_kind_of ( VALUE obj )
    {
        return xrb_is_kind_of(obj, get_ruby_class());
    }
    
    /// Ruby IuWFNgIuWFNgɕϊ
    static BitmapProjectionLayer * value_to_data ( VALUE obj )
    {
        return ruby_basecast< BitmapProjectionLayer, RubyObject >( obj );
    }
    
protected: /* Ruby IuWFNgpC^[tFCX */
    
    /// Ruby NXIuWFNg擾
    virtual VALUE get_ruby_class_object ( void ) const
    {
        return get_ruby_class();
    }
    
public: /* Ruby IuWFNgpC^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    virtual void ruby_gc_mark ( void );
    
    /// Kx[WRNg̃ObZ[Wo̓tO擾
    //virtual bool is_ruby_gc_log_enabled ( void ) const;
    
    /// Ruby inspect \bh
    //virtual char * ruby_inspect ( char * buf, unsigned int cap ) const;
    
    /// Ruby IuWFNgɂ郉bsOCxg
    virtual void on_ruby_wrap ( void );
    
private:
    
    /// ۗLĂ摜
    Bitmap & obj_bitmap;
    
public:
    
    /// RXgN^
    /**
     * @param bmp [in] gp摜IuWFNg
     */
    BitmapProjectionLayer ( Bitmap & bmp );
    
    /// fXgN^
    virtual ~BitmapProjectionLayer ();
    
    /// 摜擾
    Bitmap & get_bitmap ( void )
    {
        return obj_bitmap;
    }
    
};


} /* namespace BK */


/*   Init/Exit ֐
------------------------------------------------------------------- */
namespace BK {


/// OtBbNfoCXEC[̏
void Init_graphic_layer_BitmapProjectionLayer ( void );


/// OtBbNfoCXEC[̏I
void Exit_graphic_layer_BitmapProjectionLayer ( void );


} /* namespace BK */


#endif /* _SCHEMA_GRAPHIC_LAYER_BITMAPPROJECTIONLAYER_H_20031214Sun_181511_ */
