/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - OtBbN - C[ - C[WC[
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: OtBbN: C[: C[WC[
 *
 * C[Wgp]C[`܂B
 *
 * @author ABE Shigeru
 * @date 2003/12/14
 */
#ifndef _SCHEMA_GRAPHIC_LAYER_IMAGELAYER_H_20031214Sun_180341_
#define _SCHEMA_GRAPHIC_LAYER_IMAGELAYER_H_20031214Sun_180341_


/*   NX̒`
------------------------------------------------------------------- */
namespace BK {


/// C[WC[
/**
 * ۗLĂC[WXN[ɓ]邽߂̃C[łB
 */
class ImageLayer : public BitmapProjectionLayer
{
public:
    
    /// eNX
    typedef BitmapProjectionLayer parent_t;
    
private: /* static ϐ */
    
    /// Ruby NX: ImageLayer
    static VALUE ruby_class_object;
    
public: /* static \bh */
    
    /// Ruby NX擾
    static VALUE get_ruby_class ( void );
    
    /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
    static bool is_kind_of ( VALUE obj )
    {
        return xrb_is_kind_of(obj, get_ruby_class());
    }
    
    /// Ruby IuWFNgIuWFNgɕϊ
    static ImageLayer * value_to_data ( VALUE obj )
    {
        return ruby_basecast< ImageLayer, RubyObject >( obj );
    }
    
protected: /* RubyObject C^[tFCX */
    
    /// Ruby NXIuWFNg擾
    virtual VALUE get_ruby_class_object ( void ) const
    {
        return get_ruby_class();
    }
    
public: /* RubyObject C^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    virtual void ruby_gc_mark ( void );
    
    /// Kx[WRNg̃ObZ[Wo̓tO擾
    //virtual bool is_ruby_gc_log_enabled ( void ) const;
    
    /// Ruby inspect \bh
    //virtual char * ruby_inspect ( char * buf, unsigned int cap ) const;
    
    /// Ruby IuWFNgɂ郉bsOCxg
    virtual void on_ruby_wrap ( void );
    
public: /* Layer C^[tFCX */
    
    /// `Cxg
    virtual void execute ( GraphicDevice * dev ) = 0;
    
public: /* ProjectionLayer C^[tFCX */
    
    /// ]̈̓o^
    virtual ProjectionInfo * register_projection ( void ) = 0;
    
    /// ]̈̍폜
    virtual void delete_projection ( ProjectionInfo * ptr ) = 0;
    
    /// o^Ă]̈̐擾
    virtual unsigned int count_projection ( void ) const = 0;
    
private:
    
    /// ݒ肳ꂽC[WIuWFNg
    Image & obj_image;
    
public:
    
    /// RXgN^
    /**
     * @param image [in] gpC[W
     */
    ImageLayer ( Image & image );
    
    /// fXgN^
    virtual ~ImageLayer ();
    
    /// o^ĂC[W̎擾
    Image & get_image ( void ) const
    {
        return obj_image;
    }
    
};


} /* namespace BK */


/*   Init/Exit ֐
------------------------------------------------------------------- */
namespace BK {


/// OtBbNfoCXEC[̏
void Init_graphic_layer_ImageLayer ( void );


/// OtBbNfoCXEC[̏I
void Exit_graphic_layer_ImageLayer ( void );


} /* namespace BK */


#endif /* _SCHEMA_GRAPHIC_LAYER_IMAGELAYER_H_20031214Sun_180341_ */
