/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - C[
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: C[
 *
 * OtBbNʂ̍\vfAC[\IuWFNgłB
 *
 * @author ABE Shigeru
 * @date 2003/08/24
 */
#ifndef _SCHEMA_GRAPHIC_LAYER_H_20030824Sun_220533_
#define _SCHEMA_GRAPHIC_LAYER_H_20030824Sun_220533_


/*   NX錾
------------------------------------------------------------------- */
namespace BK {

class GraphicDevice;

} /* namespace BK */


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// C[
/**
 * XN[ւ̕`\Iɍs߂ɎgAC[IuWFNgłB
 * C[𕡐d˂邱ƂɂāAXN[\z܂B
 *
 * eC[̋̓TuNXɂĈقȂ܂B
 */
class Layer : public RubyObject
{
public:
    
    /// eNX
    typedef RubyObject parent_t;
    
private: /* static ϐ */
    
    /// Ruby NX: Layer
    static VALUE ruby_class_object;
    
public: /* static \bh */
    
    /// Ruby NX擾
    static VALUE get_ruby_class ( void );
    
    /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
    static bool is_kind_of ( VALUE obj )
    {
        return xrb_is_kind_of(obj, get_ruby_class());
    }
    
    /// Ruby IuWFNgIuWFNgɕϊ
    static Layer * value_to_data ( VALUE obj )
    {
        return ruby_basecast< Layer, RubyObject >( obj );
    }
    
protected: /* Ruby IuWFNgpC^[tFCX */
    
    /// Ruby NXIuWFNg擾
    VALUE get_ruby_class_object ( void ) const
    {
        return get_ruby_class();
    }
    
public: /* Ruby IuWFNgpC^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    //void ruby_gc_mark ( void );
    
    /// Kx[WRNg̃ObZ[Wo̓tO擾
    //virtual bool is_ruby_gc_log_enabled ( void ) const;
    
    /// Ruby inspect \bh
    //virtual char * ruby_inspect ( char * buf, unsigned int cap ) const;
    
    /// Ruby IuWFNgɂ郉bsOCxg
    //virtual void on_ruby_wrap ( void );
    
public: /* Layer C^[tFCX */
    
    /// `Cxg
    virtual void execute ( GraphicDevice * dev ) = 0;
    
public:
    
    /// RXgN^
    Layer ( void );
    
    /// fXgN^
    virtual ~Layer ();
    
};


} /* namespace BK */


/*   CN[h
------------------------------------------------------------------- */
#include "gd_LayerArray.h"
#include "gd_ProjectionLayer.h"
#include "gd_BitmapProjectionLayer.h"
#include "gd_FillLayer.h"
#include "gd_FilmLayer.h"
#include "gd_PictureLayer.h"
#include "gd_ImageLayer.h"
#include "gd_TextLayer.h"


/*   Init/Exit ֐
------------------------------------------------------------------- */
namespace BK {


/// OtBbNfoCXEC[̏
void Init_graphic_layer ( void );


/// OtBbNfoCXEC[̏I
void Exit_graphic_layer ( void );


} /* namespace BK */


#endif /* _SCHEMA_GRAPHIC_LAYER_H_20030824Sun_220533_ */
