/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - OtBbN - C[ - sN`C[
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: OtBbN: C[: sN`C[
 *
 * sN`gp]C[`܂B
 *
 * @author ABE Shigeru
 * @date 2003/12/14
 */
#ifndef _SCHEMA_GRAPHIC_LAYER_PICTURELAYER_H_20031214Sun_180629_
#define _SCHEMA_GRAPHIC_LAYER_PICTURELAYER_H_20031214Sun_180629_


/*   NX̒`
------------------------------------------------------------------- */
namespace BK {


/// sN`C[
/**
 * XN[̓ʒuɃsN`]邽߂̃C[łB
 * MAڑĂȂꍇAʂ̍ɓ]܂B
 */
class PictureLayer : public Layer
{
public:
    
    /// eNX
    typedef Layer parent_t;
    
private: /* static ϐ */
    
    /// Ruby NX: PictureLayer
    static VALUE ruby_class_object;
    
public: /* static \bh */
    
    /// Ruby NX擾
    static VALUE get_ruby_class ( void );
    
    /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
    static bool is_kind_of ( VALUE obj )
    {
        return xrb_is_kind_of(obj, get_ruby_class());
    }
    
    /// Ruby IuWFNgIuWFNgɕϊ
    static PictureLayer * value_to_data ( VALUE obj )
    {
        return ruby_basecast< PictureLayer, RubyObject >( obj );
    }
    
protected: /* RubyObject C^[tFCX */
    
    /// Ruby NXIuWFNg擾
    virtual VALUE get_ruby_class_object ( void ) const
    {
        return get_ruby_class();
    }
    
public: /* RubyObject C^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    virtual void ruby_gc_mark ( void );
    
    /// Kx[WRNg̃ObZ[Wo̓tO擾
    //virtual bool is_ruby_gc_log_enabled ( void ) const;
    
    /// Ruby inspect \bh
    //virtual char * ruby_inspect ( char * buf, unsigned int cap ) const;
    
    /// Ruby IuWFNgɂ郉bsOCxg
    virtual void on_ruby_wrap ( void );
    
public: /* Layer C^[tFCX */
    
    /// `Cxg
    virtual void execute ( GraphicDevice * dev ) = 0;
    
private:
    
    /// ݒ肳ꂽsN`IuWFNg
    Picture * const ptr_picture;
    
public:
    
    /// RXgN^
    PictureLayer ( Picture * picture );
    
    /// fXgN^
    virtual ~PictureLayer ();
    
    /// ]sN`̎擾
    Picture * get_picture ( void ) const
    {
        return ptr_picture;
    }
    
};


} /* namespace BK */


/*   Init/Exit ֐
------------------------------------------------------------------- */
namespace BK {


/// OtBbNfoCXEC[̏
void Init_graphic_layer_PictureLayer ( void );


/// OtBbNfoCXEC[̏I
void Exit_graphic_layer_PictureLayer ( void );


} /* namespace BK */


#endif /* _SCHEMA_GRAPHIC_LAYER_PICTURELAYER_H_20031214Sun_180629_ */
