/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - OtBbN - XvCgf[^x[X
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: OtBbN: XvCgf[^x[X
 *
 * XvCgǗ邽߂̃f[^x[XNX`܂B
 *
 * @author ABE Shigeru
 * @date 2003/12/19
 */
#ifndef _SCHEMA_GRAPHIC_SPRITEDATABASE_H_20031219Fri_093342_
#define _SCHEMA_GRAPHIC_SPRITEDATABASE_H_20031219Fri_093342_


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// XvCgf[^x[X
/**
 * Oɂ Sprite Ǘ邽߂́Af[^x[XIuWFNgłB
 * String  Sprite т܂Bo^ꂽf[^́uQƁv܂B
 *
 * Ce[^ɂA擾邱Ƃ\łB
 */
class SpriteDatabase : public RubyObject
{
public:
    
    /// eNX
    typedef RubyObject parent_t;
    
private: /* static ϐ */
    
    /// Ruby NX: SpriteDatabase
    static VALUE ruby_class_object;
    
public: /* static \bh */
    
    /// Ruby NX擾
    static VALUE get_ruby_class ( void );
    
    /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
    static bool is_kind_of ( VALUE obj )
    {
        return xrb_is_kind_of(obj, get_ruby_class());
    }
    
    /// Ruby IuWFNgIuWFNgɕϊ
    static SpriteDatabase * value_to_data ( VALUE obj )
    {
        return ruby_basecast< SpriteDatabase, RubyObject >( obj );
    }
    
protected: /* RubyObject C^[tFCX */
    
    /// Ruby NXIuWFNg擾
    virtual VALUE get_ruby_class_object ( void ) const
    {
        return get_ruby_class();
    }
    
public: /* RubyObject C^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    virtual void ruby_gc_mark ( void );
    
    /// Kx[WRNg̃ObZ[Wo̓tO擾
    //virtual bool is_ruby_gc_log_enabled ( void ) const;
    
    /// Ruby inspect \bh
    //virtual char * ruby_inspect ( char * buf, unsigned int cap ) const;
    
    /// Ruby IuWFNgɂ郉bsOCxg
    virtual void on_ruby_wrap ( void );
    
public:
    
    /// XvCge[ǔ^
    typedef std::map < std::string, Sprite * > map_t;
    
    /// Ce[^^
    typedef map_t::const_iterator const_iterator;
    
private:
    
    /// XvCge[u
    map_t map_sprite;
    
public:
    
    /// RXgN^
    SpriteDatabase ( void );
    
    /// fXgN^
    virtual ~SpriteDatabase ();
    
    /// XvCg`
    /**
     * w肳ꂽXvCg (ւ̎Q) f[^x[Xɒǉ܂B
     * łɓÕXvCgo^ĂꍇAVf[^ŏ㏑܂B
     *
     * @param name [in] XvCg
     * @param data [in] o^XvCgf[^
     */
    void add ( const char * name, Sprite & sprite );
    
    /// XvCg폜
    /**
     * w肳ꂽÕXvCgf[^x[X폜܂B
     *
     * @param name [in] XvCg
     * @exception argument_exception w肳ꂽO͓o^ĂȂ
     */
    void erase ( const char * name );
    
    /// XvCg擾
    /**
     * ̃f[^x[XAw肳ꂽÕXvCg܂B
     *
     * @param name [in] XvCg
     * @retval NULL w肳ꂽÕXvCg݂Ȃ
     */
    Sprite * find ( const char * name ) const;
    
    /// 擪Ce[^̎擾 (const )
    const_iterator begin ( void ) const
    {
        return map_sprite.begin();
    }
    
    /// I[Ce[^̎擾 (const )
    const_iterator end ( void ) const
    {
        return map_sprite.end();
    }
    
    /// o^ĂXvCg擾
    unsigned int size ( void ) const
    {
        return static_cast< unsigned int >( map_sprite.size() );
    }
    
};


/// XvCgf[^x[X̃X^bN
/**
 * XvCgf[^x[Xςݏd˂邽߂ Singleton IuWFNgłB
 * ςݏd˂ꂽʂ̃f[^x[X́Aʂ̃f[^x[XB܂B
 *
 * f[^̏㉺֌WɈӖ邽߁AX^bNɂKv܂B
 *
 * ŉiɂ́AɃftHg̃XvCgf[^x[X݂܂B
 */
class SpriteDatabaseStack
{
private: /* static ϐ */
    
    /// Singleton IuWFNg
    static SpriteDatabaseStack * singleton_object;
    
public: /* static \bh */
    
    /// Singleton IuWFNg̎擾
    static SpriteDatabaseStack * get_instance ( void )
    {
        return singleton_object;
    }
    
private:
    
    /// X^bN^
    typedef std::vector < SpriteDatabase * > list_t;
    
    /// f[^x[XX^bN
    list_t ary_database;
    
    /// ftHg̃XvCgf[^x[X
    /**
     * ԈăX^bNƕ|̂ŁAʗĂŎĂB
     * ܂ARuby IuWFNg͐܂B
     */
    SpriteDatabase obj_default_database;
    
public:
    
    /// RXgN^
    SpriteDatabaseStack ( void );
    
    /// fXgN^
    ~SpriteDatabaseStack ();
    
    /// Ruby Kx[WRNgp}[N
    void ruby_gc_mark ( void );
    
    /// XvCǧ
    /**
     * w肳ꂽÕXvCg܂B
     * ̃XvCg݂ꍇAX^bN̏ɂf[^x[XD悳܂B
     *
     * @param name [in] XvCg
     * @return w肳ꂽÕXvCg
     * @retval NULL w肳ꂽÕXvCg݂͑Ȃ
     */
    Sprite * find ( const char * name ) const;
    
    /// f[^x[XX^bNgbvɒǉ
    /**
     * w肳ꂽXvCgf[^x[X (ւ̎Q) X^bNgbvɒǉ܂B
     * X^bNɑ݂f[^x[Xo^邱Ƃł܂B
     *
     * @param db [in] ǉf[^x[X
     */
    void push ( SpriteDatabase & db );
    
    /// X^bNgbvɂf[^x[X̎o
    /**
     * X^bNgbvɒuꂽf[^x[X菜܂B
     * X^bN̏ꍇ runtime_exception O܂B
     *
     * @return oꂽf[^x[X
     * @exception runtime_exception X^bN
     */
    SpriteDatabase * pop ( void );
    
    /// X^bNgbvɂf[^x[X̎Q
    /**
     * X^bNgbvɒuꂽf[^x[Xւ̎QƂ擾܂B
     * X^bN̏ꍇ́AftHg̃f[^x[XԂ܂B
     *
     * @return X^bNgbṽf[^x[X
     */
    SpriteDatabase & get_top ( void );
    
};


} /* namespace BK */


/*   Init/Exit ֐
------------------------------------------------------------------- */
namespace BK {


/// OtBbNfoCXEXvCg̏
void Init_graphic_SpriteDatabase ( void );


/// OtBbNfoCXEXvCg̏I
void Exit_graphic_SpriteDatabase ( void );


} /* namespace BK */


#endif /* _SCHEMA_GRAPHIC_SPRITEDATABASE_H_20031219Fri_093342_ */
