/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - OtBbN - XvCgZbg
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: OtBbN: XvCgZbg
 *
 * XvCgzuǗ邽߂̃ReiNX`܂B
 *
 * @author ABE Shigeru
 * @date 2003/12/19
 */
#ifndef _SCHEMA_GRAPHIC_SPRITEFIELD_H_20031219Fri_093927_
#define _SCHEMA_GRAPHIC_SPRITEFIELD_H_20031219Fri_093927_


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// XvCgtB[hpXvCgf[^
/**
 * XvCgtB[hɓWJꂽXvCgf[^܂B
 */
class SpriteFieldData : public SpriteData
{
private:
    
    /// ReiƂȂĂXvCgtB[h
    const SpriteField & obj_field;
    
    /// tB[h̎gp̈ (rbg}bvł̍W)
    const Rect2 rect_field;
    
    /// tB[h̃AXyNg`
    const AspectRect2 rect_aspect;
    
public:
    
    /// RXgN^
    /**
     * @param data [in] Rs[XvCgf[^
     * @param field [in] XvCgtB[h̍ʒu
     * @param layersize [in] C[ (gprbg}bv) ̑傫
     */
    SpriteFieldData ( const SpriteField & field, const SpriteData & data );
    
    /// XvCg񂪑tB[h擾
    const SpriteField & get_field ( void ) const
    {
        return obj_field;
    }
    
    /// tB[h̎gp̈擾
    const Rect2 & get_field_rect ( void ) const
    {
        return rect_field;
    }
    
    /// AXyNg`擾
    const AspectRect2 & get_aspect ( void ) const
    {
        return rect_aspect;
    }
};


/// XvCgtB[h
/**
 * XvCgZbgC[ɓWJ邱ƂŁAXvCgtB[hƂȂ܂B
 * ̏ԂɂȂĂ͂߂āALN^[ɐݒł悤ɂȂ܂B
 * XvCgZbǵAXvCgtB[hɃRs[܂B쐬̃XvCgZbg
 * ύXĂAXvCgtB[hɂ͉e܂B
 *
 * \z̃tB[hɂ́AC[Wǂݍ܂Ă܂B
 * gpOɁAK[hsĂB
 *
 * ׂẴXvCgtB[h́AO[otB[h}bvɊi[Aǂł
 * OɂĎQƂ邱Ƃł悤ɂȂ܂B
 *
 * ȂAׂẴtB[ḧ͔rIłB
 *
 * tB[h͎gŖOۗL܂B
 * iƓɃO[of[^x[X֊i[邽߁AŖOۗLBj
 */
class SpriteField : public RubyObject, public OnOffObject
{
private: /* static ϐ */
    
    /// Ruby NX: SpriteField
    static VALUE ruby_class_object;
    
public: /* static \bh */
    
    /// Ruby NX擾
    static VALUE get_ruby_class ( void );
    
    /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
    static bool is_kind_of ( VALUE obj )
    {
        return xrb_is_kind_of(obj, get_ruby_class());
    }
    
    /// Ruby IuWFNgIuWFNgɕϊ
    static SpriteField * value_to_data ( VALUE obj )
    {
        return ruby_basecast< SpriteField, RubyObject >( obj );
    }
    
protected: /* RubyObject C^[tFCX */
    
    /// Ruby NXIuWFNg擾
    virtual VALUE get_ruby_class_object ( void ) const
    {
        return get_ruby_class();
    }
    
public: /* RubyObject C^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    virtual void ruby_gc_mark ( void );
    
    /// Kx[WRNg̃ObZ[Wo̓tO擾
    //virtual bool is_ruby_gc_log_enabled ( void ) const;
    
    /// Ruby inspect \bh
    //virtual char * ruby_inspect ( char * buf, unsigned int cap ) const;
    
    /// Ruby IuWFNgɂ郉bsOCxg
    virtual void on_ruby_wrap ( void );
    
protected: /* OnOffObject C^[tFCX */
    
    /// ANeBuԂωƂ̃Cxgnh
    //virtual void on_activate ( stat_t status );
    
public:
    
    /// t[
    class frame_t
    {
    public:
        
        /// ̈e[ǔ^
        typedef std::map < std::string, Rect2 > areamap_t;
        
        /// Tut[e[ǔ^
        typedef std::map < std::string, frame_t * > framemap_t;
        
    private:
        
        /// ̈e[u
        areamap_t map_area;
        
        /// Tut[e[u
        framemap_t map_subframe;
        
    public:
        
        /// RXgN^
        frame_t ( void )
        {
        }
        
        /// ̈̒ǉ
        void add ( const std::string & name, const Rect2 & area );
        
        /// Tut[̒ǉ
        void add ( const std::string & name, frame_t * subframe );
        
    };
    
    /// XvCg̃CfNXe[ǔ^
    typedef std::map < std::string, unsigned int > indexmap_t;
    
    /// t[e[ǔ^
    typedef std::map < std::string, frame_t * > framemap_t;
    
    /// gpsN`[f[^e[ǔ^
    typedef std::set < PictureData * > imageset_t;
    
private:
    
    /// XvCgtB[h
    const std::string str_name;
    
    /// QƂrbg}bv]C[
    BitmapProjectionLayer & obj_layer;
    
    /// tB[hWJĂ̈
    /** C[rbg}bv̗̈łB̓_WJ̊_łB */
    const Rect2 rect_field;
    
    /// XvCgf[^̃obt@
    SpriteFieldData * * ary_sprite;
    
    /// o^ĂXvCg
    unsigned int num_sprite;
    
    /// CfNX}bv
    indexmap_t map_index;
    
    /// t[}bv
    framemap_t map_frame;
    
    /// sN`[f[^e[u
    imageset_t set_image;
    
public:
    
    /// RXgN^
    /**
     * @param name [in] tB[h
     * @param layer [in] WJ̃C[
     * @param set [in] gpXvCgZbg
     * @param point [in] WJ̍W
     */
    SpriteField ( const char * name, BitmapProjectionLayer & layer, const SpriteSet & set, const Point2 & point );
    
    /// fXgN^
    virtual ~SpriteField ();
    
    /// XvCgtB[hWJĂ̈擾
    const Rect2 & get_area ( void ) const
    {
        return rect_field;
    }
    
    /// XvCgtB[hWJĂ̈̃TCY擾
    Size2 get_size ( void ) const
    {
        return get_area().get_size();
    }
    
    /// XvCgtB[hWJĂ郌C[̈ʒu擾
    Point2 get_point ( void ) const
    {
        return get_area().get_point();
    }
    
    /// gp̃C[擾
    BitmapProjectionLayer & get_layer ( void ) const
    {
        return this->obj_layer;
    }
    
    /// gp̃rbg}bv擾
    Bitmap & get_bitmap ( void ) const
    {
        return this->obj_layer.get_bitmap();
    }
    
    /// XvCgtB[h擾
    const char * get_name ( void ) const
    {
        return str_name.c_str();
    }
    
    /// XvCgtB[h̕IuWFNg擾
    const std::string & get_name_string ( void ) const
    {
        return str_name;
    }
    
    /// CfNXXvCgf[^擾
    /**
     * @param id [in] XvCg ID
     * @return tB[h̃XvCgf[^
     * @retval NULL w肳ꂽ ID ̃XvCg݂͑Ȃ
     */
    const SpriteFieldData * at ( unsigned int id ) const;
    
    /// OXvCgf[^擾
    /**
     * w肷閼Oɂ͐΃pX ('/'Ŏn܂) w肵܂B
     *
     * @param name [in] XvCg
     * @return tB[h̃XvCgf[^
     * @retval NULL w肳ꂽÕXvCg݂͑Ȃ
     */
    const SpriteFieldData * find ( const char * name ) const;
    
    /// OtBbNf[^ă[h
    /**
     * XvCggpsN`[f[^AׂẴrbg}bv
     * C[ɓ]܂B
     * C[̃C[WeꂽƂɎgp܂B
     */
    void update_bitmap ( void );
    
    /// w肳ꂽt[̃XvCg
    /**
     * w肷閼Oɂ͐΃pX ('/' Ŏn܂) w肵܂B
     *  '/' ݂Ă\܂BŎ菜܂B
     *
     * C[W̓[hȂ߁AɃC[W[hKv܂B
     *
     * @param name [in] t[
     * @param set [in] ueXvCgZbg
     */
    void replace ( const char * name, const SpriteSet * set );
    
    /// o^ĂXvCg擾
    /**
     * Ԃl ID w肷邱Ƃł܂B
     *
     * @return o^ĂXvCg
     */
    unsigned int size ( void ) const
    {
        return this->num_sprite;
    }
    
};


/// O[oXvCgtB[h
/**
 * ׂẴXvCgtB[hǗ邽߂̃f[^x[XłB
 */
class GlobalSpriteField
{
private: /* static ϐ */
    
    /// Singleton IuWFNg
    static GlobalSpriteField * singleton_object;
    
public: /* static \bh */
    
    /// Singleton IuWFNg̎擾
    static GlobalSpriteField * get_instance ( void )
    {
        return singleton_object;
    }
    
private:
    
    /// XvCgZbg̔rZq
    class SpriteFieldLess
    {
    public:
        
        /// rZq
        bool operator () ( SpriteField * const & lhs, SpriteField * const & rhs ) const
        {
            return lhs->get_name_string() < rhs->get_name_string();
        }
        
        /// rZq
        bool operator () ( SpriteField * const & lhs, const char * const & rhs ) const
        {
            return lhs->get_name_string() < rhs;
        }
        
        /// rZq
        bool operator () ( const char * const & lhs, SpriteField * const & rhs ) const
        {
            return rhs->get_name_string() > lhs;
        }
        
    };
    
    /// Xg^
    typedef std::set < SpriteField *, SpriteFieldLess > set_t;
    
    /// XvCgtB[hW
    set_t set_field;
    
public:
    
    /// RXgN^
    GlobalSpriteField ( void );
    
    /// fXgN^
    ~GlobalSpriteField ();
    
    /// Ruby Kx[WRNgp}[N
    void ruby_gc_mark ( void );
    
    /// XvCgtB[h̒ǉ
    /**
     * XvCgtB[hǉ܂B
     * ̃XvCgtB[ho^邱Ƃ͂ł܂B
     *
     * @param field [in] ǉXvCgtB[h
     * @exception argument_exception ̃tB[ho^Ă
     */
    void add ( SpriteField * field );
    
    /// XvCgtB[h̍폜
    /**
     * w肳ꂽÕXvCgtB[h폜܂B
     * ݂ȂXvCgtB[h͓o^ł܂B
     *
     * @param name [in] 폜tB[h̖O
     * @return 폜ꂽIuWFNg
     * @excepiton argument_exception w肳ꂽÕtB[h͓o^ĂȂ
     */
    SpriteField * erase ( const char * name );
    
    /// ẅ܂ރtB[h̎擾
    /**
     * w肳ꂽC[̗̈ƏdȂtB[h擾܂B
     *
     * @param layer [in] tB[hWJĂ郌C[
     * @param area [in] ̈
     * @return ̈悪dȂĂtB[h
     * @retval NULL ǂ̗̈ƂdȂĂȂ
     */
    const SpriteField * get_conflict ( BitmapProjectionLayer * layer, const Rect2 & area ) const;
    
    /// XvCgtB[ȟ
    /**
     * w肳ꂽÕXvCgtB[h܂B
     *
     * @param name [in] XvCgtB[h
     * @return w肳ꂽÕXvCgtB[h
     * @retval NULL w肳ꂽÕXvCgtB[h݂͑Ȃ
     */
    SpriteField * find ( const char * name );
    
};


} /* namespace BK */


/*   Init/Exit ֐
------------------------------------------------------------------- */
namespace BK {


/// OtBbNfoCXEXvCg̏
void Init_graphic_SpriteField ( void );


/// OtBbNfoCXEXvCg̏I
void Exit_graphic_SpriteField ( void );


} /* namespace BK */


#endif /* _SCHEMA_GRAPHIC_SPRITEFIELD_H_20031219Fri_093927_ */
