/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - OtBbN - XvCgZbg
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: OtBbN: XvCgZbg
 *
 * XvCgzuǗ邽߂̃ReiNX`܂B
 *
 * @author ABE Shigeru
 * @date 2003/12/19
 */
#ifndef _SCHEMA_GRAPHIC_SPRITESET_H_20031219Fri_093703_
#define _SCHEMA_GRAPHIC_SPRITESET_H_20031219Fri_093703_


/*   萔`
------------------------------------------------------------------- */
namespace BK {


/// XvCgpX̍ő咷
const unsigned int MAX_SPRITEPATH_STRING = 1024;

/// XvCgpX̍őlXg
const unsigned int MAX_SPRITEPATH_NEST = 64;


} /* namespace BK */


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// XvCgZbg
/**
 * XvCgZbǵÄɁAXvCgƃXvCgZbgzu邽߂
 * IuWFNgłBo^ꂽf[^́uQƁv܂B
 *
 * Ce[^ɂA擾邱Ƃł܂B
 */
class SpriteSet : public RubyObject
{
public:
    
    /// eNX
    typedef RubyObject parent_t;
    
private: /* static ϐ */
    
    /// Ruby NX: SpriteSet
    static VALUE ruby_class_object;
    
public: /* static \bh */
    
    /// Ruby NX擾
    static VALUE get_ruby_class ( void );
    
    /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
    static bool is_kind_of ( VALUE obj )
    {
        return xrb_is_kind_of(obj, get_ruby_class());
    }
    
    /// Ruby IuWFNgIuWFNgɕϊ
    static SpriteSet * value_to_data ( VALUE obj )
    {
        return ruby_basecast< SpriteSet, RubyObject >( obj );
    }
    
protected: /* RubyObject C^[tFCX */
    
    /// Ruby NXIuWFNg擾
    virtual VALUE get_ruby_class_object ( void ) const
    {
        return get_ruby_class();
    }
    
public: /* RubyObject C^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    virtual void ruby_gc_mark ( void );
    
    /// Kx[WRNg̃ObZ[Wo̓tO擾
    //virtual bool is_ruby_gc_log_enabled ( void ) const;
    
    /// Ruby inspect \bh
    //virtual char * ruby_inspect ( char * buf, unsigned int cap ) const;
    
    /// Ruby IuWFNgɂ郉bsOCxg
    virtual void on_ruby_wrap ( void );
    
public:
    
    /// o^f[^
    class data_t
    {
    private:
        
        /// QƐXvCg
        Sprite * const ptr_sprite;
        
        /// QƐXvCgZbg
        SpriteSet * const ptr_set;
        
        /// gp̈
        Rect2 const rect_area;
        
    public:
        
        /// RXgN^
        /**
         * @param ptr [in] QƂXvCg ( NULL)
         * @param p [in] XvCguʒu
         */
        data_t ( Sprite & ptr, const Point2 & p )
                : ptr_sprite  (&ptr),
                  ptr_set     (NULL),
                  rect_area   (p, ptr.get_size())
        {
        }
        
        /// RXgN^
        /**
         * @param ptr [in] QƂXvCgZbg ( NULL)
         * @param p [in] XvCgZbguʒu
         */
        data_t ( SpriteSet & ptr, const Point2 & p )
                : ptr_sprite  (NULL),
                  ptr_set     (&ptr),
                  rect_area   (p, ptr.get_size())
        {
        }
        
        /// XvCgQƂĂ邩ׂ
        bool is_sprite ( void ) const
        {
            return ptr_sprite != NULL;
        }
        
        /// XvCgZbgQƂĂ邩ׂ
        bool is_set ( void ) const
        {
            return ptr_set != NULL;
        }
        
        /// QƂĂXvCg擾
        Sprite * get_sprite ( void ) const
        {
            return ptr_sprite;
        }
        
        /// QƂĂXvCgZbg擾
        SpriteSet * get_set ( void ) const
        {
            return ptr_set;
        }
        
        /// Ruby IuWFNg擾
        VALUE get_ruby_object ( void ) const
        {
            return (is_sprite()) ? ptr_sprite->get_ruby_object() : ptr_set->get_ruby_object();
        }
        
        /// Ruby Kx[WRNgp}[N
        void gc_mark_self ( void )
        {
            if( this->is_sprite() ) {
                this->ptr_sprite->gc_mark_self();
            } else {
                this->ptr_set->gc_mark_self();
            }
        }
        
        /// Ruby IuWFNgɂ郉bsO
        void on_ruby_wrap ( void )
        {
            if( this->is_sprite() ) {
                this->ptr_sprite->on_ruby_wrap();
            } else {
                this->ptr_set->on_ruby_wrap();
            }
        }
        
        /// Ruby IuWFNgɂ郉bsO
        VALUE ruby_wrap ( void )
        {
            if( this->is_sprite() ) {
                return this->ptr_sprite->ruby_wrap();
            } else {
                return this->ptr_set->ruby_wrap();
            }
        }
        
        /// ZbgɂQƗ̈̎擾
        const Rect2 & get_area ( void ) const
        {
            return rect_area;
        }
        
        /// ZbgɂQƗ̈̍W擾
        Point2 get_point ( void ) const
        {
            return rect_area.get_point();
        }
        
        /// ZbgɂQƗ̈̃TCY擾
        Size2 get_size ( void ) const
        {
            return rect_area.get_size();
        }
    };
    
    /// f[^e[u^
    typedef std::map < std::string, data_t * > map_t;
    
    /// Ce[^^ (const)
    typedef map_t::const_iterator const_iterator;
    
private:
    
    /// Zbg̗̈TCY
    const Size2 size_field;
    
    /// f[^e[u
    map_t map_data;
    
    /// o^ĂXvCg̐
    unsigned int num_sprite;
    
private:
    
    /// w肳ꂽ`L𒲂ׂ
    /**
     * w肳ꂽ`XvCgZbg֒ǉł邩ǂ𒲂ׂB
     *
     * @param r [in] ǉ`
     * @retval true ǉ\
     * @retval false ǉs\
     */
    bool is_valid_rect ( const Rect2 & r ) const;
    
    /// f[^̒ǉ
    void add_data ( const char * name, const char * datatype, data_t * data );
    
public:
    
    /// RXgN^
    /**
     * @param size [in] XvCgZbg̗̈TCY
     */
    SpriteSet ( const Size2 & size );
    
    /// fXgN^
    virtual ~SpriteSet ();
    
    /// XvCgZbg̗̈TCY擾
    const Size2 & get_size ( void ) const
    {
        return size_field;
    }
    
    /// XvCg̓o^
    /**
     * ʒu p Ɏw肳ꂽÕXvCg (ւ̎Q) o^܂B
     * ̃f[^݂ꍇAf[^͏㏑܂B
     *
     * @param name [in] vf
     * @param sprite [in] o^XvCg
     * @param p [in] ʒu
     * @exception argument_exception XvCgZbg̗̈Ɏ܂Ȃ
     */
    void add_sprite ( const char * name, Sprite & sprite, const Point2 & p );
    
    /// XvCgZbg̓o^
    /**
     * ʒu p Ɏw肳ꂽÕXvCgZbg (ւ̎Q) o^܂B
     * ̃f[^݂ꍇAf[^͏㏑܂B
     *
     * @param name [in] vf
     * @param sprite [in] o^XvCgZbg
     * @param p [in] ʒu
     * @exception argument_exception Zbg̗̈Ɏ܂Ȃ
     */
    void add_set ( const char * name, SpriteSet & set, const Point2 & p );
    
    /// f[^̍폜
    /**
     * w肳ꂽÕf[^폜܂B
     * 폜ł̂́ÃXvCgZbgɓo^ꂽf[^݂̂łB
     *
     * @param name [in] 폜f[^̖O
     * @return 폜ꂽf[^
     * @exception argument_exception w肳ꂽÕf[^݂Ȃ
     */
    data_t erase ( const char * name );
    
    /// f[^̎擾
    /**
     * w肳ꂽÕf[^擾܂B
     * Ԃꂽf[^́AXvCgZbg邩Ao^폜ꂽ_ŎgpłȂȂ܂B
     * 擾́AKvȃf[^Rs[ȂǂđΏKv܂B
     * f[^o^ĂȂꍇANULL Ԃ܂B
     *
     * lXgꂽf[^擾ꍇ / ŋ؂܂B
     *
     * @param name [in] f[^̔z
     * @return f[^ւ̃|C^
     * @retval NULL w肳ꂽÕf[^݂Ȃ
     */
    const data_t * find ( const char * name ) const;
    
    /// f[^̎擾
    /**
     * w肳ꂽÕf[^擾܂B
     * f[^o^ĂȂꍇANULL Ԃ܂B
     *
     * ̖OnƂɂAlXgꂽf[^邱Ƃł܂B
     *
     * @param length [in] O̊Kw
     * @param name [in] f[^̔z ( NULL łȂ΂ȂȂ)
     * @return f[^ւ̃|C^
     * @retval NULL w肳ꂽÕf[^݂Ȃ
     */
    const data_t * find ( unsigned int length, const char * const * names ) const;
    
    /// f[^̎擾 (̃Zbĝ݂猟)
    /**
     * w肳ꂽÕf[^擾܂B
     * lXgꂽf[^͌܂B
     *
     * @param name [in] f[^ ( NULL łȂ΂ȂȂ)
     * @return f[^ւ̃|C^
     * @retval NULL w肳ꂽÕf[^݂Ȃ
     */
    const data_t * get_data ( const char * name ) const;
    
    /// o^Ăf[^擾
    /**
     * ̃XvCgZbgɓo^Ăf[^݂̂擾܂B
     */
    unsigned int size ( void ) const
    {
        return static_cast< unsigned int >( map_data.size() );
    }
    
    /// 擪Ce[^擾
    const_iterator begin ( void ) const
    {
        return map_data.begin();
    }
    
    /// Ce[^擾
    const_iterator end ( void ) const
    {
        return map_data.end();
    }
    
    /// o^ĂXvCg̎擾
    /**
     * q̃XvCgZbg܂߂āAׂẴXvCg𐔂܂B
     *
     * @return ZbgɊ܂܂邷ׂẴXvCg
     */
    unsigned int count_sprite ( void ) const;
    
};


/// XvCgZbg̃O[oW
/**
 * XvCgZbgɃO[oANZX邽߂ Singleton IuWFNgłB
 * WɁA̖OIuWFNgo^邱Ƃ͂ł܂B
 *
 * f[^̏㉺֌WȂ߁AWɂȂĂ܂B
 */
class GlobalSpriteSet
{
private: /* static ϐ */
    
    /// Singleton IuWFNg
    static GlobalSpriteSet * singleton_object;
    
public: /* static \bh */
    
    /// Singleton IuWFNg̎擾
    static GlobalSpriteSet * get_instance ( void )
    {
        return singleton_object;
    }
    
public:
    
    /// W^
    typedef std::map < std::string, SpriteSet * > map_t;
    
private:
    
    /// XvCgZbgW
    map_t map_spriteset;
    
public:
    
    /// RXgN^
    GlobalSpriteSet ( void );
    
    /// fXgN^
    ~GlobalSpriteSet ();
    
    /// Ruby Kx[WRNgp}[N
    void ruby_gc_mark ( void );
    
    /// XvCgZbǧ
    /**
     * w肳ꂽÕXvCgZbg܂BXvCg͌܂B
     *  / ŖO؂邱ƂɂAlXgꂽf[^擾邱Ƃł܂B
     *
     * ZbǵA΃pX` ( / Ŏn܂) ŏȂ΂Ȃ܂B
     *
     * () "/A/B/C" ... A ̓O[oXvCgZbgɓo^ꂽXvCgZbgłB
     *
     * @param name [in] XvCgZbg
     * @return w肳ꂽÕXvCgZbg
     * @retval NULL w肳ꂽÕXvCgZbg݂͑Ȃ
     */
    SpriteSet * find ( const char * name );
    
    /// XvCgZbǧ
    /**
     * w肳ꂽÕXvCgZbg܂B
     * pXĂꍇɎgp郁\bhłB
     *
     * @param length [in] O̊Kw
     * @param name [in] f[^̔z ( NULL łȂ΂ȂȂ)
     * @return XvCgZbg
     * @retval NULL w肳ꂽÕf[^݂Ȃ
     */
    SpriteSet * find ( unsigned int length, const char * const * names );
    
    /// XvCgZbg̒ǉ
    /**
     * XvCgZbg (ւ̎Q) o^܂B
     * ̃XvCgZbg݂ꍇAQƂ͏㏑܂B
     *
     * @param name [in] XvCgZbg
     * @param set [in] o^XvCgZbg
     */
    void add ( const char * name, SpriteSet & set );
    
    /// XvCgZbg̍폜
    /**
     * o^݂̂ŁAIuWFNg킯ł͂܂B
     *
     * @param name [in] XvCgZbg
     * @return 폜ꂽXvCgZbg
     * @exception argument_exception w肳ꂽÕXvCgZbg݂͑Ȃ
     */
    SpriteSet * erase ( const char * name );
    
};


} /* namespace BK */


/*   Init/Exit ֐
------------------------------------------------------------------- */
namespace BK {


/// OtBbNfoCXEXvCg̏
void Init_graphic_SpriteSet ( void );


/// OtBbNfoCXEXvCg̏I
void Exit_graphic_SpriteSet ( void );


} /* namespace BK */


#endif /* _SCHEMA_GRAPHIC_SPRITESET_H_20031219Fri_093703_ */
