/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - OtBbN - C[ - eLXgxC[
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: OtBbN: C[: eLXgxC[
 *
 * eLXgXN[ɕ`悷郌C[NX`܂B
 *
 * @author ABE Shigeru
 * @date 2003/12/22
 */
#ifndef _SCHEMA_GRAPHIC_LAYER_TEXTLABELLAYER_H_20031222Mon_092140_
#define _SCHEMA_GRAPHIC_LAYER_TEXTLABELLAYER_H_20031222Mon_092140_


/*   NX̒`
------------------------------------------------------------------- */
namespace BK {


/// eLXgx
/**
 * eLXgxC[ŎgpIuWFNgłB
 * ȉ̏ێ܂B
 *  - x
 *  - \`
 *  - tHg
 * TuNXɂāA_O@w肵܂B
 */
class TextLabel : public OnOffObject, public RubyObject
{
private: /* static ϐ */
    
    /// Ruby NX: TextLabel
    static VALUE ruby_class_object;
    
public: /* static \bh */
    
    /// Ruby NX擾
    static VALUE get_ruby_class ( void );
    
    /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
    static bool is_kind_of ( VALUE obj )
    {
        return xrb_is_kind_of(obj, get_ruby_class());
    }
    
    /// Ruby IuWFNgIuWFNgɕϊ
    static TextLabel * value_to_data ( VALUE obj )
    {
        return ruby_cast< TextLabel >( obj );
    }
    
protected: /* RubyObject C^[tFCX */
    
    /// Ruby NXIuWFNg擾
    VALUE get_ruby_class_object ( void ) const
    {
        return get_ruby_class();
    }
    
    /// }[Np֐擾
    void * get_ruby_mark_function ( void );
    
    /// p֐擾
    void * get_ruby_free_function ( void );
    
    /// bsOɎgp|C^̎擾
    void * get_wrapped_address ( void )
    {
        return this;
    }
    
public: /* RubyObject C^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    void ruby_gc_mark ( void );
    
protected: /* OnOffObject C^[tFCX */
    
    /// ANeBuԂωƂ̃Cxgnh
    //virtual void on_activate ( stat_t status );
    
public:
    
    /// ëʒu
    /**
     * TuNX𒼐ڑ삷Ƒz肵Ă邽߁Az֐ݒ肵Ă܂B
     */
    class infobase_t
    {
    private:
        
        /// gptBIuWFNg
        Film * ptr_film;
        
        /// ]̈
        /** tB̗̈܂B */
        Rect2 rect_source;
        
        /// ]̈
        /** ẍ̗܂B */
        Rect2 rect_dest;
        
        /// `F
        AlphaColor obj_color;
        
    public:
        
        /// RXgN^
        infobase_t ( void )
                : ptr_film (NULL)
        {
        }
        
        /// fXgN^
        ~infobase_t ()
        {
        }
        
        /// gptBIuWFNg̎擾
        Film * get_film ( void ) const
        {
            return ptr_film;
        }
        
        /// ]̈̎擾
        /** tB̗̈Ԃ܂B */
        const Rect2 & get_source ( void ) const
        {
            return rect_source;
        }
        
        /// ]̈̎擾
        /** ẍ̗Ԃ܂B */
        const Rect2 & get_destination ( void ) const
        {
            return rect_dest;
        }
        
        /// `F̎擾
        const AlphaColor & get_color ( void ) const
        {
            return obj_color;
        }
        
        /// gptBIuWFNg̐ݒ
        void set_film ( Film * film )
        {
            ptr_film = film;
        }
        
        /// ]̈̐ݒ
        void set_source ( const Rect2 & r )
        {
            rect_source = r;
        }
        
        /// ]̈̐ݒ
        void set_destination ( const Rect2 & r )
        {
            rect_dest = r;
        }
        
        /// `F̐ݒ
        void set_color ( const AlphaColor & c )
        {
            obj_color = c;
        }
        
        /// Ruby Kx[WRNgp}[N
        void ruby_gc_mark ( void )
        {
            if( ptr_film != NULL ) {
                rb_gc_mark( ptr_film->get_ruby_object() );
            }
        }
        
    };
    
private:
    
    /// x
    /** XML ȂǁAf[^ێ܂B */
    std::string str_label;
    
    /// x̕\`
    Rect2 rect_area;
    
    /// gptHg
    Font * ptr_font;
    
protected:
    
    /// CAEg̍XV
    /**
     * x̕ύXsƂȂǂɁAs܂B
     * CAEg̍XVA]̈쐬܂B
     */
    virtual void update_layout ( void ) = 0;
    
public:
    
    /// RXgN^
    TextLabel ( void );
    
    /// fXgN^
    virtual ~TextLabel ();
    
    /// xXN[ɕ`悷
    /**
     * TuNXɂĎ܂B
     *
     * @param dev [in] `̃OtBbNfoCX
     */
    virtual void execute ( GraphicDevice * dev ) = 0;
    
    /// xɕݒ肷
    /**
     * w肳ꂽ́ÃIuWFNgɃRs[܂B
     * ݒACAEg̍č\zs܂B
     *
     * xɂ́AXML ȂǁAf[^ݒ肵܂B
     *
     * @param str [in] x
     */
    virtual void set_label ( const char * str );
    
    /// x\`ݒ肷
    /**
     * x̕\ʒuƑŜ̃TCYݒ肵܂B
     * TCYύXꂽꍇACAEg̍č\zs܂B
     *
     * \`O̓̕NbsO܂B
     *
     * @param area [in] ݒ肷`
     */
    virtual void set_area ( const Rect2 & area );
    
    /// gptHgݒ肷
    /**
     * ݒACAEg̍č\zs܂B
     *
     * @param font [in] gptHg
     */
    virtual void set_font ( Font * font );
    
    /// ݒ肳Ă镶擾
    /** f[^Ԃ邽߁AKǂƂ͌܂B */
    const char * get_label ( void ) const
    {
        return str_label.c_str();
    }
    
    /// ݒ肳Ă镶IuWFNg擾
    /** f[^Ԃ邽߁AKǂƂ͌܂B */
    const std::string & get_label_string ( void ) const
    {
        return str_label;
    }
    
    /// x̕\`擾
    const Rect2 & get_area ( void ) const
    {
        return rect_area;
    }
    
    /// x\`̃TCY擾
    Size2 get_size ( void ) const
    {
        return rect_area.get_size();
    }
    
    /// x̕\ʒu擾
    Point2 get_point ( void ) const
    {
        return rect_area.get_point();
    }
    
    /// gptHg擾
    Font * get_font ( void ) const
    {
        return ptr_font;
    }
    
};


/// VvȃeLXgx
/**
 * vpeB̐ݒɂĕ̈ʒu킹seLXgxłB
 */
class SimpleTextLabel : public TextLabel
{
private: /* static ϐ */
    
    /// Ruby NX: SimpleTextLabel
    static VALUE ruby_class_object;
    
public: /* static \bh */
    
    /// Ruby NX擾
    static VALUE get_ruby_class ( void );
    
    /// Ruby IuWFNgIuWFNgɕϊ
    static SimpleTextLabel * value_to_data ( VALUE obj )
    {
        return ruby_basecast< SimpleTextLabel, TextLabel >( obj );
    }
    
protected: /* RubyObject C^[tFCX */
    
    /// Ruby NXIuWFNg擾
    VALUE get_ruby_class_object ( void ) const
    {
        return get_ruby_class();
    }
    
public: /* RubyObject C^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    void ruby_gc_mark ( void );
    
protected: /* TextLabel C^[tFCX */
    
    /// CAEg̍XV
    virtual void update_layout ( void );
    
public: /* TextLabel C^[tFCX */
    
    /// xXN[ɕ`悷
    virtual void execute ( GraphicDevice * dev );
    
public:
    
    /// ʒu
    enum align_t
    {
        LEFT   = 0,  /// [
        TOP    = 0,  /// [
        CENTER = 1,  /// 
        MIDDLE = 1,  /// 
        RIGHT  = 2,  /// E[
        BOTTOM = 2,  /// [
        FIT    = 3,  /// [
    };
    
    /// IuWFNg
    typedef infobase_t info_t;
    
    /// ̃Xg
    typedef std::vector < info_t > list_t;
    
private:
    
    /// ʒu
    align_t num_horizontal;
    
    /// ʒu
    align_t num_vertical;
    
    /// IuWFNg̃Xg
    list_t ary_info;
    
public:
    
    /// RXgN^
    SimpleTextLabel ( void );
    
    /// fXgN^
    ~SimpleTextLabel ();
    
    /// ʒu̐ݒ
    void set_horizontal ( align_t align );
    
    /// ʒu̐ݒ
    void set_vertical ( align_t align );
    
    /// ʒu̎擾
    align_t get_horizontal ( void ) const
    {
        return num_horizontal;
    }
    
    /// ʒu̎擾
    align_t get_vertical ( void ) const
    {
        return num_vertical;
    }
    
};


/// eLXgxC[
/**
 * eLXgXN[ɕ`悷邽߂̃C[łB
 * C[ɓo^ꂽeLXgxIuWFNg`悳܂B
 */
class TextLabelLayer : public Layer
{
private: /* static ϐ */
    
    /// Ruby NX: TextLabelLayer
    static VALUE ruby_class_object;
    
public: /* static \bh */
    
    /// Ruby NX擾
    static VALUE get_ruby_class ( void );
    
    /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
    static bool is_kind_of ( VALUE obj )
    {
        return xrb_is_kind_of(obj, get_ruby_class());
    }
    
    /// Ruby IuWFNgIuWFNgɕϊ
    static TextLabelLayer * value_to_data ( VALUE obj )
    {
        return ruby_basecast< TextLabelLayer, Layer >( obj );
    }
    
protected: /* RubyObject C^[tFCX */
    
    /// Ruby NXIuWFNg擾
    virtual VALUE get_ruby_class_object ( void ) const
    {
        return get_ruby_class();
    }
    
public: /* RubyObject C^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    virtual void ruby_gc_mark ( void );
    
public: /* Layer C^[tFCX */
    
    /// `Cxg
    virtual void execute ( GraphicDevice * dev ) = 0;
    
public:
    
    /// eNX̌^
    typedef Layer parent_t;
    
    /// eLXgx̃Xg^
    typedef std::vector < TextLabel * > list_t;
    
private:
    
    /// eLXgx̃Xg
    list_t ary_label;
    
protected:
    
    /// eLXgx̐
    /**
     * eɓKeLXgxIuWFNg𐶐܂B
     * ftHgł TextLabel IuWFNg܂B
     */
    virtual TextLabel * create_label ( void );
    
public:
    
    /// RXgN^
    TextLabelLayer ( void );
    
    /// fXgN^
    virtual ~TextLabelLayer ();
    
    /// eLXgx̓o^
    /**
     * eLXgx𐶐AC[ɓo^܂B
     *
     * @param font [in] gptHg
     * @return ꂽeLXgxIuWFNg
     */
    TextLabel * add ( void );
    
    /// eLXgx̍폜
    /**
     * o^ĂeLXgx폜܂B
     * ʏ́AeLXgx~Ԃɂ邱Ƃō폜s܂B
     *
     * @param label [in] 폜IuWFNg
     */
    void erase ( TextLabel * label );
    
    /// o^ĂeLXgx擾
    unsigned int size ( void ) const
    {
        return static_cast< unsigned int >( ary_list.size() );
    }
    
};


} /* namespace BK */


/*   Init/Exit ֐
------------------------------------------------------------------- */
namespace BK {


/// OtBbNfoCXEC[̏
void Init_graphic_layer_TextLabelLayer ( void );


/// OtBbNfoCXEC[̏I
void Exit_graphic_layer_TextLabelLayer ( void );


} /* namespace BK */


#endif /* _SCHEMA_GRAPHIC_LAYER_TEXTLABELLAYER_H_20031222Mon_092140_ */
