/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - CvbgfoCX - z̓foCX
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: CvbgfoCX: z̓foCX
 *
 * zIȓ̓foCX񋟂܂B
 *
 * @author ABE Shigeru
 * @date 2004/02/16
 */
#ifndef _SCEHMA_INPUT_ABSTRACTINPUT_H_20040216Mon_121350_
#define _SCEHMA_INPUT_ABSTRACTINPUT_H_20040216Mon_121350_


/*   萔`
------------------------------------------------------------------- */
namespace BK {


/// foCX͂̃{^ԍŒl
/** {^ĂȂԂ\܂B */
const int BUTSTAT_RELEASED = 0;

/// foCX͂̃{^ԍől
/** {^SɉĂԂ\܂B */
const int BUTSTAT_PRESSED = 0xff;


} /* namespace BK */


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// ۉꂽfoCX
class AbstractInput : public RubyObject
{
public:
    
    /// eNX
    typedef RubyObject parent_t;
    
private: /* static ϐ */
    
    /// Ruby NX: AbstractInput
    static VALUE ruby_class_object;
    
public: /* static \bh */
    
    /// Ruby NX擾
    static VALUE get_ruby_class ( void );
    
    /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
    static bool is_kind_of ( VALUE obj )
    {
        return xrb_is_kind_of(obj, get_ruby_class());
    }
    
    /// Ruby IuWFNgIuWFNgɕϊ
    static AbstractInput * value_to_data ( VALUE obj )
    {
        return ruby_basecast< AbstractInput, RubyObject >( obj );
    }
    
protected: /* RubyObject C^[tFCX */
    
    /// Ruby NXIuWFNg擾
    VALUE get_ruby_class_object ( void ) const
    {
        return get_ruby_class();
    }
    
public: /* RubyObject C^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    //virtual void ruby_gc_mark ( void );
    
    /// Kx[WRNg̃ObZ[Wo̓tO擾
    //virtual bool is_ruby_gc_log_enabled ( void ) const;
    
    /// Ruby inspect \bh
    //virtual char * ruby_inspect ( char * buf, unsigned int cap ) const;
    
    /// Ruby IuWFNgɂ郉bsOCxg
    //virtual void on_ruby_wrap ( void );
    
public:
    
    /// foCX^Cv
    enum type_t
    {
        DEV_UNKNOWN,   /// sȃfoCX
        DEV_KEYBOARD,  /// L[{[h
        DEV_MOUSE,     /// }EX
        DEV_GAMEPAD,   /// Q[pbh (WCXeBbN)
    };
    
    /// foCX^Cv Ruby 萔ւ̕ϊ
    /** AbstractInput ̒萔Ԃ܂B */
    static VALUE type_to_VALUE ( type_t type );
    
public: /* AbstractInput C^[tFCX */
    
    /// foCX̏ԂXV
    virtual void update ( void ) = 0;
    
    /// L[̕ωʂ擾
    virtual Point2 get_delta ( void ) const = 0;
    
    /// gpł{^̐擾
    /**
     * IuWFNg̍\zAɓlԂƂۏ؂Ă܂B
     */
    virtual int count_button ( void ) const = 0;
    
    /// foCX^Cv擾
    /**
     * IuWFNg̎̂ɑΉfoCXԂ܂B
     */
    virtual type_t get_type ( void ) const = 0;
    
    /// foCX擾
    virtual const char * get_name ( void ) const = 0;
    
    /// w͈͂̃{^Ԃ擾
    /**
     * {^̏Ԃ 0 (ĂȂ) ` 255 (؂Ă) ŕ\܂B
     * AbstractInput ̎ł́Anꂽp[^̃`FbN݂̂s܂B
     *
     * @param index [out] Ԃi[obt@
     * @param start [in] 擾Jn{^̔ԍ
     * @param count [in] 擾{^̐
     */
    virtual void get_button_states ( int * index, int start, int count ) const;
    
public:
    
    /// RXgN^
    AbstractInput ( void );
    
    /// fXgN^
    virtual ~AbstractInput ();
    
    /// {^̏Ԃ擾
    /**
     * @see get_button_states()
     */
    int get_button_state ( int index ) const;
    
};


} /* namespace BK */


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// }EX
class MouseInput : public AbstractInput
{
public:
    
    /// eNX
    typedef AbstractInput parent_t;
    
private: /* static ϐ */
    
    /// Ruby NX: MouseInput
    static VALUE ruby_class_object;
    
public: /* static \bh */
    
    /// Ruby NX擾
    static VALUE get_ruby_class ( void );
    
    /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
    static bool is_kind_of ( VALUE obj )
    {
        return xrb_is_kind_of(obj, get_ruby_class());
    }
    
    /// Ruby IuWFNgIuWFNgɕϊ
    static MouseInput * value_to_data ( VALUE obj )
    {
        return ruby_basecast< MouseInput, RubyObject >( obj );
    }
    
protected: /* RubyObject C^[tFCX */
    
    /// Ruby NXIuWFNg擾
    VALUE get_ruby_class_object ( void ) const
    {
        return get_ruby_class();
    }
    
public: /* RubyObject C^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    //virtual void ruby_gc_mark ( void );
    
    /// Kx[WRNg̃ObZ[Wo̓tO擾
    //virtual bool is_ruby_gc_log_enabled ( void ) const;
    
    /// Ruby inspect \bh
    //virtual char * ruby_inspect ( char * buf, unsigned int cap ) const;
    
    /// Ruby IuWFNgɂ郉bsOCxg
    //virtual void on_ruby_wrap ( void );
    
public: /* AbstractInput C^[tFCX */
    
    /// foCX^Cv擾
    type_t get_type ( void ) const
    {
        return DEV_MOUSE;
    }
    
public:
    
    /// RXgN^
    MouseInput ( void );
    
    /// fXgN^
    virtual ~MouseInput ();
    
};


/// L[{[h
class KeyboardInput : public AbstractInput
{
public:
    
    /// eNX
    typedef AbstractInput parent_t;
    
private: /* static ϐ */
    
    /// Ruby NX: KeyboardInput
    static VALUE ruby_class_object;
    
public: /* static \bh */
    
    /// Ruby NX擾
    static VALUE get_ruby_class ( void );
    
    /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
    static bool is_kind_of ( VALUE obj )
    {
        return xrb_is_kind_of(obj, get_ruby_class());
    }
    
    /// Ruby IuWFNgIuWFNgɕϊ
    static KeyboardInput * value_to_data ( VALUE obj )
    {
        return ruby_basecast< KeyboardInput, RubyObject >( obj );
    }
    
protected: /* RubyObject C^[tFCX */
    
    /// Ruby NXIuWFNg擾
    VALUE get_ruby_class_object ( void ) const
    {
        return get_ruby_class();
    }
    
public: /* RubyObject C^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    //virtual void ruby_gc_mark ( void );
    
    /// Kx[WRNg̃ObZ[Wo̓tO擾
    //virtual bool is_ruby_gc_log_enabled ( void ) const;
    
    /// Ruby inspect \bh
    //virtual char * ruby_inspect ( char * buf, unsigned int cap ) const;
    
    /// Ruby IuWFNgɂ郉bsOCxg
    //virtual void on_ruby_wrap ( void );
    
public: /* AbstractInput C^[tFCX */
    
    /// foCX^Cv擾
    type_t get_type ( void ) const
    {
        return DEV_KEYBOARD;
    }
public:
    
    /// RXgN^
    KeyboardInput ( void );
    
    /// fXgN^
    virtual ~KeyboardInput ();
    
};


/// Q[pbh
class GamepadInput : public AbstractInput
{
public:
    
    /// eNX
    typedef AbstractInput parent_t;
    
private: /* static ϐ */
    
    /// Ruby NX: GamepadInput
    static VALUE ruby_class_object;
    
public: /* static \bh */
    
    /// Ruby NX擾
    static VALUE get_ruby_class ( void );
    
    /// w肳ꂽ Ruby IuWFNgTuNXł邩𒲂ׂ
    static bool is_kind_of ( VALUE obj )
    {
        return xrb_is_kind_of(obj, get_ruby_class());
    }
    
    /// Ruby IuWFNgIuWFNgɕϊ
    static GamepadInput * value_to_data ( VALUE obj )
    {
        return ruby_basecast< GamepadInput, RubyObject >( obj );
    }
    
protected: /* RubyObject C^[tFCX */
    
    /// Ruby NXIuWFNg擾
    VALUE get_ruby_class_object ( void ) const
    {
        return get_ruby_class();
    }
    
public: /* RubyObject C^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    //virtual void ruby_gc_mark ( void );
    
    /// Kx[WRNg̃ObZ[Wo̓tO擾
    //virtual bool is_ruby_gc_log_enabled ( void ) const;
    
    /// Ruby inspect \bh
    //virtual char * ruby_inspect ( char * buf, unsigned int cap ) const;
    
    /// Ruby IuWFNgɂ郉bsOCxg
    //virtual void on_ruby_wrap ( void );
    
public: /* AbstractInput C^[tFCX */
    
    /// foCX^Cv擾
    type_t get_type ( void ) const
    {
        return DEV_GAMEPAD;
    }
    
public:
    
    /// RXgN^
    GamepadInput ( void );
    
    /// fXgN^
    virtual ~GamepadInput ();
    
};


} /* namespace BK */


/*   Init/Exit ֐
------------------------------------------------------------------- */
namespace BK {


/// ̓foCX̏
void Init_input_AbstractInput ( void );


/// ̓foCX̏I
void Exit_input_AbstractInput ( void );


} /* namespace BK */


#endif /* _SCEHMA_INPUT_ABSTRACTINPUT_H_20040216Mon_121350_ */
