/*                                                  project Black Kit
----------------------------------------------------------------------
   Black Kit - XL[}ZNV - CvbgfoCX
      $Id$
                  Copyright (C) 2003-2003, Black <shiger-a@nifty.com> 
----------------------------------------------------------------------
*/
/** @file
 * @brief XL[}ZNV: CvbgfoCX
 *
 * ͋@\񋟂foCX̃NX`܂B
 *
 * @author ABE Shigeru
 * @date 2004/02/16
 */
#ifndef _SCHEMA_INPUT_INPUTDEVICE_H_20040216Mon_121011_
#define _SCHEMA_INPUT_INPUTDEVICE_H_20040216Mon_121011_


/*   CN[h
------------------------------------------------------------------- */
#include "id_AbstractInput.h"


/*   NX`
------------------------------------------------------------------- */
namespace BK {


/// CvbgfoCX
/**
 * ̓foCX\NXłB
 * AvP[VfoCX\zĂȂ΁AfoCX̍\zł܂B
 */
class InputDevice : public ServiceDevice
{
private: /* static ϐ */
    
    /// Singleton IuWFNg
    static InputDevice * singleton_object;
    
public: /* static \bh */
    
    /// \zꂽAvP[VfoCX擾
    static InputDevice * get_instance ( void )
    {
        return singleton_object;
    }
    
protected: /* ServiceDevice C^[tFCX */
    
    /// foCX̊Jn
    virtual void _start ( void );
    
    /// foCX̏I
    virtual void _stop ( void );
    
public: /* ServiceDevice C^[tFCX */
    
    /// Ruby Kx[WRNgp}[N
    virtual void ruby_gc_mark ( void );
    
    /// foCX̎擾
    virtual const char * get_device_name ( void ) const;
    
public: /* InputDevice C^[tFCX */
    
    /// ڑĂfoCX̐擾
    /**
     * @return ڑĂfoCX
     */
    virtual int count_device ( void ) const = 0;
    
    /// ڑĂfoCX̖̂擾
    /**
     * @param index [in] foCXԍ (0 ` count_device() - 1)
     */
    virtual std::string get_device_name ( int index ) const = 0;
    
    /// ڑĂfoCX̃^Cv擾
    virtual AbstractInput::type_t get_device_type ( int index ) const = 0;
    
    /// foCX𗘗p\Ԃɂ
    /**
     * w肳ꂽfoCXłɗp\łƂ́AɏI܂B
     * ͈͊ÕCfNXw肳ꂽꍇ out_of_range_exception O܂B
     * ʏAԂ Ruby IuWFNg͎gp܂B
     *
     * @return p\ɂȂfoCX
     */
    virtual AbstractInput * setup_device ( int index ) = 0;
    
    /// foCX̓o^
    /**
     * w肳ꂽfoCXp\ɂȂĂȂꍇ argument_exception O܂B
     */
    virtual void release_device ( int index ) = 0;
    
public:
    
    /// RXgN^
    InputDevice ( void );
    
    /// fXgN^
    virtual ~InputDevice ();
    
};


} /* namespace BK */


/*   Init/Exit ֐
------------------------------------------------------------------- */
namespace BK {


/// ̓foCX̏
void Init_input_InputDevice ( void );


/// ̓foCX̏I
void Exit_input_InputDevice ( void );


} /* namespace BK */


#endif /* _SCHEMA_INPUT_INPUTDEVICE_H_20040216Mon_121011_ */
