#include "stdafx.h"
#include "body/main.h"

//////////////////////////////////////////////////////////////////////
////  BK::W32Event
//

BK::W32Event::W32Event ( const char * name )
        : handle_event (NULL),
          str_name ((name == NULL) ? "" : name)
{
    HANDLE handle;
    
    if( name != NULL ) {
        throw new unsupported_exception("OtCxg̓T|[gĂ܂.");
    } else {
        handle = CreateEvent( NULL, true, false, name );
        if( handle == NULL ) {
            throw new windows_exception("CxgIuWFNg̐Ɏs܂.");
        }
    }
    handle_event = handle;
}

BK::W32Event::~W32Event ()
{
    if( handle_event != NULL ) {
        CloseHandle( handle_event );
    }
}

void BK::W32Event::send_signal ( void )
{
    if( SetEvent(get_handle()) == 0 ) {
        throw new windows_exception("Cxg̃VOiԐݒɎs");
    }
}

void BK::W32Event::send_pulse ( void )
{
    if( PulseEvent(get_handle()) == 0 ) {
        throw new windows_exception("Cxg̃VOipXMɎs");
    }
}

void BK::W32Event::clear ( void )
{
    if( ResetEvent(get_handle()) == 0 ) {
        throw new windows_exception("Cxg̔VOiԐݒɎs");
    }
}

bool BK::W32Event::wait ( unsigned int waitmsec )
{
    DWORD result = WaitForSingleObject(get_handle(), waitmsec);
    
    if( result == WAIT_OBJECT_0 )
        return true;
        
    if( result == WAIT_TIMEOUT )
        return false;
    
    throw new windows_exception("Cxg̑ҋ@Ɏs");
    return false; // dummy
}

const char * BK::W32Event::get_name ( void ) const
{
    return (str_name.empty()) ? "" : str_name.c_str();
}

//////////////////////////////////////////////////////////////////////
