#include "stdafx.h"
#include "schema/main.h"

//////////////////////////////////////////////////////////////////////
////  t@C[Jȃ\bh
//
namespace {

/// FillScreenGear ӂɎʂ邽߂̘A
unsigned int _serial_number = 0;

unsigned int get_serial_number ( void )
{
    return _serial_number++;
}

} /* namespace */
//////////////////////////////////////////////////////////////////////
////  Ruby IuWFNg: BK::FillScreenGear
//
namespace {
extern "C" {

/// MA̐
VALUE FillScreenGear_new ( int argc, VALUE * argv, VALUE klass )
{
    using namespace BK;
    VALUE volatile obj = Qnil;
    FillScreenGear * ptr;
    
    try {
        Ruby::ArgScanner scanner("FillScreenGear.new", argc, argv);
        FrameTimer::time_t len;
        AlphaColor color;
        
        if( scanner.is_empty() ) {
            len = 0;
        } else {
            len = NUM2ULONG(scanner.fetch_value("ҋ@"));
        }
        if( scanner.is_empty() ) {
            color.set_alpha_color( 0, 0, 0, COLOR_ELEMENT_MAX );
        } else {
            color = scanner.fetch_AlphaColor("hԂF");
        }
        scanner.finish();
        
        ptr = new FillScreenGear();
        if( ptr == NULL ) {
            throw_no_memory_for_object("FillScreenGear");
        }
        obj = ptr->ruby_wrap();
        ptr->set_length( len );
        ptr->set_fill_color( color );
    }
    catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    rb_obj_call_init( obj, argc, argv );
    
    try {
        ApplicationDevice::global_add_gear( *ptr );
    }
    catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return obj;
}

/// MȀ
VALUE FillScreenGear_initialize ( int argc, VALUE * argv, VALUE self )
{
    return self;
}

/// hԂF̎擾
VALUE FillScreenGear_get_color ( VALUE self )
{
    using namespace BK;
    FillScreenGear * const ptr = FillScreenGear::value_to_data( self );
    VALUE volatile obj = Qnil;
    
    try {
        obj = ptr->get_fill_color().create_ruby_object();
    } catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return obj;
}

/// hԂF̐ݒ
VALUE FillScreenGear_set_color ( VALUE self, VALUE colorobj )
{
    using namespace BK;
    
    try {
        Ruby::ArgScanner scanner("FillScreenGear#color=", 1, &colorobj);
        
        AlphaColor color = scanner.fetch_AlphaColor("hԂF");
        
        scanner.finish();
        
        FillScreenGear * const ptr = FillScreenGear::value_to_data( self );
        
        ptr->set_fill_color( color );
        
    } catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return colorobj;
}

/// x[XC[̐ݒ
VALUE FillScreenGear_set_base_layer ( VALUE self, VALUE nameobj )
{
    using namespace BK;
    FillScreenGear * const ptr = FillScreenGear::value_to_data( self );
    const char * const name = StringValuePtr( nameobj );
    
    try {
        ptr->set_base_layer( name );
    } catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return nameobj;
}

} /* extern "C" */
} /* namespace */
//////////////////////////////////////////////////////////////////////
////  BK::FillScreenGear
//

VALUE BK::FillScreenGear::ruby_class_object = Qnil;

BK::FillScreenGear::FillScreenGear ( void )
        : str_layername   (strformat("/FillScreenGear:%08u", get_serial_number())),
          ptr_layerary    (NULL),
          ptr_layer       (NULL),
          ptr_projection  (NULL)
{
    GraphicDevice * const gdev = GraphicDevice::get_instance();
    
    if( gdev == NULL ) {
        throw new logic_exception("OtBbNfoCX݂܂.");
    }
    
    ptr_layerary = gdev->get_layer_array();
    
    if( ptr_layerary == NULL ) {
        throw new logic_exception("OtBbNfoCXɃC[ACݒ肳Ă܂.");
    }
    
    this->ptr_layer = BK::create_FillLayer();
    if( this->ptr_layer == NULL ) {
        throw new runtime_exception("XN[hׂMAŃC[Ɏs.");
    }
    
    this->ptr_projection = ptr_layer->register_projection();
    if( this->ptr_projection == NULL ) {
        delete this->ptr_layer;
        throw new runtime_exception("XN[hׂMAœ]̈搶Ɏs.");
    }
    
    const AlphaColor initcolor ( 0, 0, 0 );
    const Rect2 screenrect ( gdev->get_screen_size() );
    
    this->ptr_projection->set_destination( screenrect );
    this->ptr_projection->set_color( &initcolor );
    
    this->ptr_layerary->insert_at( this->ptr_layerary->size(), this->str_layername.c_str(), this->ptr_layer );
}

BK::FillScreenGear::~FillScreenGear ()
{
    if( !this->is_ruby_wrapped() ) {
        // Ruby IuWFNgƂČJĂȂ̂ō폜
        delete this->ptr_projection;
        delete this->ptr_layer;
    }
}

VALUE BK::FillScreenGear::get_ruby_class ( void )
{
    if( !NIL_P(ruby_class_object) ) {
        return ruby_class_object;
    }
    VALUE c;
    
    c = ruby_class_object = define_ruby_bk_class( "FillScreenGear", BK::TimerGear::get_ruby_class() );
    
    xrb_define_narg_singleton_method( c, "new", FillScreenGear_new );
    
    xrb_define_narg_method( c, "initialize", FillScreenGear_initialize );
    xrb_define_0arg_method( c, "color", FillScreenGear_get_color );
    xrb_define_1arg_method( c, "color=", FillScreenGear_set_color );
    xrb_define_1arg_method( c, "base_layer=", FillScreenGear_set_base_layer );
    
    return ruby_class_object;
}

void BK::FillScreenGear::ruby_gc_mark ( void )
{
    parent_t::ruby_gc_mark();
    this->ptr_layer->gc_mark_self();
    this->ptr_projection->gc_mark_self();
}

void BK::FillScreenGear::on_ruby_wrap ( void )
{
    parent_t::on_ruby_wrap();
    this->ptr_layer->ruby_wrap();
    this->ptr_projection->ruby_wrap();
}

void BK::FillScreenGear::on_activate ( BK::OnOffObject::stat_t status )
{
    switch( status ) {
    case STAT_ACTIVE:
        this->ptr_projection->activate();
        break;
        
    case STAT_INACTIVE:
        this->ptr_projection->deactivate();
        break;
        
    case STAT_TERMINATED:
        this->ptr_projection->terminate();
        this->ptr_layerary->erase_name( this->str_layername.c_str() );
        break;
    }
}

BK::AlphaColor BK::FillScreenGear::get_fill_color ( void ) const
{
    const AlphaColor * const color = this->ptr_projection->get_color();
    
    if( color == NULL ) {
        throw new logic_exception("XN[hԂMA̓hԂFݒł.");
    }
    
    return *color;
}

void BK::FillScreenGear::set_fill_color ( const BK::AlphaColor & color )
{
    this->ptr_projection->set_color( &color );
}

void BK::FillScreenGear::set_base_layer ( const char * name )
{
    GraphicDevice * const gdev = GraphicDevice::get_instance();
    
    if( gdev == NULL ) {
        throw new logic_exception("OtBbNfoCX݂܂.");
    }
    
    LayerArray * const layerary = gdev->get_layer_array();
    const char * const layername = this->str_layername.c_str();
    unsigned int index;
    
    layerary->erase_name( layername );
    
    if( name == NULL ) {
        index = 0;
    } else {
        if( !layerary->find_name( name, &index ) ) {
            throw new argument_exception("x[XC[ '%s' ܂.", name);
        }
        index += 1; // uvɃC[zu邽
    }
    layerary->insert_at( index, layername, this->ptr_layer );
}

//////////////////////////////////////////////////////////////////////
////  Init ֐
//

void BK::Init_application_gear_FillScreenGear ( void )
{
    BK::FillScreenGear::get_ruby_class();
    
    Init_application_gear_FadeInGear();
    Init_application_gear_FadeOutGear();
}

//////////////////////////////////////////////////////////////////////
////  Exit ֐
//

void BK::Exit_application_gear_FillScreenGear ( void )
{
    Exit_application_gear_FadeOutGear();
    Exit_application_gear_FadeInGear();
}

//////////////////////////////////////////////////////////////////////
