#include "stdafx.h"
#include "schema/main.h"

//////////////////////////////////////////////////////////////////////
////  Ruby IuWFNg: BK::ManualGear
//
namespace {
extern "C" {

/// VMAIuWFNg𐶐
VALUE ManualGear_new ( VALUE klass )
{
    using namespace BK;
    VALUE volatile obj = Qnil;
    ManualGear * ptr;
    
    try {
        ptr = new ManualGear();
        if( ptr == NULL ) {
            throw_no_memory_for_object("ManualGear");
        }
        obj = ptr->ruby_wrap();
    }
    catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    rb_obj_call_init( obj, 0, NULL );
    
    try {
        ApplicationDevice::global_add_gear( *ptr );
        if( log_is_trace() ) {
            log_trace("}jAMA <%s:%p> 𐶐܂.", typeid(*ptr).name(), ptr);
        }
    }
    catch ( exception_base * e ) {
        ruby_throw( e );
    }
    
    return obj;
}

/// MȀ
VALUE ManualGear_initialize ( VALUE self )
{
    return self;
}

} /* extern "C" */
} /* namespace */
//////////////////////////////////////////////////////////////////////
////  BK::ManualGear
//

VALUE BK::ManualGear::ruby_class_object = Qnil;

VALUE BK::ManualGear::get_ruby_class ( void )
{
    if( !NIL_P(ruby_class_object) ) {
        return ruby_class_object;
    }
    VALUE c;
    
    c = ruby_class_object = define_ruby_bk_class( "ManualGear", parent_t::get_ruby_class() );
    
    xrb_define_0arg_singleton_method( c, "new", ManualGear_new );
    
    xrb_define_0arg_method( c, "initialize", ManualGear_initialize );
    
    return ruby_class_object;
}

BK::ManualGear::ManualGear ( void )
{
}

BK::ManualGear::~ManualGear ( void )
{
}

void BK::ManualGear::execute ( void )
{
}

//////////////////////////////////////////////////////////////////////
////  Init ֐
//

void BK::Init_application_gear_ManualGear ( void )
{
    ManualGear::get_ruby_class();
}

//////////////////////////////////////////////////////////////////////
////  Exit ֐
//

void BK::Exit_application_gear_ManualGear ( void )
{
}

//////////////////////////////////////////////////////////////////////
