#include "stdafx.h"
#include "schema/main.h"

//////////////////////////////////////////////////////////////////////
////  BK::ServiceDevice
//

BK::ServiceDevice::ServiceDevice ( void )
        : bool_started (false)
{
}

BK::ServiceDevice::~ServiceDevice ()
{
}

void BK::ServiceDevice::ruby_gc_mark ( void )
{
}

bool BK::ServiceDevice::is_started ( void ) const
{
    return bool_started;
}

void BK::ServiceDevice::start ( void )
{
    if( is_started() ) {
        log_warn("N%s start() s܂.", this->get_device_name());
        return;
    }
    this->bool_started = true; // OɒuĂȂ _start()  is_start() s
    this->_start();
    if( log_is_info() ) {
        log_info("%sJn܂.", this->get_device_name());
    }
}

void BK::ServiceDevice::stop ( void )
{
    if( !is_started() ) {
        log_warn("~%s stop() s܂.", this->get_device_name());
        return;
    }
    if( log_is_info() ) {
        log_info("%s~܂.", this->get_device_name());
    }
    this->_stop();
    this->bool_started = false; // ɒuĂȂƃOT[rX̒~bZ[WoȂ
}

//////////////////////////////////////////////////////////////////////
////  Init ֐
//

void BK::Init_utility_ServiceDevice ( void )
{
}

//////////////////////////////////////////////////////////////////////
////  Exit ֐
//

void BK::Exit_utility_ServiceDevice ( void )
{
}

//////////////////////////////////////////////////////////////////////
