#include "stdafx.h"
#include "schema/main.h"
#include <algorithm>

//////////////////////////////////////////////////////////////////////
////  Ruby NX: BK::Size2
//
namespace {
extern "C" {

/// Size2  (QƔ)
void Size2_ref_free ( BK::Size2 * ptr )
{
}

/// Size2 
void Size2_free ( BK::Size2 * ptr )
{
    delete ptr;
}

/// 擾
VALUE Size2_get_width ( VALUE self )
{
    BK::Size2 * size = BK::Size2::value_to_data( self );
    
    return rb_fix_new( size->get_width() );
}

/// c擾
VALUE Size2_get_height ( VALUE self )
{
    BK::Size2 * size = BK::Size2::value_to_data( self );
    
    return rb_fix_new( size->get_height() );
}

/// IuWFNg𐶐
VALUE Size2_new ( int argc, VALUE * argv, VALUE klass )
{
    using namespace BK;
    VALUE volatile objvalue;
    Size2 * obj;
    
    try {
        Ruby::ArgScanner scanner("Size2.new", argc, argv);
        
        obj = new Size2 ();
        *obj = scanner.fetch_Size2();
        scanner.finish();
    } catch ( exception_base * e ) {
        ruby_throw(e);
    }
    
    // Size2  RubyObject pĂȂ̂ ruby_wrap() gȂ
    objvalue = Data_Wrap_Struct( BK::Size2::get_ruby_class(), NULL, Size2_free, obj );
    
    rb_obj_call_init( objvalue, argc, argv );
    
    return objvalue;
}

/// 
VALUE Size2_initialize ( int argc, VALUE * argv, VALUE self )
{
    return self;
}

/// IuWFNgRs[
VALUE Size2_initialize_copy ( VALUE self, VALUE obj )
{
    if( !BK::Size2::is_kind_of(obj) ) {
        rb_raise(rb_eArgError, "%s  Size2 ɃRs[ł܂.", rb_obj_classname(obj));
    }
    const BK::Size2 * const src = BK::Size2::value_to_data( obj );
    
    if( !BK::Size2::is_kind_of(self) ) {
        rb_raise(rb_eTypeError, "%s  Size2.initialize_copy Kp܂.", rb_obj_classname(self));
    }
    xrb_update_Data( self, NULL, Size2_free, new BK::Size2( *src ) );
    
    return self;
}

/// ̐ݒ
VALUE Size2_set_width ( VALUE self, VALUE numobj )
{
    rb_check_frozen( self );
    
    BK::Size2 * size = BK::Size2::value_to_data( self );
    
    size->set_width( NUM2INT(numobj) );
    
    return numobj;
}

/// ̐ݒ
VALUE Size2_set_height ( VALUE self, VALUE numobj )
{
    rb_check_frozen( self );
    
    BK::Size2 * size = BK::Size2::value_to_data( self );
    
    size->set_height( NUM2INT(numobj) );
    
    return numobj;
}

/// ւ̕ϊ
VALUE Size2_to_s ( VALUE self )
{
    BK::Size2 * size = BK::Size2::value_to_data( self );
    char buf [32];
    int len;
    
    len = size->get_string( buf, 32 );
    
    return rb_str_new(buf, len);
}

/// IuWFNg̔r
VALUE Size2_p_eql ( VALUE self, VALUE obj )
{
    BK::Size2 * size = BK::Size2::value_to_data( self );
    
    if( !BK::Size2::is_kind_of(obj) ) {
        return Qfalse;
    }
    BK::Size2 * rhs = BK::Size2::value_to_data( obj );
    
    return (*size == *rhs) ? Qtrue : Qfalse;
}

/// IuWFNg̃nbVl擾
VALUE Size2_get_hash ( VALUE self )
{
    BK::Size2 * size = BK::Size2::value_to_data( self );
    
    return rb_fix_new( (size->get_width()) ^ (size->get_height() << 16) );
}

} /* extern "C" */
} /* namespace */
//////////////////////////////////////////////////////////////////////
////  BK::Size2
//

VALUE BK::Size2::ruby_class_object = Qnil;

VALUE BK::Size2::get_ruby_class ( void )
{
    if( !NIL_P(ruby_class_object) ) {
        return ruby_class_object;
    }
    VALUE c;
    
    c = ruby_class_object = define_ruby_bk_class( "Size2", rb_cData );
    
    xrb_define_narg_singleton_method( c, "new", Size2_new );
    
    xrb_define_narg_method( c, "initialize", Size2_initialize );
    xrb_define_1arg_method( c, "initialize_copy", Size2_initialize_copy );
    xrb_define_0arg_method( c, "width", Size2_get_width );
    xrb_define_0arg_method( c, "height", Size2_get_height );
    xrb_define_1arg_method( c, "width=", Size2_set_width );
    xrb_define_1arg_method( c, "height=", Size2_set_height );
    xrb_define_0arg_method( c, "to_s", Size2_to_s );
    xrb_define_1arg_method( c, "==", Size2_p_eql );
    xrb_define_1arg_method( c, "eql?", Size2_p_eql );
    xrb_define_0arg_method( c, "hash", Size2_get_hash );
    
    xrb_define_narg_global_function( "Size2", Size2_new );
    
    return ruby_class_object;
}

std::string BK::Size2::to_string ( void ) const
{
    char buf [32];
    
    get_string( buf, 32 );
    
    return std::string( buf );
}

int BK::Size2::get_string ( char * buf, unsigned int cap ) const
{
    if( buf != NULL ) {
        return snprintf( buf, cap, "%dx%d", get_width(), get_height() );
    }
    return 0;
}

VALUE BK::Size2::create_ruby_reference ( void )
{
    return Data_Wrap_Struct( get_ruby_class(), NULL, Size2_ref_free, this );
}

VALUE BK::Size2::create_ruby_object ( void ) const
{
    Size2 * dupobj = new Size2( *this );
    return Data_Wrap_Struct( get_ruby_class(), NULL, Size2_free, dupobj );
}

//////////////////////////////////////////////////////////////////////
////  Init ֐
//

void BK::Init_utility_Size2 ( void )
{
    Size2::get_ruby_class();
}

//////////////////////////////////////////////////////////////////////
////  Exit ֐
//

void BK::Exit_utility_Size2 ( void )
{
}

//////////////////////////////////////////////////////////////////////
