#include "stdafx.h"
#include "schema/main.h"

//////////////////////////////////////////////////////////////////////
////  t@C[JȒ萔
//
namespace {


/// eLXgC[vfobt@̏TCY
const int INITIAL_ELEMENT_CAPACITY = 128;


} /* namespace */
//////////////////////////////////////////////////////////////////////
////  Ruby IuWFNg: BK::TextLayer::Element
//
namespace {
extern "C" {

} /* extern "C" */
} /* namespace */
//////////////////////////////////////////////////////////////////////
////  BK::TextLayer::Element
//

VALUE BK::TextLayer::Element::ruby_class_object = Qnil;

BK::TextLayer::Element::Element ( void )
{
}

BK::TextLayer::Element::~Element ()
{
}

VALUE BK::TextLayer::Element::get_ruby_class ( void )
{
    if( !NIL_P(ruby_class_object) ) {
        return ruby_class_object;
    }
    VALUE c;
    
    c = ruby_class_object = rb_define_class_under(
        BK::TextLayer::get_ruby_class(), "Element", BK::RubyObject::get_ruby_class() );
    
    return ruby_class_object;
}

//////////////////////////////////////////////////////////////////////
////  Ruby IuWFNg: BK::TextLayer
//
namespace {
extern "C" {

} /* extern "C" */
} /* namespace */
//////////////////////////////////////////////////////////////////////
////  BK::TextLayer
//
namespace {

using namespace BK;

class TextLayer_execute_t
{
private:
    
    /// LoXIuWFNg
    Canvas * ptr_canvas;
    
public:
    
    /// RXgN^
    TextLayer_execute_t ( GraphicDevice * dev )
    {
        ptr_canvas = dev->create_canvas();
    }
    
    /// fXgN^
    ~TextLayer_execute_t ()
    {
        delete ptr_canvas;
    }
    
    /// {
    void operator () ( TextLayer::Element & e )
    {
        e.execute( ptr_canvas );
    }
    
};

} /* namespace */

VALUE BK::TextLayer::ruby_class_object = Qnil;

BK::TextLayer::TextLayer ( void )
        : ary_element (INITIAL_ELEMENT_CAPACITY)
{
}

BK::TextLayer::~TextLayer ()
{
}

VALUE BK::TextLayer::get_ruby_class ( void )
{
    if( !NIL_P(ruby_class_object) ) {
        return ruby_class_object;
    }
    VALUE c;
    
    c = ruby_class_object = define_ruby_bk_class( "TextLayer", BK::Layer::get_ruby_class() );
    
    return ruby_class_object;
}

void BK::TextLayer::ruby_gc_mark ( void )
{
    ary_element.for_each( RubyObjectMarker() );
}

void BK::TextLayer::add_element ( Element & elem )
{
    if( ary_element.is_exist(elem) ) {
        throw new argument_exception(
            "eLXgC[ɏdvf (%s <%p>) o^܂.", typeid(elem).name(), &elem);
    }
    ary_element.add( elem );
}

void BK::TextLayer::execute ( BK::GraphicDevice * dev )
{
    TextLayer_execute_t funcobj ( dev );
    
    ary_element.for_each( funcobj );
}

//////////////////////////////////////////////////////////////////////
////  Ruby IuWFNg: BK::TextLabel
//
namespace {
extern "C" {

/// ]̃ANeBuԂ擾
VALUE TextLabel_is_active ( VALUE self )
{
    BK::TextLabel * const ptr = BK::TextLabel::value_to_data( self );
    
    return BK::OnOffObject_is_active( ptr );
}

/// ]ԂANeBu
VALUE TextLabel_activate ( VALUE self )
{
    BK::TextLabel * const ptr = BK::TextLabel::value_to_data( self );
    
    BK::OnOffObject_activate( ptr );
    
    return self;
}

/// ]ԂANeBu
VALUE TextLabel_deactivate ( VALUE self )
{
    BK::TextLabel * const ptr = BK::TextLabel::value_to_data( self );
    
    BK::OnOffObject_deactivate( ptr );
    
    return self;
}

/// ]ԃIuWFNg𖳌
VALUE TextLabel_terminate ( VALUE self )
{
    BK::TextLabel * const ptr = BK::TextLabel::value_to_data( self );
    
    BK::OnOffObject_terminate( ptr );
    
    return self;
}

} /* extern "C" */
} /* namespace */
//////////////////////////////////////////////////////////////////////
////  BK::TextLabel
//

VALUE BK::TextLabel::ruby_class_object = Qnil;

BK::TextLabel::TextLabel ( void )
{
}

BK::TextLabel::~TextLabel ()
{
}

VALUE BK::TextLabel::get_ruby_class ( void )
{
    if( !NIL_P(ruby_class_object) ) {
        return ruby_class_object;
    }
    VALUE c;
    
    c = ruby_class_object = define_ruby_bk_class( "TextLabel", BK::Layout::get_ruby_class() );
    
    xrb_define_0arg_method( c, "active?", TextLabel_is_active );
    xrb_define_0arg_method( c, "activate", TextLabel_activate );
    xrb_define_0arg_method( c, "deactivate", TextLabel_deactivate );
    xrb_define_0arg_method( c, "terminate", TextLabel_terminate );
    
    return ruby_class_object;
}

void BK::TextLabel::ruby_gc_mark ( void )
{
    std::for_each( ary_glyph.begin(), ary_glyph.end(), RubyObjectMarker() );
}

void BK::TextLabel::execute ( BK::GraphicDevice * dev )
{
}

bool BK::TextLabel::update ( void )
{
    LayoutUpdater obj;
    
    std::for_each( ary_glyph.begin(), ary_glyph.end(), obj );
    
    return obj.get_result();
}

//////////////////////////////////////////////////////////////////////
////  Init ֐
//

void BK::Init_graphic_layer_TextLayer ( void )
{
    BK::TextLabel::get_ruby_class();
    BK::TextLayer::get_ruby_class();
}

//////////////////////////////////////////////////////////////////////
////  Exit ֐
//

void BK::Exit_graphic_layer_TextLayer ( void )
{
}

//////////////////////////////////////////////////////////////////////
