#include "stdafx.h"
#include "schema/main.h"

//////////////////////////////////////////////////////////////////////
////  Init ֐
//

namespace {

VALUE global_mark_object = Qnil;

/// Ruby Kx[WRN^p}[N
/**
 * Ruby IuWFNgłȂ Ruby IuWFNgƂA
 *  C++ O[oIuWFNgɑΉ邽߂̍ŏIB
 *
 * ̃f[^}[N܂B
 *  - efoCX
 */
void Global_mark ( void * ptr )
{
    {
        BK::ServiceDevice * devs [16]; // 16 foCX񂾂H
        int count = 0;
        
        devs[count++] = BK::ApplicationDevice::get_instance();
        devs[count++] = BK::GraphicDevice::get_instance();
        devs[count++] = BK::InputDevice::get_instance();
        devs[count++] = BK::LogDevice::get_instance();
        
        for( int i = 0; i < count; ++i ) {
            devs[i]->ruby_gc_mark();
        }
    }
    {
        BK::SpriteDatabaseStack * ptr = BK::SpriteDatabaseStack::get_instance();
        ptr->ruby_gc_mark();
    }
    {
        BK::GlobalSpriteSet * ptr = BK::GlobalSpriteSet::get_instance();
        ptr->ruby_gc_mark();
    }
    {
        BK::GlobalSpriteField * ptr = BK::GlobalSpriteField::get_instance();
        ptr->ruby_gc_mark();
    }
    {
        BK::FontDatabase * ptr = BK::FontDatabase::get_instance();
        ptr->ruby_gc_mark();
    }
}

} /* namespace */

void BK::Init_schema ( void )
{
    rb_gc_register_address( &global_mark_object );
    global_mark_object = Data_Wrap_Struct( rb_cData, Global_mark, NULL, NULL );
    
    Init_log(); // LogDevice ʊi
    Init_ruby();
    
    Init_utility();
    
    Init_application();
    
    Init_graphic();
    
    Init_input();
}

//////////////////////////////////////////////////////////////////////
////  Exit ֐
//

void BK::Exit_schema ( void )
{
    if( is_rubysys_running() ) {
        rb_gc_unregister_address( &global_mark_object );
    }
    
    Exit_input();
    Exit_graphic();
    Exit_application();
    Exit_utility();
    Exit_ruby();
    Exit_log();
}

//////////////////////////////////////////////////////////////////////
