# p[^̐ݒ
$stderr = $stdout = File.open("./stdout.log", "w")

$Config['LogDevice.InitialLevel'] = BK::LogDevice::TRACE
$Config['ApplicationDevice.InitialCaption'] = 'bZ[W - eXg'

# foCX̋N
BK::LogDevice.start()
BK::ApplicationDevice.start()
BK::GraphicDevice.start()
BK::InputDevice.start()

#font = BK::Font.new('lr oSVbN', 32)
font = BK::Font.new('lr SVbN', 32)
#font = BK::Font.new('Buttmunch', 32)

# ̓foCX̎擾

mouse = nil
begin
  input = BK::InputDevice.new()
  devices = input.devices
  p devices
  devices.each_with_index do |pair, n|
    type, name = pair
    if type == BK::AbstractInput::MOUSE then
      mouse = input.acquire( n )
    end
  end
  if mouse then
    print <<END_OF_TEXT
foCX: #{mouse.name} (^Cv: #{mouse.type})
{^: #{mouse.size}
END_OF_TEXT
  end
end

# C[

layers = BK::GraphicDevice.new().layer
layers.names = [ "background", "window", "text" ]
mergin = 32
window_rect = Rect2( 0 + mergin, 240 + mergin, 640 - mergin, 480 - mergin )

picture = BK::Picture.open("./img640x480.png")
layer = BK::PictureLayer.new(picture)
layers["background"] = layer

layer = BK::FillLayer.new()
proj = layer.register
proj.dest = window_rect
proj.color = '#000000@A0'
layers["window"] = layer

glyphs = font.fetch(<<END_OF_DATA)
BlackKit ̓IuWFNgwXNvg Ruby g DirectX CułBRuby ̗֐CuڎwĂ܂B
END_OF_DATA
#BlackKit is a DirectX library used OOP script language Ruby. This library expects to be convinient as Ruby.

image = BK::Image.new(window_rect.size)
image.acquire do |canvas|
  canvas.fill("#000000@00")
end
layer = BK::ImageLayer.new(image)
layers["text"] = textlayer = layer

# C

chrgear = BK::CharacterGear.new()
chrgear.id = 10
proj = BK::ProjectionInfo.new()
script = BK::LinearAlphaSetter.new()
script.range = 255..0
script.length = 120

gear = BK::FrameWaitGear.new
gear.wait_frame = 500

width = window_rect.width
x = 0
y = 0
glyphcolor = BK::AlphaColor.new("#FFFFFF@FF")
waitframe = 0

app = BK::ApplicationDevice.connect()
app.loop do
  if waitframe == 0 and !glyphs.empty? then
    glyph = glyphs.shift
    film = glyph.film
    size = glyph.size
    p [glyph.to_s, size, x]
    
    if x + size.width > width then
      x = 0
      y += size.height
    end
    
    #image.acquire() do |canvas|
    image.acquire(Point2(x - glyph.front_offset, y), size) do |canvas|
      #canvas.draw_film(x, y, glyphcolor, film)
      canvas.blit_film(0, 0, glyphcolor, film)
    end
    
    c = chrgear.generate
    c.layer = textlayer
    c.add_script( script )
    proj.src = Point2(x, y), size
    proj.dest = Point2(window_rect.left + x, window_rect.top + y), size
    c.projection = proj
    
    x += size.width - glyph.back_offset
    
    waitframe = 10
  else
    waitframe -= 1
  end
  
  mouse.update
  if mouse[0] > 0 then
    gear.deactivate
  end
  
  gear.active?
end

log_write("C[vI.")

