$stdout = open("stdout.log", "w")

require "bk_win32"

xml_source = <<END_OF_XML
<?xml version="1.0" encoding="Shift_JIS"?>
<sprite name="×" at="0,0" size="320x240" src="shiz.png">
 <sprite name="ʏ" at="0,0" size="320x48">
   <sprite at="0,0" size="32x48" center="16,48" />
   <sprite at="32,0" size="32x48" center="16,48" />
   <sprite at="64,0" size="32x48" center="16,48" />
   pre-string
   <sequence name="ʏ">
     <ref>0</ref>
     <ref>1</ref>
     <ref>2</ref>
     <terminate />
   </sequence>
   post-string
 </sprite>
 
 <sprite name="" x="0" y="48" width="320" height="48">
 </sprite>
 
 <sprite name="w" x="0" y="96" width="320" height="48">
 </sprite>
</sprite>
END_OF_XML

def foo ( level, node )
  print(' ' * level)
  if node.node? then
    print(sprintf("<%s>\n", node.name))
    for child in node do
      foo( level + 1, child )
    end
  else
    print(sprintf("[Text Node] #{node.text}\n"))
  end
end

root = XML.new( xml_source )
foo( 0, root );

